GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

GLOBAL.PUELLA_MOD_SETTINGS = 
{
    CHARGEKEY = GetModConfigData("chargekey"),--变身键位
    SKILLKEY = GetModConfigData("skillkey"), --技能键
    CLICKABLE = true,
    MUSIC = true,
}
PUELLA_MOD_SETTINGS = GLOBAL.PUELLA_MOD_SETTINGS

local function IsChi()
    if not softresolvefilepath('scripts/languages/loc.lua') then
        return
    end
    local loc = require "languages/loc"
    local syslang = loc and loc.GetLanguage and loc.GetLanguage()
    if syslang and (syslang == LANGUAGE.CHINESE_T or syslang == LANGUAGE.CHINESE_S or syslang == LANGUAGE.CHINESE_S_RAIL)then
        return true
    end
end

local function IsChiModEnabled()
    for name, data in pairs(KnownModIndex.savedata.known_mods) do
        if data.enabled and data.modinfo and data.modinfo.restart_required then
            local name = string.upper(data.modinfo.name or '')
            if name:find("CHINESE") or name:find("汉化") or name:find("L.M.U") then
                return true
            end
        end
    end
end

local function IsAutoChi()
    return IsChi() or IsChiModEnabled()
end
PUELLA_MOD_SETTINGS.LANGUAGE = ((GetModConfigData('language') == "AUTO") and not IsAutoChi()) or (GetModConfigData('language') == 'ENG')

local L = PUELLA_MOD_SETTINGS.LANGUAGE 
print('pmmm-language: '..tostring(L))

modimport "modmain/puella_fn.lua" 
modimport "modmain/strings.lua"
modimport "modmain/API.lua" 
modimport "modmain/actionsandstates.lua"
modimport "modmain/ui.lua"
modimport "modmain/geometry.lua"
modimport "modmain/help.lua"
modimport "modmain/livingartifactAPI.lua"
modimport "modmain/homura_loot.lua"
modimport "modmain/listenerAPI.lua"
modimport "modmain/detonatorcrafting.lua" --雷管的可选配方
modimport "modmain/timeutil.lua"
modimport "modmain/timeAPI.lua"
--modimport "modmain/language.lua"
--modimport "modmain/entityAPI.lua"

--modimport "modmain/debugfunctions.lua"

PrefabFiles = {
    "kyouko",
    "kyouko_spear", 
    "kyouko_clo", --整合
    "kyouko_shield",

    "sayaka",
    "sayaka_heal",
    "sayaka_sword",

    "homura_1",
    "homura_magic",
    "homura_rpg",
    'homura_workdesk',
    'pmmm_mod_blueprint',
    'homura_bombs','homura_pistol','homura_weapon_buffs','homura_deto',

    "witch_pos",
    "griefseed",
    "eegg",
    "magicalgirl_fxs","soulgem_revive_fx","griefseed_fx",
    "witch_qw","witch_qw_sm","qw_projectile","qw_spawner","witch_qw_fx",
    "witch_tv","witch_tv_balls",
    "witch_sd","witch_sd_sm",'witch_sd_fx',

    "witch_fxs2",

    "beachresurrector_magic",

    'lw_dstanim',

    'pistol_soulknight',

}

Assets =
{
    Asset("ANIM", "anim/cd_fan.zip"),
    Asset("ANIM", "anim/cdflash.zip"),

    Asset("ANIM", "anim/ringmeter_pmmm.zip"), --环形进度条
    Asset("ANIM", "anim/recharge_meter_pmmm.zip"), --物品栏冷却
    Asset("ANIM", "anim/lavaarena_player_teleport_pmmm.zip"), --玩家传送进场的黑色火焰
    Asset("ANIM", "anim/lavaarena_hit_sparks_fx_pmmm.zip"), --单个火花

    Asset("ANIM", "anim/sayaka_icon.zip"),
    Asset("ANIM", "anim/homura_icon.zip"),
    Asset("ANIM", "anim/kyouko_icon.zip"),
    
    Asset("ATLAS","images/inventoryimages/kyouko_spear.xml"), 
    Asset("ATLAS","images/inventoryimages/kyouko_clo.xml"), 

    Asset("ATLAS", "images/hud/homura_tab.xml" ), --小焰专属武器栏

    Asset("ATLAS", "images/status.xml"),

    Asset("IMAGE", "images/colour_cubes/homura_cc.tex"),

    Asset("ANIM", "anim/puellaUI_flash.zip"),
    Asset("ANIM", "anim/puellaUI_soulgem_glow.zip"),
    Asset("ANIM", "anim/puellaUI_sgdark.zip"),
    Asset("ANIM", "anim/puellaUI_sgdark_build.zip"),
    Asset("ANIM", "anim/puellaUI_homurafocus.zip"),

    Asset("ANIM", "anim/homura_buff_base.zip"),

    Asset("SOUNDPACKAGE", "sound/lw_witch.fev"),
    Asset("SOUND", "sound/lw_witch.fsb"),

    Asset("SOUNDPACKAGE", "sound/lw_bgm.fev"),
    Asset("SOUND", "sound/lw_bgm.fsb"),
}

local charnames = {"kyouko","sayaka","homura_1"}

local function GetBeforeLine(str) --晓美焰使用同一套ui
    local i = string.find(str,'_',1,true)
    if i then
        return str:sub(1,i-1)
    else
        return str
    end
end
for _,name in pairs(charnames) do
    table.insert(Assets,Asset( "ATLAS", "images/saveslot_portraits/"..name..".xml" ))
    table.insert(Assets,Asset( "ATLAS", "images/selectscreen_portraits/"..name..".xml" ))
    table.insert(Assets,Asset( "ATLAS", "bigportraits/"..name..".xml" ))
    table.insert(Assets,Asset( "ATLAS", "images/map_icons/"..name..".xml"))
    
    table.insert(Assets,Asset( "ANIM", "anim/"..name.."_c.zip"))
    table.insert(Assets,Asset( "ANIM", "anim/"..name..".zip"))
    table.insert(Assets,Asset( "ANIM", "anim/"..GetBeforeLine(name).."_sg_1.zip"))
    table.insert(Assets,Asset( "ANIM", "anim/"..GetBeforeLine(name).."_sg_2.zip"))
    table.insert(CHARACTER_GENDERS.FEMALE, name)

    local speech_wilson = L and require "speech_wilson" or require "speech_kyouko_ch"
    STRINGS.CHARACTERS[string.upper(name)] = deepcopy(speech_wilson)
    
    AddMinimapAtlas("images/map_icons/"..name ..".xml")
    AddModCharacter(name)
end

--感谢bowcar同学提供的台词文件
if not L then
    STRINGS.CHARACTERS.HOMURA_1 = require "speech_homura_ch"
end

local chardata_eng = {
    {
        prefab = "kyouko",
        T = "Lancer",
        N = "Kyouko Sakura",
        D = "*Can use magical chains to absorb damage.\n*Is a food aficionado.\n",
        Q = "\"Magic is only supposed to be used for myself.\"",
    },
    {
        prefab = "sayaka",
        T = "Companion of justice",
        N = "Sayaka Miki",
        D = "*Does well in healing.\n*Is agile when combating.",
        Q = "\"Miracles and magic do exist!\"",
    },
    {
        prefab = "homura_1",
        T = "Mysterious transfer student",
        N = "Homura Akemi",
        D = "*Masters making munitions.\n*Can control time.", 
        Q = "\"No one believe the future, no one accept the truth about future...\"",
    },
}

local chardata_chi = {
    {
        prefab = "kyouko",
        T = "枪兵",
        N = "佐仓杏子",
        D = "*会释放“心锁”吸收伤害。\n*典型的吃货。",
        Q = "\"魔法，是只能为自己而使用的东西。\"",
    },
    {
        prefab = "sayaka",
        T = "正义的伙伴",
        N = "美树沙耶加",
        D = "*具备强大的治疗魔法。\n*战斗时非常敏捷。",
        Q = "\"奇迹和魔法都是存在的！\"",
    },
    {
        prefab = "homura_1",
        T = "神秘的转校生",
        N = "晓美焰",
        D = "*军火女王\n*会使用魔法控制时间。",
        Q = "\"谁都，不会相信未来，谁都，无法接受未来，\n那样的话，我就...\"",
    },
}

local function SetCharData(data)
    STRINGS.CHARACTER_TITLES[data.prefab] = data.T
    STRINGS.CHARACTER_NAMES[data.prefab] = data.N
    STRINGS.CHARACTER_DESCRIPTIONS[data.prefab] = data.D
    STRINGS.CHARACTER_QUOTES[data.prefab] = data.Q
end

local chardata = L and chardata_eng or chardata_chi
for _, data in pairs(chardata)do
    SetCharData(data)
end

local MAXWELL = L and 
{"Seems you're taking a mysterious gem with you.","It is full of magical power.",
"I don't know how you got that","But I'm sure you have no access to escaping!",}or  
{"看上去你带着个神秘的魔法石","这颗宝石蕴含着非常强大的能量",
"连我也不知道它的由来...","不过尽管如此，你依旧逃不出我的掌心",}

local function ModMaxwellIntro(inst) --专属开场对白（后续会更改）
    if GetPlayer():HasTag("puellamagi") then
        inst.components.maxwelltalker.speeches.SANDBOX_1 =
        {
            appearsound = "dontstarve/maxwell/disappear",
            voice = "dontstarve/maxwell/talk_LP",
            appearanim = "appear",
            idleanim= "idle",
            dialogpreanim = "dialog_pre",
            dialoganim="dial_loop",
            dialogpostanim = "dialog_pst",
            disappearanim = "disappear",
            disableplayer = true,
            skippable = false,
            {string = MAXWELL[1],wait = 4,anim = nil,sound = nil,},
            {string = MAXWELL[2],wait = 4,anim = nil,sound = nil,},
            {string = MAXWELL[3],wait = 4,anim = nil,sound = nil,},
            {string = MAXWELL[4],wait = 4,anim = nil,sound = nil,},
        }
    end
end
--AddPrefabPostInit("maxwellintro", ModMaxwellIntro)

--[[
local old_GetActiveCharacterListForSelection = GetActiveCharacterListForSelection
function GLOBAL.GetActiveCharacterListForSelection(...)
    local list = old_GetActiveCharacterListForSelection(...)
    local newlist = {'kyouko','sayaka'}

    if table.contains(list,'homura_1') then
        table.insert(newlist,'homura_1')
    end
    for _,v in pairs(list)do
        if not table.contains(newlist,v) then
            table.insert(newlist,v)
        end
    end

    return newlist
end

local function SelectKyouko(self)
    --self:SelectCharacter('kyouko')
end

AddClassPostConstruct("screens/characterselectscreen", SelectKyouko)
--]]
--

local function BTPostInit(self)
    local old_update = self.Update
    function self:Update(...)
        if self.inst:HasTag('homuraTag_pause') then
            return
        else
            return old_update(self, ...)
        end
    end
end
AddGlobalClassPostConstruct('behaviourtree', 'BT', BTPostInit)

local function SGPostInit(self)
    local old_update = self.Update
    function self:Update(...)
        local sleep_time = old_update(self, ...)
        if not sleep_time then
            self.lw_nextupdatetick = nil
        else
            local sleep_ticks = sleep_time/GetTickTime()
            sleep_ticks = sleep_ticks == 0 and 1 or sleep_ticks
            self.lw_nextupdatetick = math.floor(sleep_ticks + GetTick())+1
        end

        return sleep_time
    end

    function self:AddTick(dt)
        dt = dt or GetTickTime()
        self.statestarttime = self.statestarttime + dt
        if self.lw_nextupdatetick then
            local list1 = SGManager.tickwaiters[self.lw_nextupdatetick]
            if not list1 then return end
            self.lw_nextupdatetick = self.lw_nextupdatetick + 1
            if not SGManager.tickwaiters[self.lw_nextupdatetick]then
                SGManager.tickwaiters[self.lw_nextupdatetick] = {}
            end
            local list2 = SGManager.tickwaiters[self.lw_nextupdatetick]
            list1[self] = nil
            list2[self] = true
        end
    end

    self.lw_sgmemorydata = {params = {}}

    local old_gotostate = self.GoToState
    function self:GoToState(newstate, p, ...)
        local state = self.sg.states[newstate]
        --local arg = {...}       
        if not state then 
            return old_gotostate(self, newstate, p, ...)
        end

        if not self.inst:HasTag('homuraTag_pause') then
            self.lw_nextupdatetick = nil
            return old_gotostate(self, newstate, p, ...) 
        else
            self.lw_nextupdatetick = nil

            local oldstate = self.currentstate or {}

            self.lw_sgmemorydata.onexit = oldstate.onexit
            self.lw_sgmemorydata.onenter = state.onenter
            --self.lw_sgmemorydata.onupdate = state.onupdate
            self.lw_sgmemorydata.params = {p, ...}
            self.lw_sgmemorydata.statemem = self.statemem
            oldstate.onexit = function() return end
            state.onenter = function() return end
            --state.onupdate = function() return end

            old_gotostate(self, newstate, p, ...)
            
            oldstate.onexit = self.lw_sgmemorydata.onexit
            state.onenter = self.lw_sgmemorydata.onenter
        end
    end

    function self:Lw_TimeMagic_OnStop()
        local statemem = self.statemem --理论上这个值应该是nil
        self.statemem = self.lw_sgmemorydata.statemem
        if self.lw_sgmemorydata.onexit then
            self.lw_sgmemorydata.onexit(self.inst)
        end
        self.statemem = statemem
        if self.lw_sgmemorydata.onenter then
            self.lw_sgmemorydata.onenter(self.inst, unpack(self.lw_sgmemorydata.params))
        end

        self.lw_sgmemorydata = {params = {}}
    end    
end
AddGlobalClassPostConstruct('stategraph', 'StateGraphInstance', SGPostInit)

local function PeriodicPostInit(self)
    function self:AddTick()
        local thislist = scheduler.attime[self.nexttick]
        self.nexttick = self.nexttick + 1
        if not thislist then --在正常情况下是不会发生的
            return
        end
        if not scheduler.attime[self.nexttick] then
            scheduler.attime[self.nexttick] = {}
        end
        local nextlist = scheduler.attime[self.nexttick]
        thislist[self] = nil
        nextlist[self] = true
        self.list = nextlist
    end
end
AddGlobalClassPostConstruct('scheduler', 'Periodic', PeriodicPostInit)

local function EasyAddTag(self)
    local old_addtag = self.AddTag
    function self:AddTag(...)
        for _,v in ipairs({...})do
            old_addtag(self,v)
        end
    end
end
AddGlobalClassPostConstruct('entityscript','EntityScript',EasyAddTag)


--瞄准时不触发战斗bgm
local function DontPlayMusicOnFocus(self)
    local old_OnStartDanger = self.OnStartDanger
    function self:OnStartDanger()
        --self.inst:DoTaskInTime(0,function()
            local target = self.inst.components.combat.target
            local weapon = self.inst.components.combat:GetWeapon()
            if self.inst.sg:HasStateTag('homura_focus') then
                return
            end
            if target and weapon and weapon.components.homura_focus and weapon.components.homura_focus:ShouldFocus(target) then
                return
            end
            old_OnStartDanger(self) 
        --end)
    end
end
AddComponentPostInit('dynamicmusic',DontPlayMusicOnFocus)

--AddGamePostInit(function() require'entityAPI' end)

GLOBAL.AnimState.SetBankBuildAnim = function(animstate, bank, build, anim, loop)
    animstate:SetBank(bank)
    animstate:SetBuild(build)
    animstate:PlayAnimation(anim, loop)
end