local L = GLOBAL.PUELLA_MOD_SETTINGS.LANGUAGE

local function magicalheal(inst,max,min,period,consume,sayaka)
    local function heal(inst)
        local health = inst.components.health
        if health and health:IsHurt() and not health:IsDead() then
            health:DoDelta(inst.components.magicalcharge.state == 3 and max or min,false)
            local sgdelta = sayaka and consume * 0.7 or consume
            inst.components.soulgem:DoDelta(sgdelta,false)
        end 
    end
    inst:DoPeriodicTask(period,heal)
end

local function doresurrect_magic(inst,dude,spawn)--魔法复活
    inst:AddTag("busy") 
    --ProfileStatsSet("resurrectionstone_used", true)------
    TheFrontEnd:Fade(false, 2, nil, 0)
    dude.components.hunger:Pause()
    dude.components.playercontroller:Enable(false)
    dude.components.health:SetInvincible(true)
    if spawn then
        local pos = inst:GetPosition()
        local recipe = GetRecipe("lograft")
        for _, v in pairs(recipe.ingredients) do
            for i = 1, v.amount do
                local item = SpawnPrefab(v.type)
                local offset = FindWalkableOffset(pos, math.random()*6.283, math.random()*2+2, 8, true, false)
                if offset then
                    item.Transform:SetPosition((pos+offset):Get())
                else
                    item.Transform:SetPosition(pos:Get())
                end
            end
        end
    end
    dude:StartThread(function()
        Sleep(2)
        dude.Transform:SetPosition(inst.Transform:GetWorldPosition())
        dude.AnimState:PlayAnimation("sleep")
        dude.components.magicalcharge:unchargefn(true)
        TheCamera:SetDistance(12)
        GetClock():NextPhase()
        Sleep(2)
        TheFrontEnd:Fade(true, 2)
        
        
        if dude.components.sanity then
            dude.components.sanity:DoDelta(15,true)
        end

        if dude.components.moisture then
            if spawn then
                dude.components.moisture.moisture = dude.components.moisture.moistureclamp.max
            end
        end

        if dude.components.temperature then
            dude.components.temperature:SetTemperature(TUNING.STARTING_TEMP)
        end
        Sleep(4)
        local pos = dude:GetPosition()
        local fx = SpawnPrefab("soulgem_revive_fx")
        fx.Transform:SetPosition(pos:Get())
        fx.player = dude
        Sleep(5)
        if not dude.sg.sg.states.wakeup then
            dude.sg:GoToState("idle")
            Sleep(0)
        else
            dude.sg:GoToState("wakeup")
            Sleep(3)
        end
        dude.components.health:Respawn(30)
        dude.components.hunger:Resume()
        dude.brain:Start()
        if dude.HUD then
            dude.HUD:Show()
        end
        dude.components.playercontroller:Enable(true)
        TheCamera:SetDefault()
        inst:RemoveTag("busy")   
        return true
    end)
end

-----------
local function magicalresurrect(inst)--------和五格不冲突，其他模组未测试
   
inst.components.resurrectable.CanResurrect =  function(self,cause)

    self.resurrectionmethod = nil 
    if cause == "becomewitch" then
        STRINGS.UI.DEATHSCREEN.YOUAREDEAD = L and "You became a witch!" or "你变成了魔女！"  
        return false 
    end 

    if cause == "burnt" then 
        STRINGS.UI.DEATHSCREEN.YOUAREDEAD = L and "Your soul gem fell into lava!" or "灵核被熔毁。。"
        return false
    end

    if cause == "drowning" then
        if self.inst.components.leader ~= nil then
            for k,v in pairs(self.inst.components.leader.followers) do
                if k:HasTag("ballphin") and k:IsNear(self.inst, 32) then
                    if math.random() < TUNING.BALLPHIN_DROWN_RESCUE_CHANCE then 
                        self.resurrectionmethod = "ballphins"
                        return true
                    end
                end
            end
        end
        local item = self.inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.BODY)
        if item and item.prefab == "armor_lifejacket" then
            self.resurrectionmethod = "lifejacket"
            return true
        end
        if self.inst.components.soulgem:CanRevive() and cause ~= "sgdark" then
            self.resurrectionmethod = "magic_water"
            return true
        end
    end 
    if self.inst.components.soulgem:CanRevive() and cause ~= "sgdark" then
        self.resurrectionmethod = "magic"
        return true
    end
    self.resurrectionmethod = "fake revive" --防止死亡界面的推送
    return true
end

inst.components.resurrectable.FindClosestResurrector = function (self,cause)
    local res = nil
    local closest_dist = 0
    self.shouldwashuponbeach = false
    if cause == "drowning" then 
        self.shouldwashuponbeach = true 
        for k,v in pairs(Ents) do
            if v.prefab == "beachresurrector" and self.resurrectionmethod ~= "magic_water" or 
                v.prefab == "beachresurrector_magic" and self.resurrectionmethod == "magic_water" then
                local dist = v:GetDistanceSqToInst(self.inst)
                if not res or dist < closest_dist then
                    res = v
                    closest_dist = dist
                end
            end
        end
        if res then return res end
    end
    return self.inst --我救我自己
end

inst.components.resurrectable.DoResurrect = function(self,res,cause)
    self.inst:PushEvent("resurrect")
    if self.resurrectionmethod == "fake revive" then
        res.components.deadtimer:Die()
        if res.HUD then
            res.HUD.puellaUI_sgdark:StartBurstAfterDie()
        end
        return
    end

    if self.shouldwashuponbeach then
        if self.resurrectionmethod == "magic_water" then  
            self.inst.components.soulgem:DoRevive(self.inst.prefab == "sayaka" and 35 or 50,false)
            res:doresurrect(self.inst,true)
        else 
            res:doresurrect(self.inst)
        end
    elseif self.resurrectionmethod == "magic" then
        self.inst.components.soulgem:DoRevive(self.inst.prefab == "sayaka" and 35 or 50,false)
        res:doresurrect(self.inst,false)
    end
end
end

local function MakeMagicalGirl(inst, themecolour, kyouko, sayaka, homura, mami, madoka) --恭喜你发现主函数
    inst:AddTag("puellamagi")
    inst.soundsname = inst.soundsname or "wendy"
    if not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
        return
    end
    inst.AnimState:AddOverrideBuild("player_hit_darkness_pmmm")

    inst:AddComponent("witchspawner") 
	--治疗
	magicalheal(inst,10,7.5,30,1,sayaka)

	--变身
    inst.themecolour = themecolour
	inst:AddComponent("magicalcharge")

    --复活
    magicalresurrect(inst)
    inst:AddComponent("sayaka_healed")
	
	--灵核
	inst:AddComponent("soulgem")
	
    --黑化
    inst:AddComponent("deadtimer")

    --技能
    inst:AddComponent("puella_keytrigger")

    --无限复活
    inst.doresurrect = doresurrect_magic

    --bgm
    inst:AddComponent("witchbattlebgm")

    --动画辅助
    --inst:AddComponent('animstatemanager')
    --人物生成是先于API的,所以要延时一帧重设AnimState(组件内)

    --动画修正
    inst:ListenForEvent("death",function(inst,data)
        inst.AnimState:Hide("ARM_carry") 
        inst.AnimState:Show("ARM_normal")
    end)

end

local function MakeProjectile(prefab,bank,build,defaultanim,ground,speed,rad,assets,specialfn)
    ------------------------- prefab名，bank，build，anim名，贴地，速度，半径，资源，调整函数
local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank(bank)
    anim:SetBuild(build)
    anim:PlayAnimation(defaultanim,true)
    if ground then
        anim:SetOrientation(ANIM_ORIENTATION.OnGround)
    end
    
    inst:AddTag("projectile")
    inst.persists = false
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(speed or 30)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(rad or 1)
    inst.components.projectile:SetOnHitFn(function (inst)inst:Remove() end)
    inst.components.projectile:SetOnMissFn(function (inst)inst:Remove() end)
 
    if specialfn  then specialfn(inst) end
    return inst
end

    return Prefab( "common/projectile/"..prefab, fn, assets) 
end

local function Change(inst,com,from,to)
    if inst.components[com]then
        inst.components[com]["M_"..from]=inst.components[com]["M_"..from]or inst.components[com][from]
        inst.components[com][from]=to
    end
end

local function Restore(inst,com,from)
    if inst.components[com] and inst.components[com]["M_"..from] then
        inst.components[com][from]=inst.components[com]["M_"..from]
        inst.components[com]["M_"..from] = nil
    end
end


local function SetMagicalWeapon(inst,damage,ignore,can_use_without_magic)
    local function GetWeaponDamage(weapon)
        local target 
        if weapon.components.projectile then               --远程
            target = weapon.components.projectile.target
        --elseif weapon.components.inventoryitem.owner then  --近战
        --    target = weapon.components.inventoryitem.owner.components.combat.target
        else
            target = GetPlayer().components.combat.target
        end

        if target and target:HasTag("witch")then
            local absorb = target.components.health.absorb
            if absorb >= 1 then
                return damage
            end
            local weaken_absorb = math.max(absorb - ignore,0)
            return damage*(1-weaken_absorb)/(1-absorb)
        else
            return damage
        end
    end
    inst.components.weapon.getdamagefn = GetWeaponDamage
    inst:DoTaskInTime(0,function()if not GetPlayer():HasTag("puellamagi") then inst:Remove() end end)
    if not can_use_without_magic then
        inst:AddTag("needmagicalcharge")
    end
end

local function GetTrueDamage(inst,attacker,dmg,weapon,stimuli,donotpushevent)
    if not inst:IsValid() or not inst.components.health or not inst.components.combat then --保护
        return
    end
    if inst.components.health:IsInvincible() == false and not inst.components.health:IsDead() then
        inst.components.health:DoDelta(-dmg, nil, (attacker and attacker.prefab or "NIL"))
        if not donotpushevent then
            inst:PushEvent("attacked",{attacker = attacker, damage = 0 ,weapon = weapon }) --设成0是为了保护铥矿皇冠
        end
        if inst.components.health:GetPercent() <= 0 then
            if attacker then
                attacker:PushEvent("killed", {victim = inst})
            end
            if inst.components.combat.onkilledbyother then
                inst.components.combat.onkilledbyother(inst, attacker)
            end
        end
    end
end

local function SetSG(inst,sg,default)
    inst.sg = StateGraphInstance(sg, inst)
    SGManager:AddInstance(inst.sg)
    if default then
        inst.sg:GoToState(default)
    else
        inst.sg:GoToState(inst.sg.sg.defaultstate)
    end
end

local function InitializeEntity()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    return inst,trans,anim,snd
end

local function QuickSetAnim(inst,build,bank,anim,loop,ground,sortorder)
    inst.AnimState:SetBuild(build)
    inst.AnimState:SetBank(bank)
    inst.AnimState:PlayAnimation(anim,loop)
    if ground then
        inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
        inst.AnimState:SetLayer(LAYER_BACKGROUND)
        inst.AnimState:SetSortOrder(sortorder or 3)
    end
end

local function CalcDeltaAngle(angle1,angle2,abs)
    local delta = math.mod(angle2 - angle1,360)  --   -360~360
    delta = delta < 0 and delta+360 or delta     --    0 ~ 360
    if abs then
        return delta>180 and 360-delta or delta  --  0~180
    else
        return delta 
    end
end

local function WitchCommon(inst, timerstartfn)
    inst:AddComponent('timer')
    
    local function OnWitchSleep(inst)
        if inst:GetPosition():DistSq(GetPlayer():GetPosition()) > 60*60 then
            if not inst.components.timer:TimerExists('witch escape') then 
                if not timerstartfn or timerstartfn(inst) then
                    inst.components.timer:StartTimer('witch escape', 480)
                end
            end
        end
    end

    local function OnWitchAwake(inst)
        inst.components.timer:StopTimer('witch escape')
    end

    local function OnTimerDone(inst, data)
        if data and data.name == 'witch escape' then
            inst:Remove()
        end
    end

    inst:ListenForEvent("entitysleep", OnWitchSleep)
    inst:ListenForEvent("entitywake", OnWitchAwake)
    inst:ListenForEvent("timerdone", OnTimerDone)
end

local moditemlist = {}
local function AddModItem(...)
    for k,v in pairs({...})do
        if type(v) == type('') then
            moditemlist[v] = 1
        end
    end
end

local function IsModItem(v)
    return moditemlist[v]
end

local function GetModItem()
    return moditemlist
end

GLOBAL.PUELLA_MOD_FN = {

MakeMagicalGirl = MakeMagicalGirl,
MakeProjectile = MakeProjectile,
Change = Change,
Restore = Restore,
SetMagicalWeapon = SetMagicalWeapon,
GetTrueDamage = GetTrueDamage,
SetSG = SetSG,
DoMagicRevive = doresurrect_magic,
CreateEntity = InitializeEntity,
SetAnim = QuickSetAnim,
DeltaAngle = CalcDeltaAngle,
WitchCommon = WitchCommon,
--DoSetLanguage = DoSetLanguage,
AddModItem = AddModItem,
IsModItem = IsModItem,
GetModItem = GetModItem,
}


