
--------------------
------通用组件-------
----------------------------------------
local function NewComponent(inst)
    if not inst.components.ignoretimemagic and not inst.Map and not inst:HasTag('ground') then
        if (TheWorld and TheWorld.ismastersim) then
            inst:AddComponent('ignoretimemagic')
        end
    end
end

AddPrefabPostInitAny(NewComponent)

--------------------
-----阻止组件更新-----
----------------------------------------
--1.物体的更新
local skip_components = {
    'ignoretimemagic', --如果这个组件的更新也停止了的话, 可能会出现一些问题
    'highlight', --辅助性组件
    'inventoryitem',

    --世界组件
    'hunter',
    'whalehunter',
    'debugger',
}
local function CanHook(name)
    for _,v in pairs(skip_components)do
        if v == name then
            return false
        end
    end
    return true
end

local function ComponentPostInit(self)
    local old_add = self.AddComponent
    function self:AddComponent(name, ...)
        old_add(self, name, ...)
        if CanHook(name) and self.components[name].OnUpdate then 
            local cmp = self.components[name]
            local old_up = cmp.OnUpdate
            cmp.OnUpdate = function(self, ...)
                if self.inst and self.inst:HasTag('homuraTag_pause') then 
                    return
                else
                    old_up(self, ...)
                end
            end
        end
    end
end

AddGlobalClassPostConstruct('entityscript','EntityScript', ComponentPostInit)


--2.人物的更新
local stop_components = {
    'grue',
    'moisture',
    'keeponland',
    'sanitymonsterspawner',
}
local function CanHookPlayer(name)
    for _,v in pairs(stop_components)do
        if v == name then
            return true
        end
    end
end

local function HookUpdaterPlayer(inst)
    for k,v in pairs(inst.components)do
        if CanHookPlayer(k) and v.OnUpdate then
            local old_fn = v.OnUpdate
            v.OnUpdate = function(self,...)
                if self.inst.lw_timemagic_inrange then 
                    return
                else
                    old_fn(self,...)
                end
            end
        end
    end
end

AddPlayerPostInit(HookUpdaterPlayer)

--细节优化:时停状态下潮湿度不上升
local function PlayerGetMoisture(inst)
    local old_get = inst.GetMoistureRateScale
    if old_get then
        inst.GetMoistureRateScale = function(inst,...)
            if inst.lw_timemagic_inrange or inst._homura_timemagic_playerswitch:value() then
                return 0
            else
                return old_get(inst,...)
            end
        end
    end
end

AddPlayerPostInit(PlayerGetMoisture)

---------------------
---可交易怀表----------
-----------------------------
local cre = {'pigman','bunnyman'}

local function CanGiveClock(inst)
    if inst.components.trader then
        local old_test = inst.components.trader.test
        inst.components.trader.test = function(inst, item, ...)
            if item and item.prefab == 'homura_clock' then
                return true
            else
                return old_test(inst, item, ...)
            end
        end
    end
end

for _,v in pairs(cre)do
    AddPrefabPostInit(v, CanGiveClock)
end
