
local function AlwaysControlled(inst) 
    return inst:HasTag('homuraTag_precipitation')
end

function PUELLA_MOD_FN.tu_IsIgnoring(inst)
	if not (inst and inst:IsValid()) then 
		return true
	end
    if AlwaysControlled(inst) then
        return false
    end
    return
       inst:HasTag("INLIMBO")
    or inst:HasTag('homura') 
    or inst:HasTag('homuraTag_ignoretimemagic')
    or inst:HasTag('homuraTag_ignoretimemagic_temp')
    or inst.components.inventory and inst.components.inventory:Has('homura_clock',1)
    or inst.components.container and inst.components.container:Has('homura_clock',1)
    or inst:HasTag('FX') and inst.entity:GetParent() ~= nil and PUELLA_MOD_FN.tu_IsIgnoring(inst.entity:GetParent())
end

function PUELLA_MOD_FN.tu_Start(inst)
	if not inst and inst:IsValid() then 
		return 
	end 

	if inst.lw_timemagic_onstart then
        inst:lw_timemagic_onstart()
    end

    inst:AddTag('homuraTag_pause')

    if inst.components.combat then
        inst.components.combat.M_hurtsound = inst.components.combat.hurtsound
        inst.components.combat.hurtsound = nil
    end

    ------------------------------------
    ------------------------------------

    if inst.AnimState then
        inst.AnimState:Pause()
    end
    if inst.Physics then
        local mass = inst.Physics:GetMass()
        if mass ~= 0 then
            if inst.components.locomotor 
                or inst.components.projectile 
                or inst.components.complexprojectile
                or inst.components.throwable
                or inst:GetPosition().y >= 0.05
                 then --移动的生物和飞行物
                
                inst.Physics:SetActive(false)
            else                              --其他移动物体
                inst.lw_vels = {inst.Physics:GetVelocity()}
                inst.lw_mvels = {inst.Physics:GetMotorVel()}
                inst.Physics:Stop()
                --inst.Physics:SetActive(false)
                inst.lw_tempstop = true
            end
        elseif inst.Physics:GetMotorVel() ~= 0 then --质量为0, 但不是障碍物, 如海浪
            inst.Physics:SetActive(false)
        end
    end

    if inst.SoundEmitter then
        --inst.SoundEmitter:OverrideVolumeMultiplier(0)
    end
end

function PUELLA_MOD_FN.tu_Stop(inst)
	if not inst and inst:IsValid() then 
		return
	end

    if inst.lw_timemagic_onstop then
        inst:lw_timemagic_onstop()
    end

    --[[
    if inst.components.health and not inst:HasTag('homuraTag_die')then 
        local health = inst.components.health
        local min = math.min(health.minhealth or 0, health:GetMaxWithPenalty())
        if health.currenthealth <= min and not health.lw_wasminhealth then
            health.currenthealth = min + .01
            inst:RemoveTag('homuraTag_pause') --强制移除标签
            health:SetVal(min, health.lw_cause_memory, health.lw_afflicter_memory, unpack(health.lw_arg_memory))
        end
        health.lw_wasminhealth = false
        health.lw_cause_memory = nil 
        health.lw_afflicter_memory = nil 
        health.lw_arg_memory = nil
    end
    --]]

    if inst.components.combat then
        inst.components.combat.hurtsound = inst.components.combat.hurtsound or 
            inst.components.combat.M_hurtsound
    end
    
    inst:RemoveTag('homuraTag_pause')

    if inst.sg then
        inst.sg:Lw_TimeMagic_OnStop()
    end
    --------------------------------
    if inst:HasTag("INLIMBO") then
        return
    end
    --------------------------------
    ---------------------------------

    if inst.AnimState then
        inst.AnimState:Resume()
    end
    
    if inst.Physics then
        if inst.lw_tempstop then
            inst.lw_tempstop = nil
            if inst.lw_vels then
                inst.Physics:SetVel(unpack(inst.lw_vels))
                inst.lw_vels = nil
            end
            if inst.lw_mvels then
                inst.Physics:SetMotorVel(unpack(inst.lw_mvels))
                inst.lw_vels = nil
            end
        end
        inst.Physics:SetActive(true)
    end

    if inst.SoundEmitter then
       --inst.SoundEmitter:OverrideVolumeMultiplier(1)
    end
end

function PUELLA_MOD_FN.tu_Update(inst, dt)
	if not inst and inst:IsValid() then 
		return 
	end 

    if inst.lw_timemagic_onupdate then
        inst:lw_timemagic_onupdate(dt)
    end
    for k in pairs(inst.pendingtasks or {})do
        k:AddTick()
    end
    for k,v in pairs(inst.components)do
        if v.lw_timemagic_onupdate then
            v:lw_timemagic_onupdate(dt)
        end
    end

    if inst.sg then
        inst.sg:AddTick(dt)
    end
    if inst.Physics and inst.lw_tempstop then
        --inst.Physics:Stop()
    end
    if inst.components.timer then
        for k,v in pairs(inst.components.timer.timers)do
            if not v.paused then
                v.end_time = v.end_time + dt
            end
        end
    end
    if inst.components.combat and inst.components.combat.lastdoattacktime then 
        inst.components.combat.lastdoattacktime = inst.components.combat.lastdoattacktime + dt
    end
end

