GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})
local L = GLOBAL.PUELLA_MOD_SETTINGS.LANGUAGE 

local UIAnim = require "widgets/uianim"
local sg = require("widgets/puellaUI_sg")
local changeui = require("widgets/sg_AlwaysOnStatus")
local sk1 = require("widgets/puellaUI_skill1")  --kyouko
local sk2 = require("widgets/puellaUI_skill2")  --sayaka
local sk3 = require("widgets/puellaUI_skill3")  --homura
local Flash = require("widgets/puellaUI_playerflash") --致盲
local SgDark = require("widgets/puellaUI_sgdark") --vig
local FocusUI = require "widgets/puellaUI_homurafocus"

local function GetUIPosition(pos1,pos2,pos3)
    local min = math.min(pos1.x,pos2.x,pos3.x)
    local max = math.max(pos1.x,pos2.x,pos3.x)
    local y = math.max(pos1.y,pos2.y,pos3.y)
    if pos1.y-pos2.y < 5 and pos2.y-pos3.y < 5 then  --直线
        return Vector3(2*min-max,y,0),Vector3(1.5*min-0.5*max,y,0)
    else
        return Vector3(3*min-2*max,y,0),Vector3(2*min-max,y,0)
    end
end

local function Addsg(self) 
    if self.owner and self.owner.components.soulgem then
        self.soulgemicon = self.status:AddChild(sg(self.owner))
        ----------------------------------------------------------------
        if self.owner.prefab == "sayaka" then
            self.skillicon = self.status:AddChild(sk2(self.owner))
        elseif self.owner.prefab == "kyouko" then
            self.skillicon = self.status:AddChild(sk1(self.owner))
        elseif self.owner.prefab == "homura_1" then
            self.skillicon = self.status:AddChild(sk3(self.owner))
        end
        ----------------------------------------------------------------
        scheduler:ExecuteInTime(0, function()
            local badge = require"widgets/badge"
            self.mod_test = self.status:AddChild(badge("",self.owner))
            self.mod_test:Hide()
            local MOD = self.mod_test.maxnum ~= nil or self.mod_test.bg ~= nil or self.mod_test.max ~= nil
            local heart = self.owner.HUD.controls.status.heart
            local stomach = self.owner.HUD.controls.status.stomach
            local brain = self.owner.HUD.controls.status.brain
            local pos1,pos2 = GetUIPosition(heart:GetPosition(),stomach:GetPosition(),brain:GetPosition())
            self.soulgemicon:SetPosition(pos2.x,pos2.y,pos2.z) 
            if self.skillicon then
                self.skillicon:SetPosition(pos1.x,pos1.y,pos1.z)
            end
            if MOD then
                changeui(self.soulgemicon)
                if self.skillicon then
                    self.skillicon:SetScale(.9)
                    self.skillicon.MOD = .9
                end
            end
        end) 
    end
end
AddClassPostConstruct("widgets/controls", Addsg)

local function AddExtraUi(playerhud)
    local old_createoverlays = playerhud.CreateOverlays
    function playerhud:CreateOverlays(owner)
        old_createoverlays(self,owner)
        self.puellaUI_playerflash = self.overlayroot:AddChild(Flash(owner))

        self.puellaUI_sgdark = self.overlayroot:AddChild(SgDark(owner))
        self.puellaUI_sgdark:SetScaleMode(SCALEMODE_PROPORTIONAL)

        self.puellaUI_homurafocus = self.overlayroot:AddChild(FocusUI(owner))
        self.puellaUI_homurafocus:SetScaleMode(SCALEMODE_PROPORTIONAL)

        for _,v in pairs({'puellaUI_playerflash','puellaUI_sgdark','puellaUI_homurafocus'})do
            self[v]:SetHAnchor(ANCHOR_MIDDLE)
            self[v]:SetVAnchor(ANCHOR_MIDDLE)
            --self[v]:SetScaleMode(SCALEMODE_FIXEDSCREEN_NONDYNAMIC)
        end
    end
end
AddClassPostConstruct("screens/playerhud",AddExtraUi)

local function Addwatermark(self)
    local Text = require ("widgets/text")
    self.puellamagi_mod_watermark = self.status:AddChild(Text(UIFONT, 25))
    self.puellamagi_mod_watermark:SetPosition(0,-70)
    self.puellamagi_mod_watermark:SetRegionSize(350, 44) 
    self.puellamagi_mod_watermark:SetHAnchor(ANCHOR_MIDDLE)
    self.puellamagi_mod_watermark:SetVAnchor(ANCHOR_TOP)
    self.puellamagi_mod_watermark:SetString("")
    if GetPlayer().prefab == "homura_1" then
        --self.puellamagi_mod_watermark:SetString(L and 'Homura Akemi (in development)' or '晓美焰（测试版）')
    end
    if not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) and GetPlayer():HasTag("puellamagi") then
        self.puellamagi_mod_watermark:SetString(L and "Warning: must be compatible with SW or HAM" or "<魔法少女小圆mod>\n警告：此mod必须兼容船难或汉姆雷特!")
    end
end
AddClassPostConstruct("widgets/controls",Addwatermark)

--熔炉ui
local function rechargeable(self)
    local UIAnim = require "widgets/uianim"
    if self.item.components.homura_weapon and not self.item.components.homura_weapon.no_ammo then
        self:SetPercent(self.item.components.homura_weapon:GetPercent())
    end

    local frame, process
    
    if self.item.prefab == 'sayaka_sword' then
        self.rechargeframe = self:AddChild(UIAnim())
        self.rechargeframe:GetAnimState():SetBank("recharge_meter")
        self.rechargeframe:GetAnimState():SetBuild("recharge_meter_pmmm")
        self.rechargeframe:GetAnimState():PlayAnimation("frame")
        self.rechargeframe:Hide()
    end
    if self.rechargeframe ~= nil then
        self.recharge = self:AddChild(UIAnim())
        self.recharge:GetAnimState():SetBank("recharge_meter")
        self.recharge:GetAnimState():SetBuild("recharge_meter_pmmm")
        self.recharge:SetClickable(false)
    end
    if self.rechargeframe ~= nil then
        self.inst:ListenForEvent("rechargechange",function(invitem, data)
        self:SetWeaponChargePercent(data.percent)
        end, self.item.components.inventoryitem:GetGrandOwner())
    end
    function self:SetWeaponChargePercent(percent)
        if percent < 1 then
            self.recharge:GetAnimState():SetPercent("recharge", percent)
            if self.item and not self.item == self.item.components.inventoryitem:GetGrandOwner().components.inventory.activeitem then
                self.rechargeframe:Show()
            end
        else
            if not self.recharge:GetAnimState():IsCurrentAnimation("frame_pst") then
                self.recharge:GetAnimState():PlayAnimation("frame_pst")
            end
            if self.rechargeframe.shown then
                self.rechargeframe:Hide()
            end
        end
    end 

    local old_startdrag = self.StartDrag
    function self:StartDrag(...)
        old_startdrag(self,...)
        if self.recharge then
            self.recharge:Hide()
        end
        if self.rechargeframe then
            self.rechargeframe:Hide()
        end
     end
end
AddClassPostConstruct( "widgets/itemtile", rechargeable)