require "behaviours/wander"
require "behaviours/chaseandattack"
require "behaviours/follow"
require "behaviours/doaction"
require "behaviours/minperiod"
require "behaviours/controlminions"



local witch_qw_brain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function witch_qw_brain:OnStart()

	--[NEW] Some behavior trees have multiple priority nodes.  Ours has a single node with two behaviours.    
    local root = PriorityNode(
    {
    	--[[
        IfNode(function() return self:CanPlantNest() end, "can plant nest",
            ActionNode(function() self.inst.sg:GoToState("makenest") end)),
        
        MinPeriod(self.inst, TUNING.SPIDERQUEEN_GIVEBIRTHPERIOD, 
            IfNode(function() return self:CanSpawnChild() end, "needs follower", 
                ActionNode(function() self.inst.sg:GoToState("poop") return SUCCESS end, "make child" ))),
        
        --SPIDERQUEEN_MINDENSPACING
        ]]
        ChaseAndAttack(self.inst, 100),
        Wander(self.inst),

    --[NEW] This tells the creature to check every 0.25 seconds if it should be changing which behaviour it's doing.
    }, .25)
    
    --[NEW] Now we attach the behaviour tree to our brain.
    self.bt = BT(self.inst, root)
    
end

--[NEW] Register our new brain so that it can later be attached to any creature we create.
return witch_qw_brain
