local deadtimer = Class(function (self,inst)
	self.inst = inst
	self.timeleft = 30
	self.timer_on = false
	self.chooseline = 1
	
	inst:ListenForEvent("soulgemdelta",function(i,data)
		if data.newpercent >= 1 and not self.timer_on then
			self:Start()
		elseif data.newpercent < 1 and self.timer_on then
			self:End()
		end
	end)
end)

function deadtimer:Start()
	self.timeleft = 30
	self.timer_on = true
	self.inst:StartUpdatingComponent(self) 
end

function deadtimer:End()
	self.chooseline = math.random(2)
	self.timeleft = 30
	self.timer_on = false
	self.inst:StopUpdatingComponent(self) 

	local RESCUE = PUELLA_MOD_STRINGS:Get(self.inst.prefab,"RESCUE")
	self.inst.components.talker:Say(RESCUE,3)
end

function deadtimer:Pause(vel)
	vel = (vel == nil) and true or vel
	self.pause = vel
end

function deadtimer:OnSave()
	return { timer_on = self.timer_on, timeleft = self.timeleft,chooseline = self.chooseline }
end

function deadtimer:OnLoad(data)
	if data then
		self.timer_on = data.timer_on
		self.timeleft = data.timeleft
		self.chooseline = data.chooseline
	end
	if self.timer_on then
		self.inst:StartUpdatingComponent(self)
	end
end

function deadtimer:Announce(num)
	if self.inst.components.health:IsDead() then
		return
	end
	local DIELINES = PUELLA_MOD_STRINGS:Get(self.inst.prefab,"DIELINES",self.chooseline)
	self.inst.components.talker:StopIgnoringAll() 
	self.inst.components.talker:Say(DIELINES[num],4)
end

function deadtimer:Die()  --死亡事件发送~显示界面时间：3秒
	local inst = self.inst
	inst.sg:Stop()
    inst.HUD:Hide()
    inst.components.playercontroller:Enable(false)
    inst.components.soulgem:Pause()
    -------------------------------------------------------------------
    inst:StartThread(function ()
    	TheCamera:SetDistance(12)
    	Sleep(1)
    	GetClock():DoLightningLighting()
    	local pos = inst:GetPosition()
    	local fx = SpawnPrefab("griefseed_fx")   --2、4、6、8秒各释放一次冲击波，8秒处破裂
    	fx.Transform:SetPosition(pos.x,pos.y-2,pos.z)
    	fx.player = inst

    	Sleep(6.5)
    	--TheFrontEnd:Fade(false, 2, nil, 0)
    	inst:PushEvent("death",{cause="becomewitch"}) --被gamelogic接收
    	--Sleep(2)
    	--TheFrontEnd:Fade(true,1,nil,0)

    	return true
    end)
end

function deadtimer:OnUpdate(dt)
	if self.pause then
		return
	end
	if self.inst:HasTag('ironlord') then
		return
	end
	local old = self.timeleft
	self.timeleft = self.timeleft - dt
	for i = 6,1,-1 do
		if old >= 5*i and self.timeleft <= 5*i then
			self:Announce(7-i)
		end
	end
	if self.timeleft <= 0 and not self.inst.components.health:IsDead() then
		self.inst.components.health:DoDelta(-1000,true,"sgdark",true)
	end
end

return deadtimer