local FallingProjectile = Class(function(self, inst)
    self.inst = inst
    self.speedup = false
    self.homing = false
    self.a = 1.03

    self.speed = 5

    self.remove = true
end)

function FallingProjectile:Set(speed,a,homing)
    self.speed = speed
    if a then
        self.speedup = true
        self.a = a 
    end
    self.homing = homing
end

function FallingProjectile:Launch(attacker,target)
    self.inst:StartUpdatingComponent(self)
    self.target = target
    self.attacker = attacker
    self.launchpos = self.inst:GetPosition()
    if not self.homing then
        self.targetpos = target:GetPosition()
        self.dir_vector = (self.targetpos - self.launchpos):Normalize()
    end
    if self.onlaunchfn then
        self.onlaunchfn(self.inst,attacker,target)
    end
end


function FallingProjectile:Hit()
    if self.onhitground then
        self.onhitground(self.inst,self.attacker,self.target)
    end
end

function FallingProjectile:OnUpdate(dt)

    if self.homing then
        if not self.target or not self.target:IsValid() then
            self.homing = false
            if not self.lastpos then
                --self.lastpos = self.inst:GetPosition()
                self.inst:Remove()
                return
            end
            self.dir_vector = (self.inst:GetPosition()-self.lastpos):Normalize()
        else
            self.dir_vector = (self.target:GetPosition()-self.inst:GetPosition()):Normalize()
            
        end
    else

    end

    local moving_vec = self.dir_vector*(self.speed*dt)
    local pos = self.inst:GetPosition()+moving_vec
    if pos.y <= 0 and not self.hit then
        self.hit = true
        self:Hit()
    end
    if not self.inst:IsValid() then
        return
    end

    self.inst.Transform:SetPosition(pos:Get())

    self.speed = self.speedup and self.speed*self.a or self.speed
    self.lastpos = self.inst:GetPosition()
end


return FallingProjectile
