--把东西放在科技台上拆解
local HomuraWeapon = Class(function(self, inst)
    self.inst = inst
    self.buffed_data = {}
    self.basic_data = {}
    inst:ListenForEvent("techtreechange",function(i,data) --离工作台过远时关闭ui
    	if data and data.homura_weapon_level and data.homura_weapon_level == 0 then
    		if inst.components.container:IsOpen() then
    			inst.components.container:Close()
    		end
    	end
    end, GetPlayer())

    inst:ListenForEvent("onclose",function()self:Apply()end)
    inst:ListenForEvent("itemget",function()self:Apply()end)
    inst:ListenForEvent("itemlose",function()self:Apply()end)

    inst:ListenForEvent('onputininventory',function()inst:DoTaskInTime(0,function()self:DoDelta(0)end)end) --百分比显示
    inst:ListenForEvent('unequipped',function()inst:DoTaskInTime(0,function()self:DoDelta(0)end)end)

    --inst:ListenForEvent("itemget",function(i,data)self:PlaySound(data and data.item)end) --装载配件的音效

    -----子弹相关
    self.maxammo = 0
    self.currentammo = 0
    self.no_ammo = false

    self.csmode = false --连发模式  continually shooting mode

    SetDebugEntity(self.inst)--@--

    --inst:DoTaskInTime(0,function()self:DoDelta(0)end)

end)

local L = PUELLA_MOD_SETTINGS.LANGUAGE

local function Override(table1,table2) --把table2的数据覆盖到table1上
    for k,v in pairs(table2)do
        table1[k] = v
    end
    return table1
end

function HomuraWeapon:Apply(call_by_setbasicdata)
    local buffs = self:GetNormalBuff() --k buff类    v 叠加数（用于计算特殊buff）
    
    local buffed_data = deepcopy(self.basic_data)
    if self.in_csmode and not self.buffed_data.ignore_cs then --处于连击状态, 且未安装配件
        Override(buffed_data,self.cs) --则将连击状态的数据进行覆盖
    end
    for buff,_ in pairs(buffs)do                  -- 叠加数不参与计算,只判断buff的有无
        for name,value in pairs(buff.parameter)do --name参数名  value表，[1]为值，[2]为加和或加乘
            if buffed_data[name]then
                if value[2] then
                    buffed_data[name] = buffed_data[name]+value[1]
                else
                    buffed_data[name] = buffed_data[name]*(value[1]+1)
                end
            else --非数值型buff
                buffed_data[name] = true
            end
        end
    end
    self.buffed_data = buffed_data  --k  属性值      v  结果值（数字或布尔）
    self:GetSpecialBuff(buffs)
    --------
    local inst = self.inst

    inst.components.equippable.walkspeedmult = buffed_data.movespeed
    local owner = inst.components.equippable.isequipped and inst.components.equippable.equipper
    if owner and owner.components.locomotor then --重算移速(手动)
        owner.components.locomotor:AddSpeedModifier_Mult("equipslot_"..inst.components.equippable.equipslot, buffed_data.movespeed)
    end

    if self.buffed_data.waterproof then  --防水
        inst:AddComponent('waterproofer')
        inst.components.waterproofer.effectiveness = 0
        if inst.components.moisturelistener then
            inst.components.moisturelistener.moisture = 0
        end
    else
        inst:RemoveComponent('waterproofer')
    end

    if self.buffed_data.bigclip then     --重算弹夹容量
        local bonus = self.inst.prefab == 'homura_rpg' and 5 or 2
        self:SetMaxAmmo(self.basic_data.maxammo*bonus, call_by_setbasicdata)
    else
        self:SetMaxAmmo(self.basic_data.maxammo, call_by_setbasicdata)
    end

    if self.inst.components.homura_focus then
        self.inst.components.homura_focus.enabled = self.buffed_data.focus
    end

    self:SetProjectile()
    self:SetName()
end

function HomuraWeapon:GetBuff(name)
    return self.buffed_data[name]
end

function HomuraWeapon:SetBasicPara(table,cs)
    local basic = self.basic_data
    basic.speed = table.speed or 10  --子弹初速度(pro)
    basic.range = table.range or 10  --射程
    basic.hitrange = table.hitrange or 5 --必中射程(pro)
    basic.min_hit_rate = table.min_hit_rate or 1 --最低命中率(pro)
    basic.variety = table.variety or 10  --子弹最大偏角(pro)
    basic.movespeed = table.movespeed or 0 --移速
    basic.damage1 = table.damage1 or 40  ---攻击伤害
    basic.damage2 = table.damage2 or 10  ---平a伤害
    basic.maxammo = table.maxammo or 7

    self.cs = cs or {}

    self:Apply(true)
end

function HomuraWeapon:CollectUseActions(doer, target, actions) --加载配件的动作
    if target:HasTag('homura_prototyper') then
        table.insert(actions, ACTIONS.HOMURA_ADDBUFF)
    end
end

function HomuraWeapon:SetName()
    if not self.inst.prefab or not self.inst.components.named then
        return
    end
    local buffhint
    if self.inst.components.container:IsFull() then
        buffhint = " Pro"
    elseif self.inst.components.container:IsEmpty() then
        buffhint = ""
    else
        buffhint = " Plus"
    end

    local name_sp = '%s'
    local nametable = L and 
        {
            knife_sp = '',
            magic_sp = '',
            ice_sp = '',
            time_sp = '',
            wind_sp = '',
        }
        or
        {
            knife_sp = '装有%s的刺刀',
            magic_sp = '充满魔力的%s',
            ice_sp = '寒冰射手*%s',
            time_sp = '时空跃迁者*%s',
            wind_sp = '超绝快乐!*%s',

        }
    for k,v in pairs(self.buffed_data) do
        if k:find("_sp") then
            name_sp = nametable[k]
        end
    end

    local totalname = string.format(name_sp,STRINGS.NAMES[self.inst.prefab:upper()])..buffhint
    self.inst.components.named:SetName(totalname)

end

function HomuraWeapon:GetNormalBuff() --buff均不可叠加
    local buffs = {}
    --local hasitem = {}
    local container = self.inst.components.container
    local maxslots = container.numslots
    for i = 1,maxslots do
        local item = container:GetItemInSlot(i) --当前物品
        local buff = item and item.homura_weapon_buff    --当前物品的buff
        if item and item.prefab == 'homura_weapon_buff_code' and i > 1 then --如果这是一个代码编辑器
            local pre_item = container:GetItemInSlot(i-1)                   --获取前一个物品
            if pre_item and pre_item.prefab ~= 'homura_weapon_buff_code' then
                buff = pre_item.homura_weapon_buff
            end
        end
        if buff then
            local has = false
            for hasbuff,stack in pairs(buffs) do    --hasbuff  buff类 / stack 层数
                if hasbuff.name == buff.name then   --对比，两者buff等效（由于是表，不能直接用 == 进行判定）
                    buffs[hasbuff] = stack + 1      --叠加数量，退出循环
                    has = true                      --已计算
                    break
                end
            end
            if not has then
                buffs[buff] = 1                     --这是第一个
            end
        end
    end
    return buffs --表，k为buff类，v为叠加层数
end

function HomuraWeapon:GetSpecialBuff(buffs) --目前还不存在重叠的特殊buff
    local buffs_sp = self.buffed_data
    local maxslots = self.inst.components.container.numslots
    local buff_count = {}
    for k,v in pairs(buffs)do
        buff_count[k.name]=v 
    end
    if buff_count.knife and buff_count.knife >= 2 then  --带武器的刺刀
        buffs_sp.knife_sp = true
        buffs_sp.damage2 = buffs_sp.damage2 + 15
    elseif buff_count.magic and buff_count.magic >= 2 then     --充满魔力的武器
        buffs_sp.magic_sp = true
    elseif buff_count.ice and buff_count.ice >= 2 then       --寒冰
        buffs_sp.ice_sp = true
    elseif buff_count.time and buff_count.time >= 2 then      --跃迁者
        buffs_sp.time_sp = true
    elseif buff_count.wind and buff_count.wind >= 2 then      --疾风/飓风
        buffs_sp.wind_sp = buff_count.wind
    elseif buff_count.flyingspeed and buff_count.flyingspeed >= 2 then    --电磁线圈
        buffs_sp.flyingspeed_sp = true
        buffs_sp.damage1 = buffs_sp.damage1 * 1.4/1.2 --@--
        buffs_sp.speed = buffs_sp.speed * 1.4/1.2 --@--
    end
end

function HomuraWeapon:PlaySound(item) --配件装备音效
    if item and item.OnPutInBuffSlotFn then
        item:OnPutInBuffSlotFn()
    end
end

function HomuraWeapon:CanAccept(item) --指子弹
    if self.no_ammo then
        return
    end
    local inst = self.inst
    local ammo = item.prefab
    local t = {
        homura_pistol={homura_gun_ammo1=true,homura_gun_ammo3=true},
        homura_gun={homura_gun_ammo1=true},
        homura_hmg={homura_gun_ammo2=true},
        homura_rpg={homura_rpg_ammo1=true,homura_rpg_ammo2=true},
    }
    local function canfit(ammo,gun)
        if t[gun] and t[gun][ammo]then
            return true
        end
    end
    if canfit(ammo,inst.prefab) then
        if self.currentammo >= self.maxammo then
            return false
        elseif self.currentammo <= 0 then --print(1)
            return true
        elseif GetTableSize(t[inst.prefab]) == 1 then  --print(2) --弹药>0 
            return true
        elseif self.projectile == item.projectilename then --print(3)
            return true
        else
            --print(false)
        end
    end
    return false
end

function HomuraWeapon:SetCSMode(val)
    if self.csmode and not val then
        self.csmode = false
        self:Apply()
    elseif val and not self.csmode then
        self.csmode = true
        self:Apply()
    end
end

function HomuraWeapon:OnLaunch(attacker)
    if not self.no_ammo then
        if self.buffed_data.magic_sp then
            attacker.components.soulgem:DoDelta(0.2) 
        elseif self.buffed_data.magic then
            attacker.components.soulgem:DoDelta(0.1)  
        end
        self:DoDelta(0)
        --@--@--self:DoDelta(-1)
    end
end

function HomuraWeapon:SetPercent(p)
    p = math.clamp(p, 0, 1)
    self.currentammo = math.floor(self.maxammo * p)
    self:DoDelta(0)
end

function HomuraWeapon:GetPercent()
    self:Apply()
    if self.no_ammo then
        return 1
    else
        return self.currentammo/self.maxammo
    end
end

function HomuraWeapon:DoDelta(num)
    if self.no_ammo then
        return
    end
    local ammo = self.currentammo
    self.currentammo = math.max(0,self.currentammo + num)
    self.inst:PushEvent('percentusedchange',{percent=self.currentammo/self.maxammo})
    if ammo > 0 and self.currentammo == 0 then --最后一发子弹
        self.inst:DoTaskInTime(0,function()self:SetProjectile()end)
    else
        self:SetProjectile()
    end
end

function HomuraWeapon:OnAccept(item,giver) --指子弹
    if item:GetIsWet() then
        if giver and giver.components.talker then
            giver.components.talker:Say(L and "It's wet!" or "我得先把弹药都晾干。")
        end
        return true
    elseif self.inst:GetIsWet() then
        if giver and giver.components.talker then
            giver.components.talker:Say(L and "This gun is not waterproof..." or "这东西不防水，让我想个办法...")
        end
        return true
    end

    local delta1 = self.maxammo - self.currentammo      -- = self.maxammo
    local delta2 = item.components.stackable.stacksize
    if delta2 <= delta1 then    --子弹耗尽
        self:DoDelta(delta2)
        item.components.homura_ammo:OnConsume(delta2)
    else                        --子弹有剩余
        self:DoDelta(delta1)
        item.components.homura_ammo:OnConsume(delta1)
    end
    if self.onacceptfn then
        self.onacceptfn(self.inst,item)
    end
    self.ammo_prefabname = item.prefab
    self:Apply()
end  

function HomuraWeapon:SetMaxAmmo(num,loadammo)
    if self.no_ammo then
        return
    end
    local old_max = self.maxammo
    self.maxammo = num
    if loadammo then
        self.currentammo = self.maxammo
    else   --装载配件
        if self.maxammo < self.currentammo then
            local overflow = self.currentammo - self.maxammo --扔掉多余子弹
            local owner = self.inst.components.inventoryitem:GetGrandOwner()
            local item = SpawnPrefab(self.ammo_prefabname)
            if item and owner then
                item.components.stackable:SetStackSize(math.floor(overflow))
                owner.components.inventory:GiveItem(item)
            end
            self.currentammo = self.maxammo 
        end
    end
    self:DoDelta(0)
end

function HomuraWeapon:SetProjectile() --刷新载弹情况
    if self.currentammo == 0 then
        self.inst.components.weapon:SetProjectile(nil)
        self.inst.components.weapon:SetDamage(self.buffed_data.damage2)
        self.inst.components.weapon:SetRange(nil,nil)
    else
        self.inst.components.weapon:SetProjectile(self.projectile)
        --self.inst.components.weapon:SetDamage(self.buffed_data.damage1)
        self.inst.components.weapon:SetDamage(0)
        self.inst.components.weapon:SetRange(self.buffed_data.range,self.buffed_data.range+2)
    end
end

function HomuraWeapon:OnSave()
    return {currentammo=self.currentammo,maxammo=self.maxammo,ammo_prefabname=self.ammo_prefabname}
end

function HomuraWeapon:OnLoad(data)
    if data then
        self.currentammo = data.currentammo
        self.maxammo = data.maxammo
        self.ammo_prefabname = data.ammo_prefabname
    end
    self:DoDelta(0)
end

function HomuraWeapon:GetDebugString()
    local str = '\n'
    ---[[
    for k,v in pairs(self:GetNormalBuff())do
        str = str..string.format("%s : %s\n",k.name,v)
    end
    str = str..'----------\n'
    for k,v in pairs(self.buffed_data)do
        str = str..string.format("%s : %s\n",tostring(k),tostring(v))
    end
    str = str..'\n'..self.currentammo..' / '..self.maxammo
    --]]
    --str = str .. 'is focusing: '..(self.to_focustarget and self.to_focustarget.prefab or 'NO TARGET' ).. '\n'
    --str = str .. 'is focus at: '..(self.focustarget and self.focustarget.prefab or 'NO TARGET').. '\n'
    return str
end

function HomuraWeapon:OnUpdate(dt)
    if self.csmode_lefttime > 0 then
        self.csmode_lefttime = self.csmode_lefttime - dt
        if self.csmode_lefttime <= 0 then
            self:ExitCSMode()
        end
    end
    
    if self.csmode_lefttime <= 0 then
        self.inst:StopUpdatingComponent(self)
    end
end

function HomuraWeapon:EnterCSMode() --进入连发模式, 重新计算弹道偏角和子弹命中率
    if self.inst.components.container:Has('homura_weapon_buff_mouse',1) then
        print('Have mouse, dont enter cs mode')
        return
    end
    self.in_csmode = true
    self:Apply()
    self.inst:StartUpdatingComponent(self)
    self.csmode_lefttime = .5
end

function HomuraWeapon:ExitCSMode()
    self.in_csmode = false
    self:Apply()
end

return HomuraWeapon

