--我就应该把瞄准系统单独放一个组件里的....

local FOCUS_DURATION = 20

local HomuraFocus = Class(function(self, inst)
    self.inst = inst
    
    inst:ListenForEvent('homura_focus_down',function (i,data)  --发出者: sg
        self.focustarget = self.to_focustarget
        self.to_focustarget = nil
        self.focustimer = FOCUS_DURATION
        self.inst:StartUpdatingComponent(self) --开始20秒倒计时
    end)
    inst:ListenForEvent('homura_focus_abrupt',function(i,data) --发出者: sg
        self.to_focustarget = nil
        self.focustarget = nil
        self.focustimer = 0
    end)
    
    inst:ListenForEvent('unequipped',function(i,data) 
        self.to_focustarget = nil
        self.focustarget = nil
        data.owner:PushEvent('homura_focus_end')
    end)
    
    self.focustimer = 0
    SetDebugEntity(self.inst)--@--
end)

local L = PUELLA_MOD_SETTINGS.LANGUAGE

function HomuraFocus:ShouldFocus(newtarget)
    if not newtarget then --根本没传参数
        return false
    end
    if not self.enabled then --没有安装瞄准镜
        return false
    end
    if not self.inst.components.weapon.projectile then --没有子弹
        return false
    end
    if not (self.focustarget and self.focustarget:IsValid()) and not self.to_focustarget then  --初始状态
        --print(1)
        return true
    end
    if self.focustarget and self.focustarget ~= newtarget then --锁定状态下选择新目标
        --print(2)
        return true
    end
    if self.to_focustarget and self.to_focustarget ~= newtarget then --锁定过程中选择新目标
        --print(3)
        return true
    end
end

function HomuraFocus:IsFocusing()
    if not self.inst.components.weapon.projectile then
        return false
    end
    return self.inst.components.equippable:IsEquipped() and self.to_focustarget
end

function HomuraFocus:IsFocused()
    if not self.inst.components.weapon.projectile then
        return false
    end
    return self.inst.components.equippable:IsEquipped() and self.focustarget and self.focustarget:IsValid()
end

function HomuraFocus:CollectEquippedActions(doer, target, actions, right) --锁定目标的动作(fn: SetTarget())
    if self.focused and self.focustarget == target then --被锁定的目标显示为"攻击"
        return
    end
    if target.components.health and target.components.combat and self:ShouldFocus(target) then--@--需要测试
        table.insert(actions, ACTIONS.HOMURA_FOCUS)
    end
end

function HomuraFocus:OnUpdate(dt)
    if self.focustimer > 0 then
        self.focustimer = self.focustimer - dt
        if self.focustimer <= 0 then
            local owner = self.inst.components.equippable.owner
            if owner then
                owner:PushEvent('homura_focus_end')
            end
            self.inst:StopUpdatingComponent(self)
        end
    end
end

return HomuraFocus

