local _inv = 10
local _pro = 3
--该组件会为刚出手的物体添加一个10帧的时间魔法抗性，优化攻击手感（可加可不加）

local IgnoreTime = Class(function(self, inst)           
    self.inst = inst
    self.resist = 10 --抗性
    self.max_resist = 10
    self.leave = false

    self.inst:ListenForEvent("onputininventory",function()self:ReturnToOwner()end)
    self.inst:ListenForEvent("ondropped",function ()self:SetInventory() self:LeaveOwner() end)
    self.inst:ListenForEvent("onpickup",function ()self:ReturnToOwner() end)
    self.inst:ListenForEvent("throw",function()self:SetProjectile() self:LeaveOwner() end) --投掷组件
    self.inst:ListenForEvent("onthrown",function ()self:SetProjectile() self:LeaveOwner() end) --子弹组件

    self.inst:StartUpdatingComponent(self)
end)

function IgnoreTime:DoDec()
    if self.leave then
        self.resist = self.resist - 1
        if self.resist < 0 then
            self.inst:StopUpdatingComponent(self)
        end
    end
end

function IgnoreTime:IsIgnoring()
    return (self.resist > 0)
end

function IgnoreTime:LeaveOwner() --开始倒计时
    self.leave = true
    self.inst:StartUpdatingComponent(self)
end

function IgnoreTime:ReturnToOwner() --停止倒计时，并刷新
    self.leave = false
    self.inst:StopUpdatingComponent(self)
    self.resist = self.max_resist
end

function IgnoreTime:Set(num)
    self.max_resist = num
    self.resist = num
end

function IgnoreTime:SetInventory()
    self.max_resist = _inv
    self.resist = _inv
end

function IgnoreTime:SetProjectile()
    self.max_resist = _pro
    self.resist = _pro
    local speed = self.inst.components.projectile and self.inst.components.projectile.speed 
    if not speed then
        self.max_resist = 3
        self.resist = 3
    elseif speed < 25 then
    elseif speed < 50 then
        self.max_resist = _pro/3
        self.resist = _pro/3
    elseif speed < 75 then
        self.max_resist = 0
        self.resist = 0
    else
        self.max_resist = 0
        self.resist = 0
    end
end

function IgnoreTime:AddResistance(value)
    self.max_resist = self.max_resist+value
    self.resist = self.resist+value
end

function IgnoreTime:StartUpdating()
    self.leave = true
    self.inst:StartUpdatingComponent(self)
end

function IgnoreTime:OnUpdate()
    self:DoDec()
end

return IgnoreTime