local Debuff = Class(function(self, inst)
	
    self.inst = inst
    self.buffs = 0 --层数
    self.maxbuffs = 5

    self.bufftime = 0
    self.maxbufftime = 5
    self.addbufftime = 5

    self.lasttime = 0

    self.inst:ListenForEvent('attacked',function(i,d)self:OnAttacked(i,d)end)
end)

function Debuff:OnAttacked(inst,data)
    if self.buffs == 0 then
        return
    end
    local stimuli = data and data.stimuli
    if stimuli and stimuli ~= 'electric' then
        return
    end
    --只有无stimuli和stimuli为电击的情况,会执行到这一步
    --防止两个伤害增幅器反复叠加
    local dmg = data and data.damage*self.buffs*0.06 or 0
    if dmg > 0 then
        inst.components.combat:GetAttacked(data.attacker, dmg, nil, 'kyouko_hurt')
    end
end

function Debuff:OnHeavilyAttacked()
    local time = GetTime()
    if time - self.lasttime <= self.addbufftime then
        self:AddBuff()
    end
    self.lasttime = time
    self.bufftime = self.maxbufftime --刷新buff持续时间
    self.inst:StartUpdatingComponent(self) --print(self.buffs)
end

function Debuff:AddBuff()
    self.buffs = math.min(self.maxbuffs, self.buffs+1)
end

function Debuff:RemoveBuff()
    self.buffs = 0
    self.bufftime = 0
    self.inst:StopUpdatingComponent(self)
end

function Debuff:OnUpdate(dt)
    self.bufftime = self.bufftime - dt
    if self.bufftime < 0 then
        self:RemoveBuff()
    end    
end

return Debuff

