
local MotionShadowSpawner = Class(function(self, inst)
    self.inst = inst
    self.shadow_per_frame = 1
end)

function MotionShadowSpawner:Set(data)
    self.entityfn = data.CreateEntity
end

function MotionShadowSpawner:SpawnAt(pos)
    local shadow = self.entityfn(self.inst)
    shadow.Transform:SetPosition(pos:Get())
end

function MotionShadowSpawner:Start()
    self.lastpos = self.inst:GetPosition()
    self.inst:StartUpdatingComponent(self)
end

function MotionShadowSpawner:End()
    self.inst:StopUpdatingComponent(self)
end

function MotionShadowSpawner:OnUpdate(dt)
    if not self.lastpos then
        self.lastpos = self.inst:GetPosition()
        return
    end
    local pos1 = self.lastpos
    local pos2 = self.inst:GetPosition()
    if pos1 == pos2 then
        return
    end
    self.lastpos = pos2

    local vec = pos2 - pos1
    local dist = vec:Length()
    local step = dist/self.shadow_per_frame
    for i = 1,self.shadow_per_frame do
        local spawnpos = vec*(i-1)/self.shadow_per_frame + pos1
        self:SpawnAt(spawnpos)
    end
end


return MotionShadowSpawner
