
local function IsValidKeyEvent()
    return not IsPaused() and not TheInput:IsKeyDown(KEY_CTRL) and not TheInput:IsKeyDown(KEY_SHIFT) 
end

local puella_keytrigger = Class(function (self, inst)
    self.inst = inst
    self.chargekey = PUELLA_MOD_SETTINGS.CHARGEKEY 
    self.skillkey = PUELLA_MOD_SETTINGS.SKILLKEY

    TheInput:AddKeyDownHandler(self.chargekey, function()
        if IsValidKeyEvent() and not TheInput:IsKeyDown(KEY_ALT) then
            self:OnStrike1()
        end
    end)

    TheInput:AddKeyDownHandler(self.skillkey, function()
        if IsValidKeyEvent() and not TheInput:IsKeyDown(KEY_ALT) then
            self:OnStrike2()
        end
    end)
end)

local function GetSoulgem(owner)
    return owner.HUD.controls.soulgemicon
end

function puella_keytrigger:IsDisabled()
    return not self.inst.components.playercontroller:IsEnabled() and not self.inst:HasTag('ironlord')
end

function puella_keytrigger:OnStrike1() --变身键位
    if self:IsDisabled()then 
        return
    end
    GetSoulgem(self.inst):BrowseHelp()
    local state = self.inst.components.magicalcharge.state
    if state and state == 1 or state == 3 then

        self.inst.components.magicalcharge:OnTrigger()
        if self.afterstrike1 then
            --self.afterstrike1(result) --ui接口
        end
        return "SUCCESS"
    end
    
end

function puella_keytrigger:OnStrike2() --技能键位
    if self:IsDisabled()then
        return 
    end
    local result = self:TryUseSkill()
    if self.afterstrike2 then
        self.afterstrike2(result) --ui接口
    end
end

function puella_keytrigger:TryUseSkill()
    local state = self.inst.components.magicalcharge.state
    if state ~= 3 then 
        return "LOCK"
    else 
        local comtable = {
            kyouko = 'skill_kyouko',
            sayaka = 'skill_sayaka',
            homura_1 = 'skill_homura',
        }
        return self.inst.components[comtable[self.inst.prefab]]:OnTrigger()
        --print("Use a skill!")
    end
end

return puella_keytrigger