local qw_flowerspawner = Class(function(self, inst)
	
    self.inst = inst
    self.minions = {}

    self.inst:DoPeriodicTask(5, function() 
        self:FindPos()
    end)
end)

function qw_flowerspawner:Spawn(pos)   
    local man = SpawnPrefab("qw_man")
    man.Transform:SetPosition(pos:Get())
    man.witchqw = self.inst
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 2 ,{"witch","witch_sm","witch_qw",})
    for k,v in pairs(ents) do 
        if v.prefab == "qw_stem" then  ---清除生成点周围的stem
            v:PushEvent("death")
        end

    end
    self.minions[man] = true
    self.inst:ListenForEvent('death', function()self.minions[man] = nil end, man)
    self.inst:ListenForEvent('death', function(_, data)self:OnLoseMinion(data) end, man)
    man:ListenForEvent('attacked',function(_, data) man.components.combat:SetTarget(data.attacker) end, self.inst)
end

function qw_flowerspawner:FindPos()
    if self:CheckCanSpawn() == false then
        return
    end

    local pos = self.inst:GetPosition()
    for i = 1,10 do 
        local st = math.random()*2*PI
        local spawnpos = pos + Vector3(math.sin(st)*6,0,math.cos(st)*6)
        if self.inst:GetIsOnLand(spawnpos:Get()) then
            self:Spawn(spawnpos)
            return
        end
    end
end

function qw_flowerspawner:CheckCanSpawn()
    local maxminion,num = 0,0

    local p = self.inst.components.health:GetPercent()
    if p < 0.2 then 
        maxminion = 4
    elseif p < 0.5 then 
        maxminion = 3
    else 
        maxminion = 2 
    end

    for k in pairs(self.minions)do
        num = num + 1
    end

	return num < maxminion
end

function qw_flowerspawner:OnLoseMinion(data)
    print(data.cause)
    if data and data.cause ~= "no power" then
        self.inst.CanGroundPound = true
    end
end

function qw_flowerspawner:LoadPostPass(ents, data)
    if data and data.minions then
        for _,v in pairs(data.minions)do
            if ents[v] then
                local man = ents[v]
                self.minions[man] = true
                self.inst:ListenForEvent('death', function()self.minions[man] = nil end, man)
                self.inst:ListenForEvent('death', function(_, data)self:OnLoseMinion(data) end, man)
            end
        end
    end
end

function qw_flowerspawner:OnSave()
    local data = {minions = {}}
    for k in pairs(self.minions)do
        if k:IsValid() and k.persists ~= false then
            table.insert(data.minions, k.GUID)
        end
    end

    return data
end

function qw_flowerspawner:GetDebugString()
    return string.format("Minion number: %f",GetTableSize(self.minions))
end
return qw_flowerspawner
