local prefabname = "qw_stem"

local qw_stemspawner = Class(function(self, inst)
	
    self.inst = inst
    --self.maxminion = 100

    self.SPAWN_DAMAGE = 15
	self.SPAWN_DAMAGE_RANGE = 2
	--self.RING_RANGE = {MIN = 2,MAX = 20}
    self.inst:DoTaskInTime(0, function()
        self:OnTimeDone()
    end)
end)

local function CheckTileCompatibility(pos) --检查   地皮对应关系见constant.lua
    local tile = GetVisualTileType(pos:Get())
    for _,v in pairs({255,1,50,55,56,57,58,59,60,61,62,63,64,128}) do if v == tile then return false end end
    return true 
end

local function GetState(inst)
    local p = inst.components.health:GetPercent()
    if p < .33 then 
        return 3
    elseif p < .66 then
        return 2
    else
        return 1
    end
end

function qw_stemspawner:SpawnStemAt(pos,delay)   --单纯的生成函数，附带伤害
    if not CheckTileCompatibility(pos)then
        return
    end
    delay = delay or 0
    self.inst:DoTaskInTime(delay,function()
        --
    local stem = SpawnPrefab(prefabname)
    stem.Transform:SetPosition(pos:Get())
    stem.components.follower:SetLeader(self.inst)
    self.inst.components.leader:AddFollower(stem)
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, self.SPAWN_DAMAGE_RANGE,{"combat","hascombatcomponent"},{"witch"})
    for k,v in pairs(ents) do 
        if stem.components.combat:CanAttack(v) then
            v.components.combat:GetAttacked(stem, self.SPAWN_DAMAGE)
        end
    end
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, self.SPAWN_DAMAGE_RANGE/2,{"witch","witch_sm","witch_qw",},{"growing"})
    for k,v in pairs(ents) do 
        if v ~= stem then
            v:PushEvent("death",{cause = "nopower"})
        end
    end
        --
    end)
end

function qw_stemspawner:OnPound() ---保护
   -- do return end
    local rad1,rad2 = 5, 6
    local num1,num2 = 15, 15
    local pos = self.inst:GetPosition()
    for _in = 1,num1 do 
        local angle = 2*PI*_in/num1
        local spawnpos = pos + Vector3(rad1*math.sin(angle),0,rad1*math.cos(angle))
        if CheckTileCompatibility(spawnpos) then
            self.inst:DoTaskInTime(math.random()*.1,function ()self:SpawnStemAt(spawnpos)end)
        end
    end
    for _out = 1,num2 do 
        local angle = 2*PI*(_out+.5)/num2
        local spawnpos = pos + Vector3(rad2*math.sin(angle),0,rad2*math.cos(angle))
        if CheckTileCompatibility(spawnpos) then
            self.inst:DoTaskInTime(math.random()*.1,function ()self:SpawnStemAt(spawnpos)end)
        end
    end
    
end

function qw_stemspawner:SingleIcon(pos)
    local icon = SpawnPrefab("witch_qw_icon_mi")
    icon.caster = self.inst
    icon.Transform:SetPosition(pos:Get())
    icon.exist_time = 8 + 3*GetState(self.inst) + GetRandomMinMax(0,5)
    self.inst:DoTaskInTime(-2*GetState(self.inst)+10,function()self:OnTimeDone()end)
end

function qw_stemspawner:CrossIcon(pos) 
    local icon = SpawnPrefab("witch_qw_icon_cr")
    icon.caster = self.inst
    icon.Transform:SetPosition(pos:Get())
    icon.exist_time = 10 - 2*GetState(self.inst) + GetRandomMinMax(0,3)
    self.inst:DoTaskInTime(-2*GetState(self.inst)+14,function()self:OnTimeDone()end)
end

function qw_stemspawner:SurroundIcon(pos) 
    local icon = SpawnPrefab("witch_qw_icon_sr")
    icon.caster = self.inst
    icon.Transform:SetPosition(pos:Get())
    icon.exist_time = 4 + 3*GetState(self.inst) --+ GetRandomMinMax(0,5)
    self.inst:DoTaskInTime(-2*GetState(self.inst)+16,function()self:OnTimeDone()end)
end

local function FindPosAround(pos,var)
    local angle = math.random()*6.283
    local r = math.random()*var
    return pos + Vector3(r*math.sin(angle),0,r*math.cos(angle))
end

function qw_stemspawner:FindPos1(norange)  --瞄准式
    local pos = nil
    local witchpos = self.inst:GetPosition()
    local targ = self.inst.components.combat.target
    if not targ then 
        pos = FindPosAround(witchpos,GetRandomMinMax(4, 12))
    else
        local targpos = targ:GetPosition()
        local distsq = targpos:DistSq(witchpos) --取距离
        if distsq > 12*12 and not norange then
            pos = FindPosAround(witchpos,GetRandomMinMax(4, 12))
        else
            pos = FindPosAround(targpos,GetRandomMinMax(0,1))
        end
    end
    --如果是水上，放弃本次生成
    if CheckTileCompatibility(pos)then
        return pos
    end
end

function qw_stemspawner:FindPos2()  --随便乱打
    local pos = nil
    local witchpos = self.inst:GetPosition()
    local targpos = self.inst.components.combat.target and self.inst.components.combat.target:GetPosition()
    if targpos and targpos:DistSq(witchpos) < 30*30 then 
        pos = FindPosAround(targpos,GetRandomMinMax(3, 10))
    end
    return pos 
end

function qw_stemspawner:StartSpawn(mode)
    if mode == "single" then
        local pos = self:FindPos2()
        if pos then
            self:SingleIcon(pos)
        else
            self.inst:DoTaskInTime(5,function ()self:OnTimeDone() end)
        end
    end
    if mode == "cross" then
        local pos = self:FindPos2()
        if pos then
            self:CrossIcon(pos)
        else
            self.inst:DoTaskInTime(5,function ()self:OnTimeDone() end)
        end
    end
    if mode == "surround" then
        local pos = self:FindPos1(1)
        if pos then
            self:SurroundIcon(pos)
        else
            self.inst:DoTaskInTime(5,function ()self:OnTimeDone() end)
        end
    end
end



function qw_stemspawner:OnTimeDone()
    if not self:CheckCanSpawn() then
        self.inst:DoTaskInTime(5,function ()
            self:OnTimeDone()
        end)
        return
    end
    
    local spawntype
    local state = GetState(self.inst)
    local num = math.random()
    if not self.inst.components.combat.target then
        spawntype = "single"
    elseif state == 1 then
        if num < .05 then
            spawntype = "cross"
        else
            spawntype = "single"
        end
    elseif state == 2 then
        if num < .1 then
            spawntype = "cross"
        elseif num < .15 then
            spawntype = "surround"
        else
            spawntype = "single"
        end
    else
        if num < .15 then
            spawntype = "cross"
        elseif num < .25 then
            spawntype = "surround"
        else
            spawntype = "single"
        end
    end
    --spawntype = "surround"
    self:StartSpawn(spawntype)
end

function qw_stemspawner:CheckCanSpawn()
    do return true end
	local followers = self.inst.components.leader.followers
    local num = 0
    for k,_ in pairs(followers)do
        if k.prefab == "qw_stem" and not k:HasTag("burnt") then
            num = num + 1
        end
    end
    return (num<self.maxminion)
end

return qw_stemspawner
