
local  ReticuleManager = Class(function(self, inst)
	self.inst = inst
	self.spell = nil
	self.canspell = true
	self.showreticule = false

	self.inst:ListenForEvent('unequipped',function()self:KillReticule();self:Detach();end)
	self.inst:ListenForEvent('equipped',function()self:SetReticule();self:HideReticule();end)
end)

function ReticuleManager:CanCast(doer, pos)
	if doer.components.driver and doer.components.driver:GetIsDriving() then
		return false
	end
	do 
		return true 
	end

    local ground = GetWorld(doer, pos)
    if ground then
		local tile = ground.Map:GetTileAtPoint(pos:Get())
		return self.spell and tile ~= GROUND.IMPASSIBLE and tile < GROUND.UNDERGROUND
	end
	return false
end

function ReticuleManager:SetSpellFn(fn)
    self.spell = fn
end

function ReticuleManager:CastSpell(doer, pos)
    if self.spell ~= nil then
        self.spell(self.inst,doer, pos)
	end
	self:HideReticule()
end


function ReticuleManager:SetCanSpell(enabled)
    self.canspell = enabled
end

function ReticuleManager:ShowReticule()
	self.showreticule = true
	self:AddReticule()
	self.reticule:Show()
	
	---
end

function ReticuleManager:HideReticule()
	self.showreticule = false
	if self.reticule then
		self.reticule:Hide()
	end
end

function ReticuleManager:AddReticule()
	if not self.reticule then
		self.reticule = SpawnPrefab('reticuleline') --SetDebugEntity(self.reticule)
		--self.reticule._oldininterior = self.reticule.ininterior
		self.reticule:DoPeriodicTask(0,function(inst)
			local angle = self.inst:GetAngleToPoint(TheInput:GetWorldPosition())
			inst.Transform:SetPosition(self.inst:GetPosition():Get())
			inst.Transform:SetRotation(angle)
			--print(inst.ininterior)
			--if inst.ininterior ~= inst._oldininterior then
				--self:KillReticule()
			--	return
			--end
			--inst._oldininterior = inst.ininterior
		end)
	end
	local owner = self.inst.components.inventoryitem:GetGrandOwner()
	if owner.components.playercontroller then
		owner.components.playercontroller.mk_reticule_com = self
		self.playercontroller = owner.components.playercontroller
	end
end

function ReticuleManager:KillReticule()
	self.showreticule = false
	if self.reticule then
		self.reticule:Remove()
		self.reticule = nil
		--self.playercontroller.mk_reticule_com = nil
	end
end

function ReticuleManager:Detach()
	if self.playercontroller then
		self.playercontroller.mk_reticule_com = nil
	end
end

function ReticuleManager:CollectPointActions(doer, pos, actions, right)
    if right and self:CanCast(doer, pos) and self.canspell and not self.showreticule then
		--table.insert(actions, ACTIONS.MK_CASTAOE1)
	end
	if not right and self:CanCast(doer, pos) and self.canspell and self.showreticule then
		table.insert(actions, ACTIONS.MK_CASTAOE2)
	end
end

function ReticuleManager:CollectEquippedActions(doer, target, actions, right)
	local pos = target:GetPosition()
	if not right and self:CanCast(doer, pos) and self.canspell and self.showreticule then
		table.insert(actions, ACTIONS.MK_CASTAOE2)
	end
end
return ReticuleManager


