
local darkdebuff = Class(function(self, inst)
	
    self.inst = inst
    self.current = 0
    self.duration = 0

    --累加, 一段时间不受攻击则消失
    --叠满后爆发, 强制硬直, 并大幅降低攻速 移速 攻击力, 持续一段时间, 随后移除

end)

local GetOffset = require 'components/util/sayaka_darkness_debuff_offset'

function darkdebuff:OnHit(addvalue, attacker)
    self.inst:StartUpdatingComponent(self)
    if self.current == 2 then
        return
    end

    self.duration = 10
    local old = self.current
    self.current = self.current + addvalue
    if not self.fx then
        local fx = SpawnPrefab('sayaka_darkness_debuff')
        self.fx = fx
        fx.Follower:FollowSymbol(self.inst.GUID,self.inst.components.combat.hiteffectsymbol, 0, -GetOffset(self.inst),0)
    end
    if old <= 1 and self.current > 1 then
        self.current = 2
        self.fx:StartShine()
        self.inst.components.combat:AddDamageModifier(self, - 0.2)
        self.inst.components.combat:AddPeriodModifier(self, 0.2)
        if self.inst.components.locomotor then
            self.inst.components.locomotor:AddSpeedModifier_Mult(self, - 0.1)
        end
        if self.inst.sg and not (self.inst.components.health and self.inst.components.health:IsDead()) then
            if self.inst.sg:HasStateTag('abouttoattack') or self.inst.sg:HasStateTag('attack') then
                if attacker and attacker.components.talker then
                    attacker.components.talker:Say(PUELLA_MOD_SETTINGS.LANGUAGE and 'Feel the darkness.' or '你感受过真正的黑暗吗?')
                end
            end
            self.inst.sg:GoToState('hit')
        end
    end
end

function darkdebuff:ApplyFx()
    if self.fx then
        self.fx.SetIntensity(self.current)
    end
end


function darkdebuff:OnUpdate(dt)
    self:ApplyFx()
    if self.duration > 0 then
        self.duration = self.duration - dt
        if self.duration <= 0 then
            if self.inst.components.combat then
                self.inst.components.combat:RemoveDamageModifier(self)
                self.inst.components.combat:RemovePeriodModifier(self)
            end
            if self.inst.components.locomotor then
                self.inst.components.locomotor:RemoveSpeedModifier_Mult(self)
            end
            self.fx:Fade()
            self.fx = nil
            self.current = 0
            self.inst:StopUpdatingComponent(self)
        end
    end
end

function darkdebuff:OnSave()
    return {current = self.current, duration = self.duration}
end

function darkdebuff:OnLoad(data)
    self.current = data.current
    self.duration = data.duration
end

function darkdebuff:GetDebugString()
    return string.format("dark stack: %s    duration: %s ",self.current,self.duration)
end

return darkdebuff
