local colours =
{
	.2,.4,
	.6,.6,.6,
	.5,.4,.3,.2,.1,0,
}

local sayaka_healed = Class(function(self, inst)
    self.inst = inst
    self.counter = 0
    self.health_player = 5
    self.health_creature = 20

end)
function sayaka_healed:Heal( )
	if self.inst:HasTag("player")then
		self.inst.components.health:DoDelta(self.health_player)
	else
		self.inst.components.health:DoDelta(self.health_creature)
	end
	self:Shine()
end


function sayaka_healed:Shine()
	if not self.inst.AnimState then return end
	self.sayaka_heal_fx_task = self.inst:DoPeriodicTask(1/30,function ()
		self.counter = self.counter + 1
		local colour = colours[self.counter]
		if colour then
			self.inst.AnimState:SetAddColour(colour,colour,colour,1)
		else
			self.sayaka_heal_fx_task:Cancel()
			self.counter = 0
		end
	end)
end

function sayaka_healed:ReviveShine()
	if not self.inst.AnimState then return end
	self.soulgem_revive_shine_task = self.inst:DoPeriodicTask(1/30,function ()
		self.counter = self.counter + 1
		local alpha = colours[self.counter]
		local colour = self.inst.themecolour
		if colour and alpha then
			self.inst.AnimState:SetAddColour(colour[1]*alpha,colour[2]*alpha,colour[3]*alpha,1)
		else
			self.soulgem_revive_shine_task:Cancel()
			self.counter = 0
		end
	end)
end

return sayaka_healed
