----世界标签：homuraTag_pause
----世界事件：start_homuraTag_pause / end_homuraTag_pause

----这是关于晓美焰时间停止技能的主代码
----小部分代码不适用于联机版
local magic_time = 8
local cd = 20

local skill_homura = Class(function(self, inst)
    self.inst = inst
    self.ready_time = .4
    self.left_cd = 0
    self.left_time = 0
    self.left_ready_time = 0

    self.inst:StartUpdatingComponent(self)
    self.inst:ListenForEvent("itemget",function(inst,data)
    	if data and data.item and not data.item.components.ignoretimemagic and not data.item:HasTag("ignoretimemagic")then
    		data.item:AddComponent("ignoretimemagic")
    	end
    end)

	self.inst:ListenForEvent("newstate",function (inst,data)
		local name = data and data.statename
		local states = {"electrocute","hit","sneeze","freeze","vacuumedin","vacuumedheld","vacuumedout"}
		for _,v in pairs(states)do
			if name == v then
				self:OnAttacked()
				break
			end
		end
	end)
    
    self.inst:ListenForEvent("death",function(inst)
    	if self.left_time > 0 then
    		self.left_time = -1
    		self:EndSkill()
    	end
    end)

    self.inst:AddComponent('skill_homura_main')
    self.maincom = self.inst.components.skill_homura_main
end)


local function fn(...)end --空函数

-----------------------------------------------
local function pauseprecip()  				--用于将降雨和降雪悬停在空中
	local rain = GetSeasonManager().rain
	local snow = GetSeasonManager().snow
	local hail = GetSeasonManager().hail
	local pollen = GetSeasonManager().pollen
	local ash = GetWorld().components.volcanoambience and GetWorld().components.volcanoambience.ash
	if rain then
		rain.ParticleEmitter:SetDragCoefficient(1)
		rain.splashes_per_tick = 0
	end
	if snow then
		snow.ParticleEmitter:SetDragCoefficient(1)
	end
	if hail then
		hail.ParticleEmitter:SetDragCoefficient(1)
		hail.splashes_per_tick = 0
		hail.ice_per_tick = 0
		--hail.hail_rate = 0
	end
	if pollen then
		pollen.ParticleEmitter:SetDragCoefficient(1)
	end
	if ash then
		ash.ParticleEmitter:SetDragCoefficient(1)
	end
	GetWorld().SoundEmitter:SetVolume("rain",0)
end

local function resumeprecip()
	local rain = GetSeasonManager().rain
	local snow = GetSeasonManager().snow
	local hail = GetSeasonManager().hail
	local pollen = GetSeasonManager().pollen
	local ash = GetWorld().components.volcanoambience and GetWorld().components.volcanoambience.ash
	if rain then
		rain.ParticleEmitter:SetDragCoefficient(.2)
		rain.ParticleEmitter:SetMaxLifetime(2)
	end
	if snow then
		snow.ParticleEmitter:SetDragCoefficient(.8)
	end
	if hail then
		hail.ParticleEmitter:SetDragCoefficient(.2)
	end
	if pollen then
		pollen.ParticleEmitter:SetDragCoefficient(.0001)
	end
	if ash then
		ash.ParticleEmitter:SetDragCoefficient(.8)
	end
	GetWorld().SoundEmitter:SetVolume("rain",1)
end
----------------------------------------------
local function shutdownAMB()
	local amb = GetWorld().components.ambientsoundmixer
	local amb_ruin = GetWorld().components.nightmareambientsoundmixer
	if amb then
		for _,v in pairs(amb.playing_sounds)do
			GetWorld().SoundEmitter:SetVolume(v.sound, 0)
		end
		GetWorld().SoundEmitter:SetVolume("waves",0)
	end
	if amb_ruin then
		amb_ruin:SetSoundParam(0)
	end
end
local function resumeAMB() ---for nightmare
	local amb_ruin = GetWorld().components.nightmareambientsoundmixer
	local phase = GetWorld().components.nightmareclock 
	if amb_ruin and phase and phase.phase then
		local table = {calm=0,nightmare=2,warn=1,dawn=1,}
		local val = table[phase.phase]
		amb_ruin:SetSoundParam(val)
	end
end
-----------------------------------------------
local function pauseHUD(inst)
	local clock = inst.HUD and inst.HUD.controls.clock
	if clock and clock.anim then
		clock.anim:GetAnimState():Pause()
	end
	local leave_1 = inst.HUD.leavesTop
	local clouds = inst.HUD.clouds
	local leave_2 = inst.HUD.leaves
	local fog = inst.HUD.oceanfog
	local smoke = inst.HUD.smoke
	if inst.HUD.UpdateLeaves and not inst.HUD.M_UpdateLeaves then
		inst.HUD.M_UpdateLeaves = inst.HUD.UpdateLeaves
	end
	inst.HUD.UpdateLeaves = fn
	if clouds then
		clouds:GetAnimState():Pause()
	end
	if leave_1 then
		leave_1:GetAnimState():Pause()
	end
	if leave_2 then
		leave_2:GetAnimState():Pause()
	end
	if fog then
		fog:GetAnimState():Pause()
	end
	if smoke then
		smoke:GetAnimState():Pause()
	end
end

local function resumeHUD(inst)
	local clock = inst.HUD.controls.clock
	if clock and clock.anim then
		clock.anim:GetAnimState():Resume()
	end
	local leave_1 = inst.HUD.leavesTop
	local clouds = inst.HUD.clouds
	local leave_2 = inst.HUD.leaves
	local fog = inst.HUD.oceanfog
	local smoke = inst.HUD.smoke
	if inst.HUD.M_UpdateLeaves then
		inst.HUD.UpdateLeaves = inst.HUD.M_UpdateLeaves
	end
	if clouds then
		clouds:GetAnimState():Resume()
	end
	if leave_1 then
		leave_1:GetAnimState():Resume()
	end
	if leave_2 then
		leave_2:GetAnimState():Resume()
	end
	if fog then
		fog:GetAnimState():Resume()
	end
	if smoke then
		smoke:GetAnimState():Resume()
	end
end 
-----------------------------------------------
local function AddIgnoreTag(inst)
	if inst.components.drivable then
		if inst.components.drivable.driver then
			inst:AddTag("ignoretimemagic")
		else
			inst:RemoveTag("ignoretimemagic")
		end
	end
	if inst.components.prototyper or inst:HasTag("homura_prototyper") then
		inst:AddTag("ignoretimemagic")
	end
	if inst.components.container then
		if inst.components.container:IsOpen() then
			inst:AddTag('ignoretimemagic')
		else 
			inst:RemoveTag('ignoretimemagic')
		end
	end
	if inst.components.projectile or inst.components.throwable then
		if not inst.components.ignoretimemagic then
			inst:AddComponent("ignoretimemagic")
			inst.components.ignoretimemagic:Set(0)
		end
	end
end

function skill_homura:OnTrigger()
	if self.left_cd <= 0 and self.left_time <= 0 and self.left_ready_time <=0 then 	
		print('homura skill: start')	
		self:GetReady()
		return "SUCCESS"
	elseif self.left_time > 0 then
		return "ACTIVATE"
	elseif self.left_ready_time > 0 then 
		return
	elseif self.left_cd > 0 then 
		return "CD"
	end
end

function skill_homura:GetReady() --前摇
	self.left_ready_time = self.ready_time
	self.ongetready()
end

function skill_homura:OnAttacked(data) --硬直会打断技能
    self.left_ready_time = -1
    self.oninterrupt()
end

function skill_homura:UseSkill(dt)
	self.onstarttp()
	self.left_time = magic_time 
	self:StartPauseFn()
end

function skill_homura:StartPauseFn()
	self.maincom:Enable(true)
	GetWorld():PushEvent("start_homuraTag_pause")
	GetWorld():AddTag("homuraTag_pause")
	self.inst:AddTag("puella_skill")
	shutdownAMB()
	pauseprecip()
	pauseHUD(self.inst)
	local ccm = GetWorld() and GetWorld().components.colourcubemanager
	if ccm then                            
		local cc = "images/colour_cubes/homura_cc.tex"   --黑白滤镜
      	ccm:SetOverrideColourCube(resolvefilepath(cc,0))
    end
	--GetWorld().WaveComponent:SetWaveMotion(.3, .5, .35) 
	--local wave = GetWorld().WaveComponent or GetWorld().CloudComponent
	--wave:Pause()
	--单机版的巨人国海浪运动无法被代码控制   2018.12.18 
	--联机版旧神归来更新, WaveComponent不复存在
	--看来这个问题永远解决不了喽  2019.8.23 
end

function skill_homura:EndSkill()
	self.maincom:Enable(false)
	GetWorld():RemoveTag("homuraTag_pause")
	GetWorld():PushEvent("end_homuraTag_pause")
	self.inst:RemoveTag("puella_skill")
	self.onendtp()
	--self.inst:PushEvent("endtp")
	resumeAMB()
	resumeprecip()
	resumeHUD(self.inst)
	
	self.left_cd = cd
	local ccm = GetWorld() and GetWorld().components.colourcubemanager
	if ccm then                      
      	ccm:SetOverrideColourCube(nil,0)
    end
end

function skill_homura:OnSave( )
	return {left_cd = self.left_cd,left_time = self.left_time}
end

function skill_homura:OnLoad(data)
	if data then
		self.left_cd = data.left_cd
	end
end

function skill_homura:GetLeft() -- 剩余cd，剩余cd比例，剩余时间，准备时间
	return 
	self.left_cd,
	math.max(self.left_cd / cd ,0),
	self.left_time,
	self.left_ready_time
end

function skill_homura:IsKrampedEnabled()
	return self.left_cd <= cd - 1.5 and self.left_time <= 0 
end

function skill_homura:OnUpdate(dt)
	if self.left_cd > 0 then
		self.left_cd = self.left_cd - dt
		if self.left_cd <= 0 then
			self.inst:PushEvent("cooldown")
		end
	end
	
	if self.left_time > 0 then
		self.left_time = self.left_time - dt
		if self.left_time <= 0 then
			self:EndSkill()
		elseif self.inst.components.health:IsDead()then
			self:EndSkill()
			self.left_time = -1
		end
	end

	if self.left_ready_time > 0 then
		self.left_ready_time = self.left_ready_time - dt
		if self.left_ready_time <= 0 then
			self:UseSkill(dt)
		end
	end
end

return skill_homura
