return Class(function(self, inst)

local radius = 60
local enabled = false
local items = {}
local IsMagicImmue = PUELLA_MOD_FN.tu_IsIgnoring

local function ItemTimeMagicStart(item)
	PUELLA_MOD_FN.tu_Start(item)
end

local function ItemTimeMagicStop(item)
	PUELLA_MOD_FN.tu_Stop(item)
end

local function ItemTimeMagicUpdate(item, dt)
	PUELLA_MOD_FN.tu_Update(item, dt)
end

local function AddItem(item)
	items[item] = 2
	ItemTimeMagicStart(item)
end

local function RemoveItem(item)
	items[item] = nil
	ItemTimeMagicStop(item)
end

local function OnUpdate(dt)

	--预先自检
	for k in pairs(items)do
		if IsMagicImmue(k) then
			RemoveItem(k)
		end
	end

	local ignoretags = {"INLIMBO", "homura", "homuraTag_ignoretimemagic"}
	local player = inst
	if enabled then
		local x,y,z = player:GetPosition():Get()
		local ents = TheSim:FindEntities(x,y,z, radius, nil, ignoretags)
		for _, item in pairs(ents)do
			if not IsMagicImmue(item) then 
				if not items[item] then
					AddItem(item)
				else
					items[item] = 2
				end
			end
		end
	end

	for k,v in pairs(items)do
		if v == 1 then 
			RemoveItem(k)
		end
		if v == 2 then 
			items[k] = 1
			ItemTimeMagicUpdate(k, dt)
		end
	end

	if not enabled then 
		inst:StopUpdatingComponent(self)
	end
end

function self:OnUpdate(dt)
	OnUpdate(dt)
end

function self:Enable(vel)
	enabled = vel
	if vel then
		inst:StartUpdatingComponent(self)
	end
end

function self:IsEntityInRange(ent)
	if ent and ent:IsValid() and ent.Transform then
		if inst:GetDistanceSqToInst(ent) <= MAGIC_RADIUS * MAGIC_RADIUS then
			return true
		end
	end
end

end)



