local skill_kyouko = Class(function(self, inst)
    self.inst = inst
    self.power = 60
    self.maxpower = 60
    --self.left_cd = 0
    self.left_time = 0

    inst:DoTaskInTime(0,function()self:MakeFx()end)
    inst:ListenForEvent('death',function()self.shield:hidefn()end)
    local newdodelta = require("prefabs/kyouko_lockhealth");newdodelta(inst)

    inst:AddComponent('skill_kyouko_sweep')
end)

function skill_kyouko:MakeFx()
	self.shield = SpawnPrefab("kyouko_shield")
    self.shield.entity:SetParent(self.inst.entity)
    self.shield.Transform:SetPosition(0,1.5,0)
    self.shield:hidefn()
end

function skill_kyouko:OnTrigger()
	self.inst:PushEvent("skill_incd")
end

function skill_kyouko:UseSkill(overflow) --被动触发
	if self:IsActivated() then
		self.left_time = 7.5
		if overflow then
			self.shield:boostfn()
		else
			self.shield:shakefn()
		end
	else
		self:Start()
	end
end

function skill_kyouko:IsAvailable()
	local components = self.inst.components
	return components.soulgem.current < 200 and components.magicalcharge.state == 3 and not components.health:IsDead()
end

function skill_kyouko:IsActivated()
	return self.left_time > 0
end

function skill_kyouko:OnSave( )
	return {power = self.power}
end
function skill_kyouko:OnLoad(data)
	self.power = data and data.power or self.power
end

function skill_kyouko:GetLeftPower()    --护盾值
	return self.power,self.power / self.maxpower
end

function skill_kyouko:Start()
	self.left_time = 7.5
	self.inst:StartUpdatingComponent(self)
	self.shield:boostfn()
	local line = PUELLA_MOD_SETTINGS.LANGUAGE and "You can't defeat me!" or "这种程度的攻击... 不值一提！"
	self.inst.components.talker:Say(line)
end

function skill_kyouko:End()
	if self.shield then
		self.shield:fadefn()
	end
end

function skill_kyouko:Charge(dt)
	local per_second = 1
	local recover = per_second*dt
	local rate = 0.2   --1/5
	local magic_consume = rate * recover
	self.inst.components.soulgem:DoDelta(magic_consume,true)
	self:DoDelta(recover)
end

function skill_kyouko:Calc(deltavalue) --传入正数 
	local health = self.inst.components.health.currenthealth
	local absorb,realdelta
	if health <= 1 then
		realdelta = 0
		absorb = deltavalue
	else
		realdelta = health-1 --留1血
		absorb = deltavalue - realdelta
	end
	--self:OnAbosrbDamage(absorb)
	--return -realdelta
	self:OnAbosrbDamage(deltavalue)
	return 0
end

function skill_kyouko:OnAbosrbDamage(absorb)
	print("absorb"..absorb)
	local overflow = false --是否溢出
	if absorb>self.power then
		overflow = true
		self:DoDelta(-self.power)
		self.inst.components.soulgem:DoDelta(math.min(self.maxpower,absorb-self.power)) --多余伤害由sg承受
	else
		self:DoDelta(-absorb)
	end
	self:UseSkill(overflow)
end

function skill_kyouko:DoDelta(d)
	local new = self.power + d
	new = math.min(self.maxpower,new)
	self.power = new
end

function skill_kyouko:OnUpdate(dt)
	--print(self.power)
	if self.power < self.maxpower then
		self:Charge(dt)
	end
	if self.left_time > 0 then
		self.left_time = self.left_time - dt
		if self.left_time <= 0 then
			self.left_time = 0
			self:End()
		end
	end
	if self.power >= self.maxpower and not self:IsActivated() then
		self.inst:StopUpdatingComponent(self)
	end
end

return skill_kyouko
