--事件表
--useskill 成功使用技能
--skill_incd  技能未冷却  
--sayaka: undateskill 刷新技能 1/2 使widget刷新图标 传递skill
--cooldown  冷却完成瞬间

--[[
1.治疗术 主动&键位 cd = 30   san > 0.15
2.突进  主动&武器  cd = 20 (每成功躲避一次攻击减少50%(线性, san > 0), 并获得10s的攻速和移速buff)

3.暗影  被动 受攻击10%/发动攻击2% 时触发 理智越低几率越大  内置cd = 5 ,duration = 3~7(线性), 快速耗蓝(线性), 部分免伤(线性), 免疫冰冻中毒雷电燃烧
4.弱化  被动 被命中目标附带标记，引爆时强制硬直，[打断攻击state后有台词] 降低移速和伤害 (暗影生物无效)

]]

local function SayakaApplyDamage(inst, damage, attacker, weapon) 
	--local sanpercent = inst.components.sanity:GetPercent()
	local self = inst.components.skill_sayaka
	if damage > 0 and inst.sg:HasStateTag('sayaka_lunge') then
		self.speedboost_duration = 10
		self.lunge_cd = self.lunge_cd * (1-self:San()*0.75)
		return 0
	end
	return damage
end
--[[
local function speedimmue_on(inst)
	PUELLA_MOD_FN.Change(inst,"locomotor","GetSpeedMultiplier",PUELLA_MOD_FN.Sayaka_GetSpeedMultiplier)
	PUELLA_MOD_FN.Change(inst,"locomotor","UpdateGroundSpeedMultiplier",PUELLA_MOD_FN.Sayaka_UpdateGroundSpeedMultiplier) 
	inst:AddTag("twister_immue")
end

local function speedimmue_off(inst)
	PUELLA_MOD_FN.Restore(inst,"locomotor","GetSpeedMultiplier")
	PUELLA_MOD_FN.Restore(inst,"locomotor","UpdateGroundSpeedMultiplier")
	inst:RemoveTag("twister_immue")
end

local function startignoringwater(inst,self)
	inst.components.moisture.GetDelta = function()return 0 end
	if not self.dry_task then
		self.dry_task = inst:DoPeriodicTask(0,function()inst.components.moisture:DoDelta(-10)end)
	end
end

local function stopignoringwater(inst,self)
	inst.components.moisture.GetDelta = function(self)return self.delta end
	if self.dry_task then
		self.dry_task:Cancel()
		self.dry_task = nil
	end
end
--]]

local lunge_cd = 10--0
local heal_cd = 30
local darkness_cd = 10

local skill_sayaka = Class(function(self, inst)
    self.inst = inst
    self.lunge_cd = 0 
    self.heal_cd = 0
    self.darkness_cd = 0

    self.darkness_duration = 0
    self.darkness_duration_max = 10
    self.speedboost_duration = 0

    self.skillname = 1

    local old_applydamage = inst.components.inventory.ApplyDamage --新添加一个闪避接口
    inst.components.inventory.ApplyDamage = function(com, damage, attacker, weapon,...)
    	damage = SayakaApplyDamage(inst, damage, attacker, weapon)
    	if damage > 0 then
    		return old_applydamage(com, damage, attacker, weapon, ...)
    	else
    		return 0
    	end
    end

    local old_dodelta = inst.components.health.DoDelta
    inst.components.health.DoDelta = function(com, delta, ...) --新添加一个免伤接口
    	if self.absorb and delta < 0 then
    		return old_dodelta(com, (1-self.absorb)*delta, ...)
    	end
    	return old_dodelta(com, delta, ...)
    end

    inst:DoTaskInTime(0,function()self:UpdateSkillName()end)
    inst:ListenForEvent("sanitydelta",function (_,d) self:UpdateSkillName(d.oldpercent,d.newpercent)end)

    inst:ListenForEvent('onhitother',function() self:TryEnterDarkState(0.05) end)
    inst:ListenForEvent('attacked', function() self:TryEnterDarkState(0.2) end)

    inst:ListenForEvent('onhitother', function(_,data) self:AddDarknessToTarget(data) end)

    inst:StartUpdatingComponent(self)
end)

local function IsCharge(inst)
	return inst.components.magicalcharge and inst.components.magicalcharge.state == 3
end

function skill_sayaka:CanLunge()
	return IsCharge(self.inst) and self.lunge_cd <= 0
end

function skill_sayaka:OnLunge()
	self.lunge_cd = lunge_cd
end

function skill_sayaka:OnTrigger()
	if not IsCharge(self.inst) then
		return "LOCK"
	elseif self.skillname == 1 and self.heal_cd <= 0 then --只有治疗术为主动技能
		self:Heal()
		return 'SUCCESS'
	elseif self.skillname == 1 then
		return 'CD'
	else
		return 'PASSIVE'
	end
end

function skill_sayaka:Heal() --释放治疗环, 技能进入cd
	local pos = self.inst:GetPosition()
	if pos then
		local fx = SpawnPrefab("sayaka_heal")
		fx.Transform:SetPosition(pos:Get())
		fx.caster = self.inst
	end
	self.heal_cd = heal_cd
end

local function SpawnFire(pos)
	local inst = PUELLA_MOD_FN.CreateEntity() --这里, 直接用CreateEntity函数会导致崩溃, 原因不明...
	
	inst.AnimState:SetBank('lavaarena_player_teleport')
	inst.AnimState:SetBuild('lavaarena_player_teleport_pmmm')
	inst.AnimState:PlayAnimation('idle')
	inst.AnimState:SetMultColour(0.2,0.2,0.2,1)
	inst.AnimState:SetTime(0.3)

	inst:ListenForEvent('animover', inst.Remove)
	inst.Transform:SetScale(0.8,0.8,0.8)

	return inst
end

local function GetLine()
	local table = PUELLA_MOD_SETTINGS.LANGUAGE and 
	{
		'',
		'',
	}
	or 
	{
		'够了!',
		'哈哈哈哈哈...',
		'只要有心, 疼痛这种东西, 完全就可以消除.',
	}
	return table[math.random(#table)]
end



function skill_sayaka:AddDarknessToTarget(data)
	do return end --暂不启用
	if not (data and data.target) then--@-- or self.darkness_duration <= 0 then
		return
	end
	local target = data.target
	if target ~= self.inst and not target:HasTag('shadow') and not target:HasTag('witch_sd') then
		target.components.sayaka_darkness_debuff:OnHit(Remap(self:San(), 0.15, 0, 0.1, 0.3), self.inst)
	end
end

function skill_sayaka:TryEnterDarkState(rate)
	if not IsCharge(self.inst) then
		return
	end
	if self.darkness_cd > 0 or self.darkness_duration > 0 or self:San() >= 0.15 or math.random() > rate then
		return
	end
	self:Dark()
end

function skill_sayaka:Dark()
	SpawnFire().Transform:SetPosition(self.inst:GetPosition():Get())
	self.inst.AnimState:SetMultColour(0,0,0,.8)
	self.inst:AddTag("sayaka_dark","sayaka_inshadow")
	self.inst:AddTag("puella_skill")

	self.inst.components.inventory.insulated = true
	self.inst.components.freezable.is_freeze_immue = true
	self.inst.components.poisonable:SetBlockAll(true)

	self.darkness_duration = Remap(self.inst.components.sanity:GetPercent(), 0.15, 0, 4, 12)
	self.darkness_duration_max = self.darkness_duration

	--speedimmue_on(self.inst)--免疫减速（同时无视飓风的加速）

	if math.random() < 0.33 then
		self.inst.components.talker:Say(GetLine())
	end
	if self.onstartdark then
		self.onstartdark()
	end
end

function skill_sayaka:EndSkill2()
	self.inst.AnimState:SetMultColour(1,1,1,1)
	self.inst:RemoveTag("sayaka_dark","sayaka_inshadow")
	self.inst:RemoveTag("puella_skill")

	self.inst.components.inventory.insulated = false
	self.inst.components.freezable.is_freeze_immue = false
	self.inst.components.poisonable:SetBlockAll(false)
	--speedimmue_off(self.inst)

	if self.onenddark then
		self.onenddark()
	end

	self.darkness_cd = 10
end

local function FxFn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	anim:SetBank("sayaka_heal");anim:SetBuild("sayaka_heal");
	anim:PlayAnimation("enter");anim:PushAnimation("loop");
	local s = GetRandomMinMax(.05,.15)
	trans:SetScale(s,s,1)
	local c = GetRandomMinMax(0,1)
	anim:SetMultColour(c,c,c,1)
	inst:AddComponent("colourtweener")
	inst:DoTaskInTime(GetRandomMinMax(1,2),function ()
		inst.components.colourtweener:StartTween({0,0,0,0},.5,inst.Remove)
	end)
	inst:AddTag("NOCLICK")
	inst:AddTag("FX")
	inst:AddTag("ignoretimemagic")

	return inst
end

local function SpawnFx(player)
	if math.random() > 0.3 then --密度控制
		return
	end
	local fx = FxFn()
	local offset = Vector3(GetRandomMinMax(-.7,.7),GetRandomMinMax(0,1.4)+1,GetRandomMinMax(-.7,.7))
	fx.Transform:SetPosition((player:GetPosition()+offset):Get())
end

function skill_sayaka:OnSave( )
	return {heal_cd = self.heal_cd,darkness_cd = self.darkness_cd,lunge_cd = self.lunge_cd}
end

function skill_sayaka:OnLoad(data) --2技能的持续时间比较短, 干脆不保存了!
	if data then
		self.heal_cd = data.heal_cd
		self.darkness_cd = data.darkness_cd
		self.lunge_cd = data.lunge_cd
	end
end

function skill_sayaka:GetLeftTime() --返回值 1.剩余冷却时间 2.剩余冷却百分比/剩余技能百分比
	if self.skillname == 1 then
		return self.heal_cd, math.max(self.heal_cd / heal_cd,0)
	else
		return self.darkness_cd, math.max(self.darkness_cd / darkness_cd,0),
		self.darkness_duration, math.max(self.darkness_duration / self.darkness_duration_max, 0)
	end
end

function skill_sayaka:UpdateSkillName(old,new)
	if not old then 
		if self.inst.components.sanity:GetPercent() < 0.15 then
			self.skillname = 2
			self.inst:PushEvent('sayaka: undateskill',2)
		end
		return
	end

	if new <= 0.15 and old > 0.15 then
		self.skillname = 2
		self.inst:PushEvent('sayaka: undateskill',2)
	elseif new > 0.15 and old <= 0.15 then
		self.skillname = 1
		self.inst:PushEvent('sayaka: undateskill',1)
	end	
end

function skill_sayaka:OnUpdate(dt)
	if self.lunge_cd > 0 then
		self.lunge_cd = self.lunge_cd - dt
		self.inst:PushEvent('rechargechange', {percent= 1-self.lunge_cd/lunge_cd})
	end
	
	if self.heal_cd > 0 then
		self.heal_cd = self.heal_cd - dt
		if self.heal_cd <= 0 then
			self.inst:PushEvent("cooldown",1)
		end
	end
	if self.darkness_cd > 0 then
		self.darkness_cd = self.darkness_cd - dt
		if self.darkness_cd <= 0 then
			self.inst:PushEvent("cooldown",2)
		end
	end

	--冲刺移速加成
	if self.speedboost_duration > 0 then
		self.speedboost_duration = self.speedboost_duration - dt
		local period = Remap(self:San(), 1, 0.5, -0.2, 0)
		local speed = Remap(self:San(), 1, 0.5, 0.25, 0)
		self.inst.components.combat:AddPeriodModifier(self,period)
		self.inst.components.locomotor:AddSpeedModifier_Mult(self,speed)
	else
		self.inst.components.combat:RemoveDamageModifier(self)
		self.inst.components.locomotor:RemoveSpeedModifier_Mult(self)
	end

	--2技能效果刷新
	if self.darkness_duration > 0 then 

		local old = self.darkness_duration
		self.darkness_duration = self.darkness_duration - dt
		if math.floor(self.darkness_duration) < math.floor(old) then
			self.inst.components.soulgem:DoDelta(Remap(self.inst.components.sanity:GetPercent(),0,0.15,1.2,0.4))
		end

		if self.darkness_duration <= 0 then
			self:EndSkill2()
			self.absorb = 0
			if not self.inst.components.inventory:EquipHasTag('venting')then
				self.inst:RemoveTag("venting")
			end
			return
		end
		-----

		self.inst:AddTag("venting")
		SpawnFx(self.inst)
		self.absorb = Remap(self:San(), 0.15, 0, 0.6, 0.3)
	end
end

function skill_sayaka:San()
	return self.inst.components.sanity:GetPercent(), self.inst.components.sanity.current
end

return skill_sayaka
