--[[
素材路径: lw_bgm/witchbattle1/
pre 长度 23.3秒 = 23 + 9*FRAMES
loop 长度 96.05秒 = 96 + 1.5*FRAMES

这里我并没有解决无缝循环的问题，我认为在fmod工程里应该是有参数可以设置的，但是还没找到。
不得已，只能用WallUpdate方法来实现循环。

---当前参数------------------
Bank type: Stream from disk
Compression: mp3
Max streams: 128
Enable syncpoints: No
----------------------------
]]
local PRE_TIME_1 = 23 + 7*FRAMES
local LOOP_TIME_1 = 96 + (-1)*FRAMES

local STEP = 0.2/30

local WitchBattleBGM = Class(function(self, inst)
    self.inst = inst
    self.inst:StartUpdatingComponent(self)
    
    self.enabled = true --PUELLA_MOD_SETTINGS and PUELLA_MOD_SETTINGS.MUSIC
    
    self.witch_time = 0
    self.next_bgm_time = 0
    
    self.inst:ListenForEvent("attacked", function(inst, dat)
        if self.enabled and dat.attacker and dat.attacker:HasTag("witch") then
            self:OnCombat(dat.attacker)
            --[[
            if dat.attacker:HasTag("witch_mn") then
                self:StartWitchBGM(dat.attacker)
            elseif dat.attacker:HasTag("witch_sm")then
                self:RefreshWitchBGM(dat.attacker)
            end
            --]]
        end
    end )  
    self.inst:ListenForEvent("doattack", function(inst, dat)
        if self.enabled and dat.target  and dat.target:HasTag("witch") then
            self:OnCombat(dat.target)
            --[[
            if dat.target:HasTag("witch_mn") then
                self:StartWitchBGM(dat.target)
            elseif  dat.target:HasTag("witch_sm")then
                self:RefreshWitchBGM(dat.target)
            end
            --]]
        end	
	end )  
    self.inst:ListenForEvent("entity_death",function (inst,data)
        if data and data.inst and data.inst:HasTag("witch") and data.inst:HasTag("witch_mn")then
            self:StopPlaying()
        end
    end, GetWorld())
    self.inst:ListenForEvent("resurrect", function(inst)
        --self:StopWitchBGM()
    end) 
    self.intensity = 0
    self.target_intensity = 0

    self:Init()

    self.inst:StartWallUpdatingComponent(self)
end)

function WitchBattleBGM:Init()
    self.snd_pre = CreateEntity().entity:AddSoundEmitter()
    self.snd_loop1 = CreateEntity().entity:AddSoundEmitter()
    self.snd_loop2 = CreateEntity().entity:AddSoundEmitter()
end

local function GetBgmPath(witch) --暂时还用不到
    return "lw_bgm/witchbattle1/"
end

function WitchBattleBGM:OnCombat(witch)
    if self.inst.SoundEmitter:PlayingSound("erupt") then 
        return 
    end
    if witch then
        --local path = GetBgmPath(witch)
        if not self.playing then
            self:StartPlaying()
        else
            self:SetTargetIntensity(0.5)
        end
    end
    self.witch_time = 10
    self.inst:StartUpdatingComponent(self)
end

function WitchBattleBGM:StartPlaying() --启动一个新的播放任务
    self.stop = false
    self.playing = true
    self:StartNextSound(true)
    self:SetTargetIntensity(0.5, true)
end

function WitchBattleBGM:StopPlaying()
    self:SetTargetIntensity(0)
    self.stop = true --在update判定
end

function WitchBattleBGM:Silence()
    self:SetTargetIntensity(0)
end

function WitchBattleBGM:SurpressNormalBGM()
    self.inst.SoundEmitter:KillSound("dawn")
    local cmp = GetPlayer().components.dynamicmusic
    if cmp then
        for _,v in pairs({'StopPlayingDanger','StopPlayingBusy','StopPlayingTone','StopPlayingSurfing','StopPlayingBoating'})do
            if cmp[v] then
                local fn = cmp[v]
                fn(cmp)
            end
        end
    end
end

function WitchBattleBGM:OnUpdate(dt)
    if self.witch_time > 0 and not self.inst.components.health:IsDead()then
        self.witch_time = self.witch_time - dt
        self:SurpressNormalBGM()
        if self.witch_time <= 0 then
            self:Silence()
        end
    end  
    --模拟fmod的seek
    if self.target_intensity > self.intensity then
        self.intensity = math.min(self.intensity + STEP, self.target_intensity)
    else
        self.intensity = math.max(self.intensity - STEP, self.target_intensity)
    end
    self:SetParameter(self.intensity)

    if self.stop and self.intensity == 0 then
        self:KillAllSounds()
        print('kill all sounds')
    end

    if self.intensity == self.target_intensity and self.witch_time <= 0 then
        self.inst:StopUpdatingComponent(self)
    end

    print(self.playing)
    print('go to stop', self.stop)
    print(self.intensity)
end

function WitchBattleBGM:StartNextSound(first)
    --print("-----START-----")
    if first then
        self.snd_pre:PlaySound('lw_bgm/witchbattle1/pre', 'bgm')
        self.next_bgm_time = PRE_TIME_1
    elseif self.playing_loop == 2 then
        self.snd_loop1:PlaySound('lw_bgm/witchbattle1/loop', 'bgm')
        self.next_bgm_time = LOOP_TIME_1
        self.playing_loop = 1
    else
        self.snd_loop2:PlaySound('lw_bgm/witchbattle1/loop', 'bgm')
        self.next_bgm_time = LOOP_TIME_1
        self.playing_loop = 2
    end
    self.inst:StartUpdatingComponent(self) --为所有snd设置一次音量
end

function WitchBattleBGM:SetTargetIntensity(para, skipwalking)
    self.target_intensity = para or 0
    if skipwalking then
        self.intensity = para or 0
    end
    self.inst:StartUpdatingComponent(self)
end

function WitchBattleBGM:SetParameter(para)
    for _,v in pairs({'snd_pre','snd_loop1','snd_loop2'})do
        self[v]:SetParameter('bgm','intensity',para or 0)
    end
end

function WitchBattleBGM:KillAllSounds(para)
    if para == 'pre' then
        self.snd_pre:KillAllSounds()
    elseif para == 'loop' then
        self.snd_loop1:KillAllSounds()
        self.snd_loop2:KillAllSounds()
    elseif para == nil then
        self.snd_pre:KillAllSounds()
        self.snd_loop1:KillAllSounds()
        self.snd_loop2:KillAllSounds()
        self.playing = false
    end
end

function WitchBattleBGM:OnWallUpdate(dt)
    --print(self.next_bgm_time)
    if self.next_bgm_time > 0 then
        self.next_bgm_time = self.next_bgm_time - dt
        if self.next_bgm_time <= 0 then
            self:StartNextSound()
        end
    end
end

return WitchBattleBGM
