local function GetPhase()
    if GetWorld():IsCave() then
        return 'night' 
    else
        return GetClock():GetPhase()
    end
end

local darkdebuff = Class(function(self, inst)
	
    self.inst = inst
    self.stack = 0
    self.maxstack = 100
    self.attacked_cool_down = 0

    --self.maxstack = 30----------

    --self.can_burst = true --受到debuff溢出的攻击后，进入查理攻击状态（不进入hit），随后短时间内不重复进入该状态
    self.burst_cool_down = 0

end)

function darkdebuff:AddDebuff(stack)
    self.stack = self.stack + stack
    self.attacked_cool_down = 3
    self.inst:StartUpdatingComponent(self)
    self:Apply()
    if self.stack > self.maxstack then
        self.stack = self.maxstack
        if self.burst_cool_down <= 0 then
            self:Burst()
        else
            self.attacked_cool_down = 5
        end
    end
end

local function gotostunstate(inst)
    if not inst.components.health:IsDead() and not inst.sg:HasStateTag('pmmm_invincible') then
        inst:PushEvent('sd_darkattack') 
    end
end

function darkdebuff:Burst()
    self.burst_cool_down = 5
    if GetPhase() == 'day' then
        if self.inst:HasTag('player') then
            self.inst.components.sanity:DoDelta(-5)
        end
    end
    if GetPhase() == 'dusk' then
        if self.inst:HasTag('player') then
            self.inst.components.sanity:DoDelta(-15)
            gotostunstate(self.inst)
        else
            if self.inst.components.health then
                self.inst.components.health:DoDelta(-50)
            end
        end
    end
    if GetPhase() == 'night' then
        if self.inst:HasTag('player') then
            self.inst.components.sanity:DoDelta(-30)
            gotostunstate(self.inst)
        else
            if self.inst.components.health then
                self.inst.components.health:DoDelta(-100)
            end
        end
    end
end

function darkdebuff:RemoveDebuff(instant)
    if instant then
        self.stack = 0
        self.attacked_cool_down = 0
    elseif self.attacked_cool_down <= 0 then
        local rate = 5
        if GetPhase() == 'dusk' then
            rate = 10
        elseif GetPhase() == 'day' then
            rate = 20
        end
        self.stack = self.stack - rate/30
    end
    self:Apply()
end

function darkdebuff:Apply()
    if self.stack > 0 then
        if not self.fx then
            self.fx = SpawnPrefab('poisonbubble')
            self.fx.SoundEmitter:KillAllSounds()
            self.fx.AnimState:SetMultColour(0,0,0,0.7)
            self.fx.entity:SetParent(self.inst.entity)
        end
        if self.inst.HUD then
            local value = math.min(0.7,Remap(self.stack,25,100,0.7,0))
            self.inst.HUD.puellaUI_sgdark:SetAlphaValue(value)  --0.7~0
        end
        
        if self.inst.components.combat then
            local dmgdebuff = math.max(0,Remap(self.stack,25,100,0,0.15))
            self.inst.components.combat:AddDamageModifier(self, -dmgdebuff)
        end

        if self.inst.components.locomotor then
            local speeddebuff = math.max(0,Remap(self.stack,25,100,0,0.1))
            self.inst.components.locomotor:AddSpeedModifier_Mult(self, -speeddebuff)
        end
    else
        if self.fx then
            self.fx:Remove()
            self.fx = nil
        end
        if self.inst.components.combat then
            self.inst.components.combat:RemoveDamageModifier(self)
        end
        if self.inst.components.locomotor then
            self.inst.components.locomotor:RemoveSpeedModifier_Mult(self)
        end
    end
end


function darkdebuff:OnUpdate(dt)
    self.attacked_cool_down = self.attacked_cool_down - dt
    self.burst_cool_down = self.burst_cool_down - dt
    --print(self.stack)
    self:RemoveDebuff()
    if self.stack <= 0 and self.attacked_cool_down <= 0 and self.burst_cool_down <= 0 then
        self.inst:StopUpdatingComponent(self)
    end
end

function darkdebuff:OnSave()
    return {stack=self.stack}
end

function darkdebuff:OnLoad(data)
    self.stack = data.stack or 0
    self:Apply()
end

function darkdebuff:GetDebugString()
    return string.format("dark stack: %s",self.stack)
end

return darkdebuff
