--这个组件依附于玩家
local witchspawner = Class(function(self, inst)
	
    self.inst = inst

    self.left_time = 9.75*480    
    self.can_spawn = false
    self.data = {witch_qw_pos=0,witch_tv_pos=0,witch_sd_pos=0}

    self.gs = 0
    
    --self.inst:StartUpdatingComponent(self)
    self.inst:DoPeriodicTask(1,function()self:DoUpdate(1)end)  
end)

function witchspawner:GetSpawnLocation() -- print(1)
    if TheCamera.interior then
        return
    end
    local pt = GetPlayer():GetPosition()
    local theta = math.random() * 6.283

    for radius = 45,35,-5 do
        local offset = FindGroundOffset(pt, theta, radius,10)
        if offset then
            return pt+offset
        end
    end
end

function witchspawner:OnSearchFailed()
    if not self.can_spawn then
        local delta = math.max(0.5*480, self.left_time * 0.25)
        self.left_time = math.max(1,self.left_time - delta)
    end
end

function witchspawner:GetDist()
    local function _get()
        if not self.witchpos then
            return
        end
        if not self.witchpos:IsValid() then
            if self.witchpos.triggered then
                self.witchpos = nil
                return 'TRIGGERED'
            else
                self.witchpos = nil
                return
            end
        end
        return math.sqrt(self.inst:GetDistanceSqToInst(self.witchpos))
    end

    local Dist = _get()
    if not self.lastDist then
        if not Dist then
            return 10000
        else
            self:Announce('WITCH_APPEAR')
            self.lastDist = Dist
            return Dist
        end
    else
        if not Dist then
            if self.lastDist < 80 then
            self:Announce('WITCH_LOST')
            end
            self.lastDist = Dist
            return 10000
        else
            if Dist == 'TRIGGERED' then
                self.lastDist = nil
                return
            end
            self:Announce(nil,self.lastDist,Dist)
            self.lastDist = Dist
            return Dist
        end
    end
end

function witchspawner:Announce(sit, dist1, dist2)
    if not sit then
        if dist1 >= 20 and dist2 < 20 then
            sit = 'WITCH_NEAR1'
        elseif dist1 >= 40 and dist2 < 40 then
            sit = 'WITCH_NEAR2'
        elseif dist2 >= 30 and dist1 < 30 then
            sit = 'WITCH_FAR1'
        elseif dist2 >= 50 and dist1 < 50 then
            sit = 'WITCH_FAR2'
        elseif dist2 >= 70 and dist1 < 70 then
            sit = 'WITCH_FAR3'
        elseif dist2 >= 100 and dist1 < 100 then
            sit = 'WITCH_VERYFAR_FAR'
        elseif dist1 >= 90 and dist2 < 90 then
            sit = 'WITCH_VERYFAR_NEAR'
        end
    end

    --print(sit)

    if not sit then
        return
    end

    local announce = PUELLA_MOD_STRINGS:Get(self.inst.prefab,sit)
    self.inst.components.talker:Say(announce) 
end


function witchspawner:SpawnAt(pos)
    local prefab = self:SelectWitch()
    local witch = SpawnPrefab(prefab)
    witch:OnSpawn()
    witch.Transform:SetPosition(pos:Get())
    self.witchpos = witch

    self.lastone = prefab
    self.data[prefab] =  self.data[prefab]+1 
end

function witchspawner:SelectWitch()
    local t = {'witch_qw_pos','witch_tv_pos','witch_sd_pos'}
    local nextname = t[math.random(#t)]
    while nextname == self.lastone do
        nextname = t[math.random(#t)]
    end

    return nextname
end
--[[
function witchspawner:SelectWitch()
    local table = {'qw_pos','tv_pos'}
    local canselect = {}   -----------  索引-预制物名 / 值-权重
    local totalweight = 0
    --local maxweight = math.max()
    for _,v in pairs(table)do
        if self.data.lastone ~= v then
            local w = self.data[v]
            canselect[v] = 1/(w+1) --转移权重（生成数越高，权重越低）
            totalweight = totalweight + 1/(w+1)
        end
    end
    -----------------------------------------------
                     --计算刷新率

    local ram = totalweight * math.random() 
    for name,weight in pairs(canselect)do
        ram = ram - weight
        if ram <= 0 then 
            return name
        end
    end
end
]]
function witchspawner:DoUpdate(dt)
    if not GetWorld():HasTag('homuraTag_pause') then
        self:OnUpdate(dt)
    end
end

function witchspawner:OnUpdate(dt)
   -- print(self.left_time,self.can_spawn)
    
    if self.left_time > 0 then
        self.left_time = self.left_time - dt
            
        if self.left_time <= 0 then
            self.can_spawn = true
            self.left_time = self:GetNextSpawnTime()
        end
    end

    if self.can_spawn then
        local pos = self:GetSpawnLocation()
        if pos then
            self:SpawnAt(pos)
            self.can_spawn = false
        end
    end
    self:GetDist()
end

function witchspawner:RemoveGS()
    self.gs = self.gs - 1
end

function witchspawner:AddGS()
    self.gs = self.gs + 1
end

function witchspawner:GetTotalGriefseeds()
    return self.gs 
end

function witchspawner:GetNextSpawnTime()
    local min = 6*480
    local max = 10*480
    local delay = math.max(0, (self.gs-6)*240)
    return GetRandomMinMax(min,max) + delay
end

function witchspawner:LongUpdate(dt)
    self:OnUpdate(dt)
end

function witchspawner:OnSave()
    return {
        left_time = self.left_time,
        lastname = self.lastname,
        can_spawn = self.can_spawn,
        gs = self.gs,
    }
end

function witchspawner:OnLoad(data)
    if data then
        self.left_time = data.left_time
        self.lastname = data.lastname
        self.can_spawn = data.can_spawn
        self.gs = data.gs
    end
end

function witchspawner:ForceReset()
    self.lastone = nil
    self.left_time = 10
end

function witchspawner:GetDebugString()
    local str = ''
    str = str .. string.format("Next witch: %.2f\nTotal grief seeds: %f", self.left_time, self.gs)

    return str
end

return witchspawner
