require("class")
require("util")

--for debug
do return end

local LW_LINKER = Class(function(self)
    self.AnimStateLinker = {}
end)

local LW_LINKER = LW_LINKER()

local addanimstate = Entity.AddAnimState
Entity.AddAnimState = function(ent, ...)
    local userdata = addanimstate(ent, ...)
    local GUID = ent:GetGUID()
    local inst = Ents[GUID]
    if inst and LW_LINKER then
    	if inst.AnimState and LW_LINKER.AnimStateLinker[inst.AnimState] then
    		LW_LINKER.AnimStateLinker[inst.AnimState] = nil
    	end
        LW_LINKER.AnimStateLinker[userdata] = inst
    end
    return userdata
end

-----------AnimState-------------
for k,v in pairs(AnimState)do
	local old_fn = v
	AnimState[k] = function(as, ...)
		local ent = as:GetEntity()
		if ent and ent.components and ent.components.animstatemanager then
			local comfn = ent.components.animstatemanager[k]
			if comfn then
				comfn(ent.components.animstatemanager, ...)
			end
		end
		--print("Run: "..k) --for debug
		return old_fn(as, ...)
	end
end

local getentity = AnimState.GetEntity
AnimState.GetEntity = function(as,...)
    return LW_LINKER and LW_LINKER.AnimStateLinker[as] 
end
