local assets=
{
    Asset("ATLAS", "images/inventoryimages/eegg.xml")
}

local L = PUELLA_MOD_SETTINGS.LANGUAGE 

STRINGS.NAMES.EEGG = L and "easter egg" or "彩蛋"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.EEGG = L and "It's an artwork." or "你就这么喜欢用控制台？？\n----来自作者的吐槽"
STRINGS.CHARACTERS.KYOUKO.DESCRIBE.EEGG = L and "It is BEAUTIFULL!" or "这个很漂亮哦。"

local prefabs = 
{    
    "bird_egg_cooked",
    "rottenegg",
}

local function fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBuild("doydoy_nest")
    inst.AnimState:SetBank("doydoy_nest")
    inst.AnimState:PlayAnimation("idle_egg")

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/eegg.xml"

    inst:AddComponent("edible")
    inst.components.edible.foodtype = "MEAT"
    inst.components.edible.oneaten = function (inst,eater)
        if eater:HasTag("player") and eater.components.talker then
            local line = PUELLA_MOD_STRINGS:Get(eater.prefab,"EEGG")       
            eater.components.talker:Say(line)
        end
    end
--[[
    inst:AddComponent("perishable")
    inst.components.perishable.onperishreplacement = "rottenegg"
    inst.components.perishable:SetPerishTime(120)
    inst.components.perishable:StartPerishing()
--]]
    inst:AddTag("cattoy")
    inst:AddComponent("tradable")
    inst.components.tradable.goldvalue = 10
    inst.components.tradable.dubloonvalue = 10

    inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 15
    inst.components.edible.sanityvalue = -15

    inst:AddComponent("cookable")
    inst.components.cookable.product = "bird_egg_cooked"
    inst:AddComponent("appeasement")
    inst.components.appeasement.appeasementvalue = TUNING.APPEASEMENT_MEDIUM
    return inst
end

-- doydoyegg_cracked is really just here so old saves don't blow up
return Prefab( "common/inventory/eegg", fn, assets, prefabs)