local assets=
{
	Asset("ANIM", "anim/griefseed.zip"),
    Asset("ATLAS", "images/inventoryimages/griefseed.xml")
}
local L = PUELLA_MOD_SETTINGS.LANGUAGE 

STRINGS.NAMES.GRIEFSEED = L and "grief seed" or "悲叹之种"
STRINGS.NAMES.COOKEDGRIEFSEED = L and "grief seed" or "悲叹之种"
STRINGS.NAMES.SHADOWGRIEFSEED = L and "grief seed?" or "悲叹之种?"

local str_ = L and "What's... this? A common rock?" or "这是什么？一块小石头？"
local str_kk = L and "It brings me infinite magic." or "这是能为我们魔法少女带来无限魔力的东西。"
local str_sy = L and "It is witch's egg." or "这是魔女的卵。"
local str_ho = L and "The soul gem turns to grief seed after becoming fully turbid." or "灵魂宝石的污秽值达到极限后，就会变成悲叹之种。"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.GRIEFSEED = str_
STRINGS.CHARACTERS.GENERIC.DESCRIBE.COOKEDGRIEFSEED = str_
STRINGS.CHARACTERS.KYOUKO.DESCRIBE.GRIEFSEED = str_kk
STRINGS.CHARACTERS.KYOUKO.DESCRIBE.COOKEDGRIEFSEED = str_kk
STRINGS.CHARACTERS.SAYAKA.DESCRIBE.GRIEFSEED = str_sy
STRINGS.CHARACTERS.SAYAKA.DESCRIBE.COOKEDGRIEFSEED = str_sy
STRINGS.CHARACTERS.HOMURA_1.DESCRIBE.GRIEFSEED = str_ho
STRINGS.CHARACTERS.HOMURA_1.DESCRIBE.COOKEDGRIEFSEED = str_ho

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    
    MakeInventoryPhysics(inst)
    if rawget(_G, 'MakeInventoryFloatable') then
        MakeInventoryFloatable(inst, 'idle_water', 'idle')
    end

    inst.AnimState:SetBank("griefseed")
    inst.AnimState:SetBuild("griefseed")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(4)
    inst.components.finiteuses:SetUses(4)
    inst.components.finiteuses:SetOnFinished(inst.Remove)
    
    inst:AddComponent("purifier")
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/griefseed.xml"
    inst.components.inventoryitem.imagename = "griefseed"

    if GetPlayer().components.witchspawner then
        GetPlayer().components.witchspawner:AddGS()
    end

    inst:ListenForEvent('onremove',function()
        if GetPlayer().components.witchspawner then
            GetPlayer().components.witchspawner:RemoveGS()
        end
    end)

    inst.OnLoad = function()
        if GetPlayer().components.witchspawner then
            GetPlayer().components.witchspawner:RemoveGS()
        end
    end

    return inst
end

local function shadowfn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    
    MakeInventoryPhysics(inst)

    if rawget(_G, 'MakeInventoryFloatable') then
        MakeInventoryFloatable(inst, 'idle_water', 'idle')
    end

    inst.AnimState:SetBank("griefseed")
    inst.AnimState:SetBuild("griefseed")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetMultColour(1,1,1,0.5)
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(1)
    inst.components.finiteuses:SetUses(1)
    inst.components.finiteuses:SetOnFinished(inst.Remove)
    
    inst:AddComponent("purifier")
    inst.components.purifier.value = 0
    inst.components.purifier.onusedfn = function(inst,user)
        local pos = user:GetPosition()
        local item = SpawnPrefab("nightmarefuel")
        item.Physics:Teleport(pos:Get())
    end

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/griefseed.xml"
    inst.components.inventoryitem.imagename = "griefseed"

end

return Prefab( "griefseed", fn, assets),Prefab("cookedgriefseed", fn, assets),Prefab("shadowgriefseed",shadowfn,assets)