local assets= 
{
    --Asset("SOUND", "sound/chess.fsb"), --新音效
    Asset("ANIM", "anim/homura_magicwave.zip"),
}

local function OnHit(inst, owner, target)
    local pt = target:GetPosition()
    inst:Remove()
end

local dmg = 40
local ignore = .5
local usemagic = .33

local function fn(inst)
    --trans:SetScale(.8,.8,.8)
    inst.components.projectile:SetLaunchOffset(Vector3(0,1,0))
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnHit)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
    inst.AnimState:SetTime(math.random()*0.1)

    inst:AddComponent("ignoretimemagic")
    inst.components.ignoretimemagic:SetProjectile()
end

local function UpdateSymbol(owner,data)
    local specialstate = {"",}
    for _,v in pairs(specialstate)do
        if data and data.statename == v then
            return
        end
    end
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function onequip(inst,owner)
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal")
    owner.components.combat.min_attack_period = .7
    inst:ListenForEvent("newstate",UpdateSymbol,owner)
end

local function onunequip(inst,owner)
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
    owner.components.combat.min_attack_period = .5
    inst:DoTaskInTime(0, inst.Remove)
    inst:RemoveEventCallback("newstate",UpdateSymbol,owner)
end

local function onattack(inst, owner, target)
    if owner and owner.components.soulgem then
        owner.components.soulgem:DoDelta(usemagic)
    end
end

local function launcherfn()
    local inst = CreateEntity()
    inst.entity:AddTransform() 
    inst.entity:AddAnimState() 
    inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

    inst:AddComponent("inventoryitem")
    
    if GetPlayer():HasTag("homura") then
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(dmg)
    inst.components.weapon:SetRange(10, 12)
    inst.components.weapon:SetProjectile("homura_magicwave")
    inst.components.weapon.magicfn = function(player) player.components.soulgem:DoDelta(usemagic) end
    --inst.components.weapon:SetOnAttack(onattack)
    PUELLA_MOD_FN.SetMagicalWeapon(inst,dmg,ignore)
    end
    
    inst:AddTag("invisibleweapon")
    inst:AddTag('magicweapon')
    
    return inst
end

return PUELLA_MOD_FN.MakeProjectile( "common/inventory/homura_magicwave", "homura_magicwave","homura_magicwave",
 "anim","这是在tv版第10集里，小焰追杀qb时使用的魔法冲击波" ,30,nil, assets,fn ) ,
Prefab( "common/inventory/homura_magicwave_launcher" ,launcherfn,assets,{"homura_magicwave",})