--手枪，步枪，机枪
--子弹，机枪子弹，起源弹
--材质包 homura_pistol

--② ammo:  1~3   (物品栏子弹)
--③ pro: anim/anim_magic/anim_magic_sp  (飞行子弹)  tail(尾迹)

--symbol: pistol gun hmg

local assets = 
{
    
    Asset("SOUNDPACKAGE", "sound/lw_homura.fev"),
    Asset("SOUND", "sound/lw_homura.fsb"), 
    Asset("ANIM", "anim/homura_pistol.zip"),
    Asset("ANIM", "anim/homura_weapon_ui_1.zip"),
    Asset("ANIM", "anim/homura_weapon_ui_2.zip"),
    Asset("ANIM", "anim/homura_weapon_ui_3.zip"),
    
    Asset("ATLAS","images/inventoryimages/homura_pistol.xml"),
    Asset("ATLAS","images/inventoryimages/homura_gun.xml"),
    Asset("ATLAS","images/inventoryimages/homura_hmg.xml"),
    Asset("ATLAS","images/inventoryimages/homura_gun_ammo1.xml"),
    Asset("ATLAS","images/inventoryimages/homura_gun_ammo2.xml"),
    Asset("ATLAS","images/inventoryimages/homura_gun_ammo3.xml"),

    Asset("ATLAS_BUILD","images/inventoryimages/homura_pistol.xml",256),
    Asset("ATLAS_BUILD","images/inventoryimages/homura_gun.xml",256),
    Asset("ATLAS_BUILD","images/inventoryimages/homura_hmg.xml",256),
    Asset("ATLAS_BUILD","images/inventoryimages/homura_gun_ammo1.xml",256),
    Asset("ATLAS_BUILD","images/inventoryimages/homura_gun_ammo2.xml",256),
    Asset("ATLAS_BUILD","images/inventoryimages/homura_gun_ammo3.xml",256),

    Asset("ATLAS","images/inventoryimages/homura_ammochain.xml"),

    Asset("ANIM","anim/player_homura_gun.zip"),
}

local L = PUELLA_MOD_SETTINGS.LANGUAGE
local function quickset(prefab,name,desc_data,recipe)
    prefab = string.upper(prefab)
    STRINGS.NAMES[prefab] = name 
    for cha,desc in pairs(desc_data)do
        cha = string.upper(cha)
        STRINGS.CHARACTERS[cha].DESCRIBE[prefab] = desc
    end
    STRINGS.RECIPE_DESC[prefab] = recipe
end
if PUELLA_MOD_SETTINGS.LANGUAGE then
    quickset("homura_gun_ammo1","Bullets",
        {
            generic = "Bullets for pistols and rifles",
        },"Bullets for pistols and rifles")
    quickset("homura_gun_ammo2","Machine gun bullets",
        {
            generic = "Bullets for machine gun",
        },"Bullets for machine gun")
    quickset("homura_gun_ammo3","Origination",
        {
            generic = "",
        },"Deal significant damage to witches.")
    quickset("homura_pistol","Desert eagle",
        {
            generic = "The power of this pistol cannot be underestimated"
        },"The most popular one")
    quickset("homura_gun","SCAR-L",
        {
            generic = "It reminds me of game by Bluehole."
        },"A kind of ssault rifle")
    quickset("homura_hmg","Light machine gun",
        {
            generic = "It't a bit heavy..."
        },"Fire suppression!") 
    quickset('homura_ammochain', 'Ammunition Belt',
        {
            generic = 'Use it to link bullets.'
        },'Use it to link bullets.')

else
    quickset("homura_gun_ammo1","子弹",
        {
            generic = "可以用在手枪和步枪上",
            homura_1 = "没有它, 我的枪就毫无威力了",
        },"biu!")
    quickset("homura_gun_ammo2","机枪子弹",
        {
            generic = '可以用在机枪上',
            homura_1 = "适用于连发型的武器",
        },"biu!biu!biu!")
    quickset("homura_gun_ammo3","起源弹",
        {
            homura_1 = "你看这子弹...这好像是隔壁剧组的子弹?",
        },"对魔法生物造成重创。")
    quickset("homura_pistol","沙漠之鹰",
        {
            generic = "这手枪的威力不容小觑",
            homura_1 = "只要距离不远, 我就能轻松打中目标。",
        },"最著名的一款手枪")
    quickset("homura_gun","SCAR-L",
        {
            generic = "这让我想到了蓝洞公司的一个游戏",
            homura_1 = "看起来还不错.",
        },"可靠的半自动突击步枪")
    quickset("homura_hmg","99式机枪",
        {
            generic = "我一梭子下去你可能会死",
            homura_1 = "唔, 有点沉。",
        },"火力压制!")
    quickset('homura_ammochain','弹链',
        {
            generic = '一大串的, 跟鞭炮一样',
        },'一个把大量子弹串联在一起的装置')
end

local function CommonAmmo(num)
    local function fn()
        local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
        MakeInventoryPhysics(inst)
        PUELLA_MOD_FN.SetAnim(inst,'homura_pistol','ammo', ''..num)

        inst:AddComponent("inspectable")
        inst:AddComponent("homura_ammo")
        inst.projectilename = 'homura_projectile'..num

        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/inventoryimages/homura_gun_ammo"..num..".xml"

        inst:AddComponent("stackable")
        inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

        return inst
    end
    return Prefab("homura_gun_ammo"..num,fn,assets)
end

local function OnHit(inst, owner, target)
    inst.components.homura_projectile:OnHit(inst, owner, target)
    inst:Remove()
end

local function OnMiss(inst,owner,target)
    local fx = SpawnPrefab('homura_miss_fx')
    if inst.components.homura_projectile.magic then
        fx.AnimState:SetAddColour(1,0,1,0.7)
    end
    --local offset = Point(math.random(),0,math.random())
    fx.Transform:SetPosition(inst:GetPosition():Get())
    inst:Remove()
end

local function OnThrown(inst,owner,target)
    inst.components.homura_projectile:OnTrow(inst,owner,target)
end

local function CreateTail()
    local inst = PUELLA_MOD_FN.CreateEntity()
    PUELLA_MOD_FN.SetAnim(inst,'homura_pistol','pro','tail',false,true)
    inst:AddTag("FX")
    inst:AddTag("NOCLICK")
    inst.AnimState:SetMultColour(1,50/255,200/255,.8)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
    inst.AnimState:SetLightOverride(1)

    inst:AddComponent("colourtweener")

    --inst:ListenForEvent('animover',inst.Remove)

    inst.entity:SetCanSleep(false)
    inst.persists = false
    
    inst.components.colourtweener:StartTween({0,0,0,0},4*FRAMES,inst.Remove)

    return inst
end

local function UpdateTail(inst,tails)
    local pos = inst:GetPosition()
    local tail = CreateTail()
    tail.Transform:SetPosition(pos:Get())
    tail.Transform:SetRotation(inst.Transform:GetRotation())

    if inst.last_tail_pos then
        local tail2 = CreateTail()
        tail2.Transform:SetPosition((((pos+inst.last_tail_pos)*0.5)):Get())
        tail2.Transform:SetRotation(inst.Transform:GetRotation())
    end
    inst.last_tail_pos = pos
    local speed = 15
    if inst.components.homura_projectile.time_sp then
        tail:AddTag('ignoretimemagic')
    end
end

local function pro1(inst) --手枪射出的子弹
    --trans:SetScale(.8,.8,.8)
    inst.components.projectile:SetLaunchOffset(Vector3(0,1,0))
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnMiss)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(0.5)
    inst.components.projectile.onthrown = OnThrown

    inst:AddComponent("ignoretimemagic")
    inst.components.ignoretimemagic:SetProjectile()

    inst:AddComponent('homura_projectile')

    inst:ListenForEvent("entitysleep", inst.Remove)
    inst.updatetailfn = function(inst) inst:DoPeriodicTask(0,UpdateTail,nil,{}) end
end

local function pro2(inst) --步枪射出的子弹
    --trans:SetScale(.8,.8,.8)
    inst.components.projectile:SetLaunchOffset(Vector3(1.5,1.1,0))
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnMiss)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(0.5)
    inst.components.projectile.onthrown = OnThrown

    inst:AddComponent("ignoretimemagic")
    inst.components.ignoretimemagic:SetProjectile()

    inst:AddComponent('homura_projectile')

    inst:ListenForEvent("entitysleep", inst.Remove) 
    inst.updatetailfn = function(inst) inst:DoPeriodicTask(0,UpdateTail,nil,{}) end
end

local function pro3(inst) --机枪射出的子弹
    --trans:SetScale(.8,.8,.8)
    inst.components.projectile:SetLaunchOffset(Vector3(1.7,1,0))
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnMiss)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(0.5)
    inst.components.projectile.onthrown = OnThrown

    inst:AddComponent("ignoretimemagic")
    inst.components.ignoretimemagic:SetProjectile()

    inst:AddComponent('homura_projectile')

    inst:ListenForEvent("entitysleep", inst.Remove) 
    inst.updatetailfn = function(inst) inst:DoPeriodicTask(0,UpdateTail,nil,{}) end
end

local function CommonGunFn(name,slots)
    local inst = CreateEntity()
    inst.entity:AddTransform() 
    inst.entity:AddAnimState() 
    inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    if rawget(_G, 'MakeInventoryFloatable') then
        MakeInventoryFloatable(inst, "idle_water", "idle")
    end
    PUELLA_MOD_FN.SetAnim(inst, 'homura_pistol', name, 'idle')

    inst:AddComponent("inspectable")

    inst:AddComponent("container")
    inst.components.container.type = "homura_weapon"
    inst.components.container:SetNumSlots(slots)
    inst.components.container.acceptsstacks = false
    inst.components.container.canbeopened = false
    inst.components.container.itemtestfn = function (i,item) return item:HasTag('homura_weapon_buff') end
    inst.components.container.onopenfn = function(i) i.SoundEmitter:PlaySound("") end
    inst.components.container.onclosefn = function(i) i.SoundEmitter:PlaySound("") end

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/homura_"..name..".xml"
    if GetPlayer():HasTag("homura") then 
        inst:AddComponent("equippable")
        inst.components.equippable:SetOnEquip(function(_,owner)
            owner.AnimState:OverrideSymbol("swap_object","homura_pistol",'swap_'..name)
            owner.AnimState:Show("ARM_carry") owner.AnimState:Hide("ARM_normal")
        end)
        inst.components.equippable:SetOnUnequip(function(_,owner)
            owner.AnimState:ClearOverrideSymbol("swap_object")
            owner.AnimState:Hide("ARM_carry") owner.AnimState:Show("ARM_normal") 
        end)

        inst:AddComponent("homura_weapon")
        inst:AddComponent('homura_focus')
        inst:AddComponent("weapon")
        inst:AddComponent('named')

        inst.components.weapon.onprojectilelaunch = function(inst, attacker, target)
            inst.components.homura_weapon:OnLaunch(attacker)
        end
    end
    
    return inst
end

local function PistolFn()
    local inst = CommonGunFn('pistol',2)
    inst.components.container.widgetslotpos = {Vector3(43,-13,0),Vector3(-37,-13,0)}
    inst.components.container.widgetanimbank = "homura_weapon_ui_2"
    inst.components.container.widgetanimbuild = "homura_weapon_ui_2"
    inst.components.container.widgetpos = Vector3(0,100,0)
    inst.components.container.side_align_tip = 160

    
    inst.components.homura_weapon.projectile = 'homura_projectile_pistol'
    inst.components.homura_weapon.ammo_prefabname = 'homura_gun_ammo1'

    local weapon_data = {
        speed = 30, --射速
        range = 8,  --射程
        hitrange = 4, --必中射程
        min_hit_rate = 0.8, --最低命中率
        variety = 5,  --子弹最大偏角
        damage1 = 60,  ---攻击伤害
        damage2 = 5,  ---平a伤害
        maxammo = 7,
    }
    local cs_data = { 
        hitrange = 4, --必中射程
        min_hit_rate = 0.6, --最低命中率
        variety = 7.5, --子弹最大偏角
    }
    inst.components.homura_weapon:SetBasicPara(weapon_data,cs_data)

    return inst
end

local function GunFn()
    local inst = CommonGunFn('gun',3)
    inst.components.container.widgetslotpos = {Vector3(-80,10,0),Vector3(0,10,0),Vector3(80,10,0)}
    inst.components.container.widgetanimbank = "homura_weapon_ui_3"
    inst.components.container.widgetanimbuild = "homura_weapon_ui_3"
    inst.components.container.widgetpos = Vector3(0,100,0)
    inst.components.container.side_align_tip = 160

    inst.components.homura_weapon.projectile = 'homura_projectile_gun'
    inst.components.homura_weapon.ammo_prefabname = 'homura_gun_ammo1'

    local weapon_data = {
        speed = 50, --射速
        range = 12,  --射程
        hitrange = 6, --必中射程
        min_hit_rate = 0.9, --最低命中率
        variety = 2.5,  --子弹最大偏角
        damage1 = 40,  ---攻击伤害
        damage2 = 10,  ---平a伤害
        maxammo = 20,
    }
    local cs_data = {
        hitrange = 4, --必中射程
        min_hit_rate = 0.5, --最低命中率
        variety = 12.5, --子弹最大偏角
    }
    inst.components.homura_weapon:SetBasicPara(weapon_data,cs_data)

    return inst
end


local function HMGFn()
    local inst = CommonGunFn('hmg',3)
    inst.components.container.widgetslotpos = {Vector3(-80,10,0),Vector3(0,10,0),Vector3(80,10,0)}
    inst.components.container.widgetanimbank = "homura_weapon_ui_3"
    inst.components.container.widgetanimbuild = "homura_weapon_ui_3"
    inst.components.container.widgetpos = Vector3(0,100,0)
    inst.components.container.side_align_tip = 160

    inst.components.homura_weapon.projectile = 'homura_projectile_hmg'
    inst.components.homura_weapon.ammo_prefabname = 'homura_gun_ammo2'

    local weapon_data = {
        speed = 40, --射速
        range = 12,  --射程
        hitrange = 2, --必中射程
        min_hit_rate = 0.5, --最低命中率
        variety = 10,  --子弹最大偏角(pro)
        movespeed = -0.1, --移速
        damage1 = 30,  ---攻击伤害
        damage2 = 10,  ---平a伤害
        maxammo = 80,
    }
    local cs_data = {
        hitrange = 2,
        min_hit_rate = 0,
        variety = 25,
    }
    inst.components.homura_weapon:SetBasicPara(weapon_data,cs_data)

    return inst
end


local function MakeAmmoChain()
    local inst, trans, anim ,snd = PUELLA_MOD_FN.CreateEntity()
    MakeInventoryPhysics(inst)
    anim:SetBankBuildAnim('ammo', 'homura_pistol', '4')

    inst:AddComponent('inspectable')

    inst:AddComponent('inventoryitem')
    inst.components.inventoryitem.atlasname = 'images/inventoryimages/homura_ammochain.xml'

    return inst
end


local function missfx()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    anim:SetBankBuildAnim('hits_sparks', 'lavaarena_hit_sparks_fx_pmmm', 'hit_'..math.random(5))
    anim:SetLightOverride(1)
    anim:SetMultColour(1,1,0.5,1)
    anim:SetBloomEffectHandle("shaders/anim.ksh")
    snd:PlaySound('lw_homura/sfx/miss'..math.random(2), nil, 0.5)

    trans:SetScale(0.3,0.3,0.3)

    inst:AddTag('FX','NOCLICK','NOBLOCK')
    
    inst:ListenForEvent("animover",inst.Remove)

    return inst
end

local function smokefx()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    anim:SetBankBuildAnim('wilson', 'player_pistol', 'hand_shoot')
    trans:SetFourFaced()

    inst:AddTag('FX','NOCLICK','NOBLOCK')

    inst:ListenForEvent('animover',inst.Remove)

    return inst
end

local function firefx()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    local light = inst.entity:AddLight()
    anim:SetBankBuildAnim('wilson', 'player_pistol', 'hand_shoot')
    trans:SetFourFaced()

    inst:AddTag('FX','NOCLICK','NOBLOCK')

    inst:AddComponent('lighttweener')

    inst:ListenForEvent('animover',inst.Remove)

    return inst
end

return 
PUELLA_MOD_FN.MakeProjectile( "homura_projectile_pistol", "pro","homura_pistol",
 "anim",true ,1, nil, assets,pro1),
PUELLA_MOD_FN.MakeProjectile( "homura_projectile_gun", "pro","homura_pistol",
 "anim",true ,2, nil, assets,pro2),
PUELLA_MOD_FN.MakeProjectile( "homura_projectile_hmg", "pro","homura_pistol",
 "anim",true ,4, nil, assets,pro3),
Prefab( "common/inventory/homura_pistol", PistolFn,assets),
Prefab( "common/inventory/homura_gun", GunFn,assets),
Prefab( "common/inventory/homura_hmg", HMGFn,assets),
CommonAmmo(1),CommonAmmo(2),CommonAmmo(3), --homura_gun_ammo1~3
Prefab('homura_ammochain', MakeAmmoChain),
Prefab('homura_miss_fx',missfx,assets),
Prefab('homura_gun_smoke_fx',smokefx)

