local HOMURA_TAB={str='HOMURA_1',sort=999,icon="homura_tab.tex",icon_atlas="images/hud/homura_tab.xml"}

local function AddModRecipe(prefab,ingredients,level,num,atlas,image)
    local recipe = Recipe(prefab,ingredients,HOMURA_TAB,{SCIENCE=10})----10
    recipe.nounlock = true
    recipe.level.HOMURA_WEAPON = level or 1
    recipe.numtogive = num or 1
    recipe.atlas = atlas or "images/inventoryimages/"..prefab..".xml"
    recipe.image = image and image..".tex" or recipe.image
end

local IsHAM = SaveGameIndex:IsModePorkland()
local IsSW  = SaveGameIndex:IsModeShipwrecked()
---------------------------------------------------------------------------------------
local function CreateTab(inst)
    inst:AddComponent('homura_tech')--科技树
    inst.components.builder:AddRecipeTab(HOMURA_TAB)
    STRINGS.TABS.HOMURA_1=PUELLA_MOD_SETTINGS.LANGUAGE and 'Munition'or '军火'
    
    local Ig = Ingredient
    ----------------------------------------------------------------------------------
    local recipe_workdesk = Recipe('homura_workdesk',{Ig("gunpowder",2),Ig("log",8),Ig('goldnugget',4)},HOMURA_TAB,{SCIENCE=2})
    recipe_workdesk.atlas = "images/inventoryimages/homura_workdesk.xml"
    recipe_workdesk.placer = "homura_workdesk_placer"
    -----------------------------------------------------------------------------------
    local recipe_detonator = Recipe('homura_detonator',{Ig('gunpowder',1),Ig('powcake',2),Ig('goldnugget',1)},HOMURA_TAB,{SCIENCE =10})
    recipe_detonator.nounlock = true
    recipe_detonator.level.HOMURA_WEAPON = 1
    recipe_detonator.numtogive = 4
    recipe_detonator.atlas = "images/inventoryimages/homura_detonator.xml"
    recipe_detonator.image = "homura_detonator.tex"
    Recipe('homura_detonator1',{Ig('gunpowder',1),Ig('goldnugget',1)},nil,TECH.LOST,nil,nil,nil,true,4).product = 'homura_detonator'
    Recipe('homura_detonator2',{Ig('powcake',2),Ig('goldnugget',1)},nil,TECH.LOST,nil,nil,nil,true,4).product = 'homura_detonator'


    local DETONATOR = Ig('homura_detonator',1,'images/inventoryimages/homura_detonator.xml')

    AddModRecipe('homura_bomb_bomb',{DETONATOR, Ig('flint',4)})
    AddModRecipe('homura_bomb_fire',{DETONATOR, Ig('charcoal',3)})
    AddModRecipe('homura_bomb_flash',{DETONATOR,Ig('nitre',1)})

    local AMMO1 = function(num) return Ig('homura_gun_ammo1',num,'images/inventoryimages/homura_gun_ammo1.xml') end
    local AMMO2 = function(num) return Ig('homura_gun_ammo2',num,'images/inventoryimages/homura_gun_ammo2.xml') end
    AddModRecipe('homura_pistol',{Ig('blowdart_pipe',1),IsHAM and Ig('oinc',5) or IsSW and Ig('dubloon',5) or Ig('thulecite_pieces',3),AMMO1(7)})
    AddModRecipe('homura_gun',{Ig('blowdart_pipe',1),IsSW and Ig('cane',2) or Ig('walrus_tusk',2), AMMO1(20)},2)
    AddModRecipe('homura_hmg',{Ig('blowdart_pipe',1),Ig('gears',1), AMMO2(40)},2)
    AddModRecipe('homura_gun_ammo1',{Ig('gunpowder',1),Ig('goldnugget',2)},1,20)
    AddModRecipe('homura_ammochain',{Ig('silk',4),Ig('rope',2)},2,1)
    AddModRecipe('homura_gun_ammo2',{AMMO1(40),Ig('homura_ammochain',1,'images/inventoryimages/homura_ammochain.xml')},2,40)
    AddModRecipe('homura_gun_ammo3',{Ig('boneshard',1),Ig('rocks',1),Ig('ash',2)},1,5)

    AddModRecipe('homura_rpg',{Ig('blowdart_fire',1), IsSW and Ig('obsidian',20) or Ig('dragon_scales',1),Ig('homura_rpg_ammo1',1,'images/inventoryimages/homura_rpg_ammo1.xml')},2)
    AddModRecipe('homura_rpg_ammo1',{DETONATOR,Ig('log',4),Ig('durian',1)},2)


    local weapon_buffs_level1 =
    {
        lens    = {Ig('log',1),Ig('berries_cooked',1),Ig('bluegem',1)}, --IsHAM and Ig('magnifying_glass',1)
        knife   = {Ig('flint',10)},
        silent  = IsHAM and {Ig('iron',4),Ig('charcoal',2)} or {Ig('heatrock',1),Ig('charcoal',2)},--
    }
    local weapon_buffs_level2 =
    {
        ice     = {Ig('icehat',1),Ig('bluegem',3),Ig('gears',1)},
        code    = {Ig('beardhair',16)}, 
        magic   = {Ig('griefseed',1,"images/inventoryimages/griefseed.xml"),Ig('purplegem',4),Ig('nightmarefuel',6)},
        wind    = {Ig('feather_crow',6),Ig('feather_robin',6),Ig('feather_robin_winter',6)},
        waterproof  = {Ig('beeswax',1),Ig('pigskin',2)},
        mouse   = {Ig('cutreeds',29),Ig('homura_weapon_buff_code',1,'images/homura_weapon_buffs/homura_weapon_buff_code.xml'),Ig('goldnugget',1)},
        homing  = {Ig('homura_weapon_buff_eye_lens',1,"images/homura_weapon_buffs/homura_weapon_buff_eye_lens.xml"),Ig('boards',10),},
        flyingspeed = {Ig('goldnugget',10),Ig('redgem',1),Ig('bluegem',1)}, --
        --graphite= {},
        eye_lens= {IsSW and Ig('tigereye',1) or Ig('deerclops_eyeball',1),Ig('goldnugget',4),Ig('homura_weapon_buff_lens',1,'images/homura_weapon_buffs/homura_weapon_buff_lens.xml')},
        clip    = {Ig('nightmarefuel',40),Ig('boards',2)},
    }
    
    if IsSW then 
        weapon_buffs_level2.time2 = {Ig('messagebottleempty',2),Ig('sand',3)}
    else
        weapon_buffs_level2.time1 = {Ig('goldnugget',2),Ig('papyrus',1),IsHAM and Ig('froglegs_poison',2) or Ig('froglegs',2)}
    end

    for name,ing in pairs(weapon_buffs_level1)do
        AddModRecipe('homura_weapon_buff_'..name,ing,1,1,"images/homura_weapon_buffs/homura_weapon_buff_"..name..".xml")
    end
    for name,ing in pairs(weapon_buffs_level2)do
        AddModRecipe('homura_weapon_buff_'..name,ing,2,1,"images/homura_weapon_buffs/homura_weapon_buff_"..name..".xml")
    end

    AddModRecipe('homura_wrench',{Ig('goldenaxe', 1),Ig('goldenpickaxe',1),Ig('goldenshovel',1)},1,1)

end

return CreateTab