require 'class'
local function quickset(shortname,name,desc,recipe)
    local prefab = "HOMURA_WEAPON_BUFF_"..shortname:upper()
    STRINGS.NAMES[prefab] = name 
    STRINGS.CHARACTERS["HOMURA_1"].DESCRIBE[prefab] = desc
    STRINGS.RECIPE_DESC[prefab] = recipe
end
local buffstrings = PUELLA_MOD_SETTINGS.LANGUAGE and
{
    ice = {'[Fitting]Refrigerator','好冷！','Cool bullets and rockets'},
    wind = {'[Fitting]Winnower','逮虾户！','Speed up'},
    code = {'[Fitting]Code editer','代码敲得我头都突了。','Use lua script to do everything.'},
    graphite = {'[Fitting]石墨发射器'},
    magic = {'[Fitting]Magic circuit','要用魔法打败魔法。','Injects magic into the bullet'},

    time2 = {'[Fitting]Sand glass','子弹:\"我还能再飞一会儿!\"','Resist time magic'},
    time1 = {'[Fitting]Time shuttler','子弹:\"我还能再飞一会儿!\"','Resist time magic'},
    lens = {'[Fitting]Lens','我可以射的更准一点。','Increases range and accuracy'},
    eye_lens = {'[Fitting]E-Y-E','我可以用它来锁定目标','Focusing before shooting'},
    homing = {'[Fitting]Projectile guider','让子弹拐弯是有原理的... 出膛的一瞬间，\n手腕快速抖动，给子弹一个水平的加速度...','Turn the bullet around'},
    knife = {'[Fitting]Knife','我拿着一把枪...近战？','Sharpen your gun!'},

    silent = {'[Fitting]Silencer','安静多了','Significantly reduces noise from shooting'},
    waterproof = {'[Fitting]Waterproofer','虽然湿的枪也能射击，但还是干一些好。','Keep weapon from dampness'},
    flyingspeed = {'[Fitting]Electromagnetic accelerator','安培力加速装置','Speed up Projectiles'},
    clip = {'[Fitting]Super clip','哇，这么小的弹夹，塞那么多子弹。','Increase the ammunition capacity'},
    mouse = {'[Fitting]Mouse macro','要不要我展示一下十枪一孔？','\"No plugins are used\"'},
}
or
{
    ice = {'[配件]预冷装置','好冷！','降低子弹和火箭的温度'},
    wind = {'[配件]风车','逮虾户！','脚底生风, 提升移速'},
    code = {'[配件]代码编辑器','代码敲得我头都突了。','没有什么是不能用一行代码来解决的'},
    graphite = {'[配件]石墨发射器'},
    magic = {'[配件]魔术回路','要用魔法打败魔法。','向子弹注入魔力'},

    time2 = {'[配件]时之沙漏','子弹:\"我还能再飞一会儿!\"','提升子弹对时间魔法的抗性'},
    time1 = {'[配件]时空穿梭器','子弹:\"我还能再飞一会儿!\"','提升子弹对时间魔法的抗性'},
    lens = {'[配件]瞄准镜','我可以射的更准一点。','提高武器射程和命中率'},
    eye_lens = {'[配件]眼','我可以用它来锁定目标','瞄准，射击！'},
    homing = {'[配件]牛顿的棺材板','让子弹拐弯是有原理的... 出膛的一瞬间，\n手腕快速抖动，给子弹一个水平的加速度...','让子弹追踪目标'},
    knife = {'[配件]刺刀','我拿着一把枪...近战？','提升武器在没有装填子弹时的攻击力'},

    silent = {'[配件]消音器','安静多了','大幅降低射击噪音'},
    waterproof = {'[配件]防水涂层','保持干燥','防止武器受潮'},
    flyingspeed = {'[配件]电磁线圈','安培力加速装置','提升子弹和火箭的出膛射速和伤害'},
    clip = {'[配件]四次元的弹夹','哇，这么小的弹夹，塞那么多子弹。','提升枪械的弹药容量'},
    mouse = {'[配件]鼠标宏','要不要我展示一下十枪一孔？','没有开挂'},


}
for shortname,strings in pairs(buffstrings)do
    quickset(shortname,strings[1],strings[2],strings[3])
end

----------------------------------------------------------------------------------------

local Buff = Class(function(self,parameter) 
    self.parameter = parameter
end)
local buffdata = 
{
    ice = Buff{ice={true,true}}, --攻击附带一层冰冻  
    wind = Buff{movespeed={0.2,true}}, --0.2倍速度加成    
    code = Buff{copy = true,}, -- 复制前一个buff  
    graphite = Buff{graphite={true,true}}, --击落附近飞行物  未实装
    magic = Buff{magic={true,true}}, --10点真实伤害

    time1 = Buff{time={true,true}}, time2 = Buff{time={true,true}}, --免疫时停
    lens = Buff{range={1,true},hitrange={1,true},variety={-0.3,false},min_hit_rate={0.1,false}}, --范围+1，收束30%，最低命中率+10%
    eye_lens = Buff{range={0.333,false},focus={true,true},variety={-1,false},min_hit_rate={1,true}}, --范围×0.5，需要瞄准，必中
    homing = Buff{min_hit_rate={1,true},homing={true,true},damage1={-0.2,false}},
    knife = Buff{damage2={15,true}}, --伤害+15

    silent = Buff{silent={true,true}},
    waterproof = Buff{waterproof={true,true}},
    flyingspeed = Buff{speed={0.2,false},damage1={0.2,false}}, --出膛速度+20%, 0.2倍伤害加成  
    clip = Buff{bigclip={true,true}},
    mouse = Buff{ignore_cs={true,true}},

    --whitehole = Buff{ammo={true,true}},
}
for k,v in pairs(buffdata)do
    v.name = k:sub(1,4)=='time' and 'time' or k
end
local function MakeBuff(name)
    local prefabname = "homura_weapon_buff_"..name
    local function fn()    
        local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
        MakeInventoryPhysics(inst)
        MakeInventoryFloatable(inst,"idle","idle")
        local s = 1.4
        trans:SetScale(s,s,s)
        anim:SetBank('homura_buff_base')
        anim:SetBuild('homura_buff_base')
        anim:PlayAnimation('idle', true)
        anim:OverrideSymbol('swap', resolvefilepath("images/homura_weapon_buffs/"..prefabname..".xml"), prefabname..".tex")
        anim:SetBloomEffectHandle("shaders/anim.ksh")

        inst:AddComponent("inspectable")

        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/homura_weapon_buffs/"..prefabname..".xml"
        --inst.components.inventoryitem.atlasname = 'images/homura_weapon_buffs.xml'
        inst.components.inventoryitem.imagename = prefabname
        --inst.components.inventoryitem.nobounce = true

        inst:AddTag("homura_weapon_buff")
        inst.shortname = name
        inst.homura_weapon_buff = buffdata[name]

        return inst
    end
    --local assets = {Asset("ATLAS","images/homura_weapon_buffs/"..name..".xml"),}
    local assets = {
    Asset('ATLAS',"images/homura_weapon_buffs/"..prefabname..".xml"),
    Asset('ATLAS_BUILD',"images/homura_weapon_buffs/"..prefabname..".xml", 64),
    }
    return Prefab(prefabname,fn,assets,nil)
end


local prefabs = {}

for name,v in pairs(buffdata)do
    table.insert(prefabs,MakeBuff(name))
end

return unpack(prefabs)

