local MakePlayerCharacter = require "prefabs/player_common_mod"

local assets = {
    Asset( "ANIM", "anim/kyouko.zip" ), Asset( "ANIM", "anim/kyouko_c.zip" ),
    Asset("ANIM","anim/anim001.zip"),
    Asset("ANIM", "anim/griefseed_fx.zip"), --横扫冲击波
    Asset("SOUNDPACKAGE", "sound/lw_kyouko.fev"),Asset("SOUND", "sound/lw_kyouko.fsb"), 
}
local prefabs = {"magicalheal_fx","griefseed","magicalring_fx","magicalboom_fx","kyouko_chain",}
local start_inv = { "griefseed",}

local function onhungerchange(inst) 
    local basic = TUNING.WILSON_HUNGER_RATE
    if inst.components.hunger.current >= 200 then
        inst.components.hunger:SetRate(1.5 * basic)
        inst.components.soulgem.rate = 0.5
    elseif inst.components.hunger.current >= 50 then
        inst.components.hunger:SetRate(1.25 * basic)
        inst.components.soulgem.rate = 1
    else 
        inst.components.hunger:SetRate(1 * basic)
        inst.components.soulgem.rate = 1.5
    end
end

local fn = function(inst)
    local anim = inst.AnimState
    anim:SetBuild("kyouko")
    inst.soundsname = "willow"
    inst.MiniMapEntity:SetIcon( "kyouko.tex" )

    PUELLA_MOD_FN.MakeMagicalGirl(inst, {1,.5,.5,.5}, "版本号: 2.2.3")

    inst.components.health:SetMaxHealth(150)
    inst.components.hunger:SetMax(250)
    inst.components.hunger.current = 200
    inst:ListenForEvent("hungerdelta", onhungerchange)
    
    inst:AddComponent("skill_kyouko")
    local SGkyouko = require "stategraphs/SGmagicalgirls/SGkyouko";SGkyouko(inst) 
end
return MakePlayerCharacter("kyouko", prefabs, assets, fn, start_inv)

