local L = PUELLA_MOD_SETTINGS.LANGUAGE 

local function SetDescription(inspector,item,string1,string2)
    STRINGS.CHARACTERS[inspector:upper()].DESCRIBE[item:upper().."_CLO"] = L and string1 or string2
end

STRINGS.NAMES.KYOUKO_CLO = L and "kyouko dress" or "杏子的连衣裙"
STRINGS.NAMES.SAYAKA_CLO = L and "sayaka dress" or "沙耶加的短裙"
STRINGS.NAMES.HOMURA_CLO = L and "" or "小焰的裙子"
SetDescription("kyouko","kyouko","","红色, 跟苹果是一个颜色.")
SetDescription("sayaka","sayaka","","穿这身...有点害羞。")
SetDescription("kyouko","sayaka","","那个笨蛋跑哪儿去了？")
local BATTLE = {}
BATTLE.kyouko = L and {"Magical power can protect me.",} or {"魔法可以保护我。","这件裙子可没有表面上那么弱不禁风。",}
BATTLE.sayaka = L and {"This clothes is really suitable.",} or {"战斗的时候不要分心！","我的衣服很合身，为什么要脱掉呢？",}
BATTLE.homura_1 = L and {} or {"这身挺帅的。"}


local function onequip(inst, owner)
    if not owner.components.magicalcharge or owner.components.magicalcharge.state ~= 3 then 
        inst:DoTaskInTime(0, function()
            inst.components.equippable.un_unequipable = nil
            inst:Remove()
        end)
    end
    owner.AnimState:ClearOverrideSymbol("swap_body")
end
local function onunequip(inst, owner)
    inst:DoTaskInTime(0, function()
        if inst:IsValid() then
            inst:Remove()
        end
    end)
    owner.AnimState:ClearOverrideSymbol("swap_body")
end

local function MakeClothes(owner)
    local assets = {Asset("ATLAS","images/inventoryimages/"..owner.."_clo.xml"),}
    local function fn()
        local inst = CreateEntity()
        inst.entity:AddTransform() 
        inst.entity:AddAnimState() 
        MakeInventoryPhysics(inst)

        inst:AddComponent("inspectable")
    
        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/inventoryimages/"..owner.."_clo.xml"
        inst.components.inventoryitem.keepondeath = true

        if GetPlayer().prefab == owner or GetPlayer():HasTag('homura') and owner == 'homura' then
            inst:AddComponent("equippable")
            inst.components.equippable.un_unequipable = true
            inst.components.equippable.equipslot = EQUIPSLOTS.BODY
            inst.components.equippable:SetOnEquip(onequip)
            inst.components.equippable:SetOnUnequip(onunequip)
            inst.components.equippable.CollectInventoryActions = function() return end
        end

        inst:AddTag("irreplaceable","notslippery","cantdrop",'magicweapon')
        inst.forceequipstr = BATTLE[GetPlayer().prefab]
        return inst
    end
    return Prefab(owner.."_clo",fn,assets)
end


return MakeClothes("sayaka"),MakeClothes("kyouko"),MakeClothes("homura")
--,MakeClothes("mami"),MakeClothes("madoka")

   