local assets ={  }
local prefabs = {"kyouko_chain",}

local COLOUR = 
{
    F = {1,.3,.3,.7},
    B = {.25,0,0,.7},
}

--LAYER_WORLD_BACKGROUND = 2
--LAYER_WORLD = 3
--LAYER_WORLD_CEILING = 4

local function setcolour(inst,t)
    inst.AnimState:SetMultColour(t[1],t[2],t[3],t[4])
end

local function tryshine(inst)
    for i = 1,6 do
        inst["time".. i] = inst["time".. i] - 0.1 
        if inst["time".. i] < 0 then 
            inst["time".. i] = 4*math.random()+2
            inst.shinefn(inst,i)
        end
    end
end

local function idle(inst,num) -----before fade out
    if  num then
        inst.AnimState:PlayAnimation("idle"..num)
    else
        for i = 1,6 do
            inst["chain"..i].AnimState:PlayAnimation("idle"..i ,true)
        end
    end   
end

local function shake(inst)
    inst:Show()
    for i = 1,6 do
        local chain = inst["chain"..i]
        chain.AnimState:PlayAnimation("boost"..i)
        chain.AnimState:PushAnimation("idle"..i , true)
        chain:AddTag("busy") 
        if chain.busy then chain.busy:Cancel();chain.busy = nil end
        chain.busy = chain:DoTaskInTime(1,function (chain) chain:RemoveTag("busy")end)
    end
end

local function boost(inst) ---on attacked
    inst:Show()
    --if inst.fade then 
    --    inst.fade:Cancel()
    --end
    --inst.fade = inst:DoTaskInTime(10,inst.fadefn)

    inst.state = "show"
        
        for i = 1,6 do
            local white = i<=3 and 1 or 0.5
            local delta = i<=3 and 1/30 or 1/60
            local chain = inst["chain"..i]
            chain.AnimState:PlayAnimation("boost"..i)
            chain.AnimState:PushAnimation("idle"..i , true)
            setcolour(chain,COLOUR.F)
            if chain.cooldown then chain.cooldown:Cancel() end
            if chain.busy then chain.busy:Cancel()end
            chain:StopUpdatingComponent(chain.components.colourtweener)

            chain.w = white  
            chain.AnimState:SetAddColour(chain.w,chain.w,chain.w,1) 

            chain.cooldown = chain:DoPeriodicTask(0,function (chain)
                chain.w = chain.w - delta
                chain.AnimState:SetAddColour(chain.w,chain.w,chain.w,1)
                if chain.w < 0 then 
                    chain.cooldown:Cancel()
                end
            end)
            chain:AddTag("busy") 
            chain.busy = chain:DoTaskInTime(1,function (chain) chain:RemoveTag("busy")end)
        end
end

local function hide(inst)
    inst:Hide()
end

local function shine(inst,num)
    local chain = inst["chain".. num]
    if not chain:HasTag("busy") then
        chain.AnimState:PlayAnimation("shine"..num)
        chain.AnimState:PushAnimation("idle"..num)
    end
end

local function fade(inst)
    local _r,_g,_b,_a =inst.chain1.AnimState:GetMultColour()
    --print(tostring(_r),tostring(_g),tostring(_b),tostring(_a))
    if _a == 0 then 
        return 
    end

    for i = 1,6 do 
        local chain = inst["chain"..i]
        chain.components.colourtweener:StartTween({0,0,0,0},3,function ()inst.state = "hide" end)
    end
end 

function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()

    for i = 1,6 do
        inst["chain".. i] = SpawnPrefab("kyouko_chain")
        inst["chain".. i].entity:SetParent(inst.entity)
        inst["time".. i] = i+3
        if i <= 3 then 
            --inst["chain".. i].AnimState:SetLayer(LAYER_WORLD_CEILING)
        else
            inst["chain".. i].AnimState:SetLayer(LAYER_WORLD_BACKGROUND)
        end
    end
    inst:DoPeriodicTask(.1,tryshine)

    inst.boostfn = boost
    inst.idlefn = idle
    inst.fadefn = fade
    inst.shinefn = shine
    inst.hidefn = hide
    inst.shakefn = shake

    inst.state = "hide"

    inst:AddTag("fx")
    
    return inst

end

return 
Prefab("common/fx/kyouko_shield", fn, assets,prefabs)
