local L = PUELLA_MOD_SETTINGS.LANGUAGE 

STRINGS.NAMES.KYOUKO_SPEAR = L and "Kyouko lance" or "杏子的长枪"
STRINGS.CHARACTERS.KYOUKO.DESCRIBE.KYOUKO_SPEAR = L and "This lance is made of magic." or "这是一把魔法长枪。"

local assets =
{
    Asset("ANIM","anim/kyouko_spear.zip"),
    Asset("ANIM","anim/swap_kyouko_spear.zip"),
    Asset("ATLAS","images/inventoryimages/kyouko_spear.xml"),
}
local dmg = 45
local ignore_value = .25
--local area_dmg = 25
--local range = 3

local prefebs= {}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_kyouko_spear", "swap_kyouko_spear") 
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    if owner.components.magicalcharge.state < 3 then 
        inst:DoTaskInTime(0, inst.Remove)
    end
end
local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal")
    inst:DoTaskInTime(0,inst.Remove)
end

---旧版横扫机制
--[[
local function onattack(inst, owner, target)
    if not target or not target:IsValid()then
        return
    end

    if math.random() < -.2 then
        local muti = owner.components.soulgem.rate --和饥饿值有关  0/1/1.5
        owner.components.soulgem:DoDelta(muti*0.2+0.1,true)-- 0.1/0.3/0.4
        --额外伤害
        local pos = target:GetPosition()
        local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, range)
        for k,v in pairs(ents) do 
            if v.components.health and v.components.combat and not v.components.health:IsDead() and not v:HasTag("player") then
                if v.prefab == "qw_stem" then
                    v.components.health:Kill()
                else
                    v.components.combat:GetAttacked(owner,area_dmg)
                end
            end
        end

        local fx = SpawnPrefab("groundpoundring_fx")
        fx.Transform:SetPosition(pos.x,pos.y,pos.z)
        fx.Transform:SetScale(.5,.5,.5)
        fx.AnimState:SetMultColour(1,.5,.5,.8)

        owner.sg:GoToState("chop")  
    end 
   
end
 --]]
local function fn()
	local inst = CreateEntity()
    inst.entity:AddTransform() 
    inst.entity:AddAnimState() 
    inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "idle_water", "idle")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/kyouko_spear.xml"
    inst.components.inventoryitem.keepondeath = true
    
    if GetPlayer().prefab == "kyouko" then
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("weapon")
    PUELLA_MOD_FN.SetMagicalWeapon(inst,dmg,ignore_value)
    end
    
    inst:AddTag("irreplaceable",'magicweapon','sharp')

	return inst
end


return Prefab("common/inventory/kyouko_spear", fn, assets)
