local assets =
{
    Asset("ANIM", "anim/heal_fx2.zip"),
    --Asset("ANIM", "anim/heal_fx3.zip"),
    Asset("ANIM", "anim/heal_fx4.zip"),
    Asset("ANIM", "anim/purify_fx.zip"),
    Asset("ANIM", "anim/sayaka_darkness_debuff.zip"),
}
local kyouko_assets = 
{
    Asset( "ANIM", "anim/kyouko_chain.zip"),
}
local sayaka_assets = 
{
    Asset( "ANIM", "anim/sayaka_dark_fx.zip"),
}
local homura_assets = 
{
    Asset("ANIM", "anim/homura_rpg_smoke.zip"),
    Asset("ANIM", "anim/homura_gun_fire.zip"),
}

local function purify()
    local inst = CreateEntity()
    inst:AddTag("ignoretimemagic")
    inst:AddTag("fx")
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    anim:SetBank("ringmeter")
    anim:SetBuild("ringmeter_pmmm")
    --anim:SetMultColour(.5,.5,.5,0)
    local s = 2.5
    trans:SetScale(s,s,s)
    --anim:PlayAnimation("progress")
    inst:AddComponent("colourtweener")
    inst.InFn = function(inst,pos)
        inst.Transform:SetPosition(pos.x,pos.y+1,pos.z)
    end
    inst.OutFn = function(inst)
        inst.num = 0
        inst:DoPeriodicTask(0,function()
            inst.num = inst.num+1
            local s_plus = s+inst.num*0.01
            trans:SetScale(s_plus,s_plus,s_plus)
        end)
        inst.components.colourtweener:StartTween({0,0,0,0},.7,inst.Remove)
        inst.AnimState:PlayAnimation("flash")
    end

    return inst
end

local function lavaring()
    local inst = CreateEntity()
    inst:AddTag("ignoretimemagic")
    inst:AddTag("fx")
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    anim:SetBank("ringmeter")
    anim:SetBuild("ringmeter_pmmm")
    --anim:SetMultColour(.5,.5,.5,0)
    trans:SetScale(3,3,3)
    inst.ShowFn = function(inst,pos)
        inst:Show()
        inst.AnimState:PlayAnimation("progress")
        inst.AnimState:PushAnimation("flash",false)
        inst.Transform:SetPosition(pos.x,pos.y,pos.z)
    end
    inst.HideFn = function(inst)
       inst:Hide()
    end
    inst.GroundFn = function(inst)
        inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround )
        inst.AnimState:SetLayer( LAYER_BACKGROUND )
        inst.AnimState:SetSortOrder(3)
        inst.AnimState:SetMultColour(.1,.1,.1,0)
        inst.Transform:SetScale(2,2,2)
        inst:Hide()
    end

    return inst
end

local function common(num)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    anim:SetBank("heal_fx" .. num)
    anim:SetBuild("heal_fx" .. num)
    anim:PlayAnimation("anim")
    inst:AddTag("fx")
    return inst
end

local function fn2()    ----boom
    local inst = common(2)
    --inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/shocked")
    inst:ListenForEvent( "animover", function(inst) inst:Remove() end )
    inst.Transform:SetScale(2,2,2)
    return inst
end

local function fn4()    ----ring
    local inst = common(4)
    --inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/shocked")
    --inst:ListenForEvent( "animover", function(inst) inst:Remove() end )
    inst.Transform:SetScale(1.5,1.5,1.5)
    inst.AnimState:PushAnimation("anim",true)
    return inst
end

local function kyouko_chain()  --chain
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    anim:SetBank("kyouko_chain")
    anim:SetBuild("kyouko_chain")
    --anim:SetMultColour(1,.5,.5,.7)
    trans:SetScale(.85,.85,.85)
    inst:AddTag("fx")

    inst:AddComponent("colourtweener") 
    return inst
end

local function sayaka_dark_fx()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    anim:SetBank("sayaka_dark_fx")
    anim:SetBuild("sayaka_dark_fx")
    anim:PlayAnimation("anim")
    --anim:SetMultColour(1,.5,.5,.7)
    trans:SetScale(.85,.85,.85)
    inst:AddTag("fx")

    inst:AddComponent("colourtweener") 
    return inst
end

local function sayaka_darkness_debuff()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    inst.entity:AddFollower()

    anim:SetBank("sayaka_darkness_debuff")
    anim:SetBuild("sayaka_darkness_debuff")
    inst.anim = math.random(1,9)
    anim:PlayAnimation(""..inst.anim)
    anim:SetMultColour(0.2,0.2,0.2,0)
    trans:SetScale(1.5,1.5,1.5)
    inst:AddTag("fx")

    inst.SetIntensity = function(intensity) --传入 0~1
        anim:SetMultColour(0.2,0.2,0.2,Remap(intensity, 0, 1, 0.6, 1))
    end

    inst.Shine = function()
        local fx = SpawnPrefab('sayaka_darkness_debuff')
        fx.AnimState:PlayAnimation(""..inst.anim)
        fx.Transform:SetPosition(inst:GetPosition():Get())
        fx.AnimState:SetMultColour(0.5,0.5,0.5,0.5)
        fx.components.colourtweener:StartTween({0.5,0.5,0.5,0},0.8,inst.Remove)
        fx.components.sizetweener:StartTween(1.5*1.5,0.8)
    end

    inst.StartShine = function()
        inst:DoPeriodicTask(0.66,inst.Shine)
    end

    inst.Fade = function()
        inst.components.colourtweener:StartTween({0,0,0,0},1,inst.Remove)
    end

    inst:AddComponent("colourtweener") 
    inst:AddComponent("sizetweener")
    return inst
end

local function homura_rpg_smoke()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    trans:SetFourFaced()
    PUELLA_MOD_FN.SetAnim(inst,'homura_rpg_smoke', 'homura_rpg_smoke', 'idle')

    inst:AddTag('FX','NOCLICK')
    inst:ListenForEvent('animover',inst.Remove)

    inst:AddComponent('ignoretimemagic')
    inst.components.ignoretimemagic:Set(3)
    inst.components.ignoretimemagic:StartUpdating()

    return inst
end

local function homura_gun_fire()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    trans:SetFourFaced()
    PUELLA_MOD_FN.SetAnim(inst,'homura_gun_fire', 'homura_gun_fire', 'anim1', nil, true, 3)
    anim:SetLightOverride(0.5)
    anim:SetBloomEffectHandle("shaders/anim.ksh")
    inst:AddTag('FX','NOCLICK')
    --inst:ListenForEvent('animover',inst.Remove) --用lighttweener组件移除

    inst.SetRandomScale = function(inst,min,max)
        local s = GetRandomMinMax(min,max)
        trans:SetScale(s,s,1)
    end

    local light = inst.entity:AddLight()
    light:Enable(true)
    light:SetRadius(.1)
    light:SetFalloff(.5)
    light:SetIntensity(.5)
    light:SetColour(0.75,0.75,0)

    inst:AddComponent('lighttweener')
    inst.components.lighttweener:StartTween(light, 0.5, 0.3, 0.9, nil, 2/30, function(inst)
        inst.components.lighttweener:StartTween(light, 0, 0.5, 0, nil, 3/30, inst.Remove)
    end)

    inst:AddComponent('ignoretimemagic')
    inst.components.ignoretimemagic:Set(2)
    inst.components.ignoretimemagic:StartUpdating()
    
    return inst
end

local function homura_gun_light()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()

    inst:AddTag('FX','NOCLICK')
    inst:AddTag('ignoretimemagic')

    local light = inst.entity:AddLight()
    light:Enable(true)
    light:SetRadius(.1)
    light:SetFalloff(.5)
    light:SetIntensity(.5)
    light:SetColour(0.75,0.75,0)

    inst:AddComponent('lighttweener')
    inst.components.lighttweener:StartTween(light, 0.5, 0.3, 0.9, nil, 2/30, function(inst)
        inst.components.lighttweener:StartTween(light, 0, 0.5, 0, nil, 3/30, inst.Remove)
    end)
    inst.persists = false

    return inst
end


return 
Prefab("common/fx/magicalboom_fx", fn2, assets),
Prefab("common/fx/magicalring_fx", fn4, assets),
Prefab("common/fx/magic_purify_fx",purify,assets),
Prefab("common/fx/lava_ring",lavaring,assets),
Prefab("common/fx/kyouko_chain", kyouko_chain, kyouko_assets),
Prefab("common/fx/sayaka_dark_fx", sayaka_dark_fx, sayaka_assets),
Prefab('sayaka_darkness_debuff',sayaka_darkness_debuff, sayaka_assets),
Prefab('homura_rpg_smoke',homura_rpg_smoke, homura_assets),
Prefab('homura_gun_fire',homura_gun_fire, homura_assets),
Prefab('homura_gun_light',homura_gun_light)