local function setbehavior(inst)
    for i = 1,20 do
        inst:DoTaskInTime(.6*i,function(inst)
            inst.AnimState:SetDeltaTimeMultiplier(.2+i*.04)
        end)
    end
    inst:DoTaskInTime(12.1,function (inst)
        inst.AnimState:PlayAnimation("butterfly_ring_pst")
        inst.components.colourtweener:StartTween({0,0,0,0},1,inst.Remove)
    end)
    inst:DoTaskInTime(12.5,function (inst)
        GetSeasonManager():DoLightningStrike(inst:GetPosition())
        SpawnPrefab("witch_qw").Transform:SetPosition(inst:GetPosition():Get())
        inst.SoundEmitter:PlaySound("lw_witch/qw/onspawn")
        inst.lightfx:TurnOff()
    end)
end

local assets=
{
    Asset("ANIM", "anim/witch_qw_fx.zip"),
}

local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()

    anim:SetBank("fx")
    anim:SetBuild("witch_qw_fx")
    anim:PlayAnimation("butterfly_ring_spawn")
    anim:PushAnimation("butterfly_ring_loop",true)
    inst.AnimState:SetDeltaTimeMultiplier(.2)

    snd:PlaySound("lw_witch/qw/coming")

    trans:SetScale(1.5,1.5,1.5)

    inst:AddComponent("colourtweener")
 
    setbehavior(inst)
    
    inst:AddTag("FX")
    inst:AddTag("NOCLICK")

    inst.lightfx = SpawnPrefab("chesterlight")
    inst.lightfx.entity:SetParent(inst.entity)
    inst.lightfx:TurnOn()

    return inst
end

return Prefab( "common/inventory/qw_spawner", fn, assets) 