local L = PUELLA_MOD_SETTINGS.LANGUAGE 

STRINGS.NAMES.SAYAKA_SWORD = L and "Sayaka sword" or "西洋剑"
STRINGS.CHARACTERS.KYOUKO.DESCRIBE.SAYAKA_SWORD = L and "It's ... confusing." or "我...我没看错吧？"

local assets =
{
Asset("ANIM","anim/swap_sayaka_sword.zip"),
Asset("ATLAS","images/inventoryimages/sayaka_sword.xml"),
}
local dmg = 34
local bonus = .25

local prefebs= {}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_sayaka_sword", "swap_sayaka_sword") 
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    --owner.components.combat.min_attack_period = .4
    if owner.components.magicalcharge.state < 3 then 
        inst:DoTaskInTime(0, inst.Remove)
    end
end
local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal")
    --owner.components.combat.min_attack_period = .5
    inst:DoTaskInTime(0, inst.Remove)
end

local function fn()
	local inst = CreateEntity()

    inst.entity:AddTransform() 
    inst.entity:AddAnimState() 
    inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/sayaka_sword.xml"
    inst.components.inventoryitem.keepondeath = true
    
    if GetPlayer().prefab == "sayaka" then
        inst:AddComponent("equippable")
        inst.components.equippable:SetOnEquip(onequip)
        inst.components.equippable:SetOnUnequip(onunequip)
        --inst.components.equippable.walkspeedmult = .15

        inst:AddComponent("weapon")
        PUELLA_MOD_FN.SetMagicalWeapon(inst,dmg,bonus)

        inst:AddComponent("sayakasword_skill")
    end
    
    inst:AddTag("irreplaceable",'magicweapon','sharp')
    
	return inst
end


return Prefab("common/inventory/sayaka_sword", fn, assets)


    