--线程真好用
local assets =  
{ 
    Asset("ANIM", "anim/soulgem_revive_fx.zip"),
    Asset("ANIM", "anim/soulgem_revive_glow.zip"),
    Asset("SOUNDPACKAGE", "sound/lw_revive.fev"),
    Asset("SOUND", "sound/lw_revive.fsb"), 
}

local function Tags(inst)
    inst:AddTag("FX")
    inst:AddTag("NOCLICK")
    inst:AddTag("ignoretimemagic")
end

local function CreateUpFx(parent)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()

    anim:SetBank("soulgem_revive_glow")
    anim:SetBuild("soulgem_revive_glow")
    anim:PlayAnimation("up")
    anim:SetDeltaTimeMultiplier(.8)
    local r,g,b,a = unpack(parent.player.themecolour)
    anim:SetMultColour(r,g,b,1)
    trans:SetScale(1.8,1.8,1.8)

    Tags(inst)

    inst:ListenForEvent("animover",inst.Remove)    
    inst:DoTaskInTime(.5,function()snd:PlaySound("lw_revive/revive/1",nil,.8)end)

    return inst
end

local function CreateSG(parent)
    local function sg (parent)
        local soulgem = CreateEntity()
        local trans = soulgem.entity:AddTransform()
        local anim = soulgem.entity:AddAnimState()
        local snd = soulgem.entity:AddSoundEmitter()
        anim:SetBank("soulgem_revive_glow")
        anim:SetBuild("soulgem_revive_glow")
        local r,g,b,a = unpack(parent.player.themecolour)
        anim:SetMultColour(r,g,b,a)
        trans:SetScale(1.5,1.5,1.5)

        Tags(soulgem)

        soulgem:StartThread(function ()
            Sleep(.5)
            anim:PlayAnimation("sg")
            Sleep(3)--3.5
            local i = 15
            while i > 0 do
                i = i-1
                anim:SetMultColour(i/15*r,i/15*g,i/15*b,i/15*a)
                Sleep(0)
            end
            return true
        end)

        return soulgem
    end
    local function glow (parent)
        local glow = CreateEntity()
        local trans = glow.entity:AddTransform()
        local anim = glow.entity:AddAnimState()
        local snd = glow.entity:AddSoundEmitter()

        glow.entity:AddLight()
        glow.Light:Enable(true)
        glow.Light:SetIntensity(.3)--光强
        glow.Light:SetColour(unpack(parent.player.themecolour))
        glow.Light:SetFalloff(.5) --衰减
        glow.Light:SetRadius(.4) --半径

        anim:SetBank("soulgem_revive_glow")
        anim:SetBuild("soulgem_revive_glow")
        local r,g,b,a = unpack(parent.player.themecolour)
        anim:SetMultColour(r,g,b,1)
        trans:SetScale(1.5,1.5,1.5)

        Tags(glow)

        glow:StartThread(function ()
            Sleep(.5)
            anim:PlayAnimation("glow",true)
            Sleep(3) --3.5
            anim:PlayAnimation("glow_pst")
            glow:ListenForEvent("animover",glow.Remove)
            return true
        end)
        return glow
    end

    local inst = CreateEntity()
    Tags(inst)
    local trans = inst.entity:AddTransform()
    inst.soulgem = sg(parent)
    inst.soulgem.entity:SetParent(inst.entity)
    inst.glow = glow(parent)
    inst.glow.entity:SetParent(inst.entity)

    return inst

end

local function CreateTail(parent)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    MakeCharacterPhysics(inst,1,.01)
    RemovePhysicsColliders(inst)

    anim:SetBank("soulgem_revive_fx")
    anim:SetBuild("soulgem_revive_fx")
    anim:SetMultColour(unpack(parent.player.themecolour))
    anim:PlayAnimation("anim1",true)
    trans:SetScale(.1,.1,.1)

    inst:AddTag("FX")
    inst:AddTag("NOCLICK")
    inst:AddTag("ignoretimemagic")
    inst.persists = false

    inst:ListenForEvent("animover",inst.Remove)
    return inst
end

local function UpdateTail(inst,parent)
    local tail = CreateTail(parent)
    local var = .3
    local offset = Vector3(GetRandomMinMax(-var,var),GetRandomMinMax(-var,var),GetRandomMinMax(-var,var))
    tail.Transform:SetPosition((inst:GetPosition()+offset):Get())
end

local function CreateBall(parent,soundpath)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()

    inst.entity:AddLight()
    inst.Light:Enable(true)
    inst.Light:SetIntensity(.1)--光强
    inst.Light:SetColour(unpack(parent.player.themecolour))
    inst.Light:SetFalloff(.4) --衰减
    inst.Light:SetRadius(.3) --半径

    local s = 1.6

    anim:SetBank("soulgem_revive_fx")
    anim:SetBuild("soulgem_revive_fx")
    anim:SetMultColour(unpack(parent.player.themecolour))
    anim:PlayAnimation("anim2",true)
    trans:SetScale(s,s,s)
    snd:PlaySound("lw_revive/revive/3", nil, .5)

    inst:AddTag("FX")
    inst:AddTag("NOCLICK")
    inst:AddTag("ignoretimemagic")
    inst.persists = false
    inst.entity:SetParent(parent.entity)

    inst:DoPeriodicTask(0,UpdateTail,nil,parent)

    return inst
end

local function GetTrack() --获得法球轨迹坐标
    --math.randomseed(tostring(os.time()):reverse():sub(1, 7))
    local height = 3.5
    local wide = .3
    local parallel_speed = .4
    local var,var_min,var_max = 1,0.5,2 --浮动系数
    local converge = 1                  --收敛系数
    local right_vec = TheCamera:GetRightVec()
    local i_offset = math.random()*6.283 --初始值偏差
    local table = {}
    local frame = 30

    for i = 1,frame do
        local y_percent = i/frame
        local x_offset = math.sin(i*parallel_speed+i_offset)
        if math.abs(x_offset) < .05 then
            var = GetRandomMinMax(var_min,var_max)
        end
        converge = 1 - 25*math.pow( math.max(0,(y_percent - 0.8)) , 2)
        local x = math.sin(i_offset+i*parallel_speed) * wide * var * converge
        local vec1 = right_vec * x

        local y = Vector3( 0,(1-y_percent)*height,0)
        table[i] = vec1 + y
    end
    return table
end

local function BallFn(inst,delay)
    local ID = delay
    Sleep(delay)
    inst["ball"..ID] = CreateBall(inst,delay*2)  --3,5,7
    local table = GetTrack()
    local i = 1
    while table[i] do
        inst["ball"..ID].Transform:SetPosition(table[i]:Get())
        i = i+1
        Sleep(0)
    end
    inst["ball"..ID].AnimState:PlayAnimation("blast2")
    local pos = inst:GetPosition()
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 15)
    for k,v in pairs(ents) do
        if v ~= inst and v.components.sleeper then
            v.components.sleeper:GoToSleep(20)
        end 
    end
    local ents_witch = TheSim:FindEntities(pos.x,pos.y,pos.z, 50)
    for k,v in pairs(ents_witch) do
        if v.components.combat and v:HasTag('witch')then
            v.components.combat.target = nil
        end 
    end

    inst.player.components.sayaka_healed:ReviveShine()
    inst["ball"..ID]:ListenForEvent("animover",inst["ball"..ID].Remove)
end

local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()

    inst.player = GetPlayer() --联机版使用时删去这句
    
    Tags(inst)

    inst.upfx = CreateUpFx(inst)
    inst.upfx.entity:SetParent(inst.entity)

    inst.soulgem = CreateSG(inst)
    inst.soulgem.entity:SetParent(inst.entity)
    inst.soulgem.Transform:SetPosition(0,3.5,0)

    inst:StartThread(function()
        BallFn(inst,1.5) 
        return true
    end)
    inst:StartThread(function()
        BallFn(inst,2.5)
        return true
    end)
    inst:StartThread(function()
        BallFn(inst,3.5)
        Sleep(3)
        inst:Remove()
        return true
    end)

    return inst
end

return Prefab("common/fx/soulgem_revive_fx",fn,assets)