local assets = {
    Asset("SOUNDPACKAGE", "sound/lw_griefseed.fev"),
    Asset("SOUND", "sound/lw_griefseed.fsb"), 
    }
local function ondisappear()
    GetPlayer().components.witchspawner:OnSearchFailed()
end

local function update(inst) 
    if inst.timeout < 0 then 
        inst:Remove()
        ondisappear() 
        return
    end

    local pos = inst:GetPosition()
    local pos2 = GetPlayer():GetPosition()
    local dist = pos:Dist(pos2)
    if dist > 100 then
        inst.timeout = inst.timeout - 3
    elseif dist > 70 then
        inst.timeout = inst.timeout - 2
    elseif dist > 40 then
        inst.timeout = inst.timeout - 1
    elseif dist > 15 then
        --
    elseif dist >= 0 then
        inst:triggerFn()
    end
end

local function playsound(inst)
    local vec = inst:GetPosition() - GetPlayer():GetPosition()
    local dire = vec:Normalize()
    local len = vec:Length()
    local targpos = GetPlayer():GetPosition() + dire*10
    local vol = math.max(0.3,2-len/30)

    local snd = CreateEntity()
    snd.entity:AddTransform()
    snd.entity:AddSoundEmitter()
    snd.Transform:SetPosition(targpos:Get())
    snd.SoundEmitter:PlaySound("lw_griefseed/sfx/shine1",nil,vol)
    snd:DoTaskInTime(5,snd.Remove)

    inst:DoTaskInTime(math.random(15,20),playsound)
end

local function trigger(inst)
    inst.spawner = inst.spawner or 'qw_spawner'
    SpawnPrefab(inst.spawner).Transform:SetPosition(inst:GetPosition():Get())
    inst.triggered = true
    inst:Remove()
end

local function fn()
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity() 
    
    inst:DoPeriodicTask(1,update)
    inst:DoTaskInTime(0,playsound)
    inst.auto_trigger_task = inst:DoTaskInTime(0,trigger)

    inst.triggerFn = trigger

    inst.timeout = 300

    inst.OnSpawn = function(inst) inst.auto_trigger_task:Cancel() end
    inst.OnSave = function(inst,data)data.timeout = inst.timeout; data.spawner = inst.spawner end
    inst.OnLoad = function(inst,data)inst.timeout = data.timeout; inst.spawner = data.spawner; inst:OnSpawn() end
    
    inst:AddTag("NOBLOCK","NOCLICK","INLIMBO","FX")
    inst:AddTag("witch_pos")

    return inst
end

local function qw()
    local inst = fn()
    inst.spawner = 'qw_spawner'
    return inst
end

local function tv()
    local inst = fn()
    inst.spawner = 'witch_tv'
    return inst
end

local function sd()
    local inst = fn()
    inst.spawner = 'witch_sd_tower'
    return inst
end

local function debugfn()
    local inst = fn()
    inst.spawner = 'qw_spawner'
    inst.auto_trigger_task:Cancel()

    return inst
end

return 
Prefab("witch_qw_pos", qw),Prefab("witch_tv_pos", tv),Prefab("witch_sd_pos", sd)
--,Prefab('debugpos', debugfn)