local assets_qw =
{
    Asset("ANIM", "anim/witch_qw_icon.zip"),
}
local function SpawnIcon(colour,scale)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    PUELLA_MOD_FN.SetAnim(inst,"witch_qw_fx","fx","icon",true,true)

    trans:SetScale(scale,scale,scale)

    inst.entity:AddLight()
    inst.Light:Enable(true)
    inst.Light:SetIntensity(.2)--光强
    inst.Light:SetColour(colour[1],colour[2],colour[3])
    inst.Light:SetFalloff(.5) --衰减
    inst.Light:SetRadius(.5) --半径

    inst.SetSpeed = function (speed)
        anim:SetDeltaTimeMultiplier(speed)
    end

    inst.persists = false
    inst:AddTag("FX")

    return inst
end
local function icon_1()     --地雷
    local inst = SpawnIcon({1,1,.4},1.5)
    ---[[
    --inst.SoundEmitter:PlaySound("lw_witch/qw/magic2")

    inst:DoTaskInTime(0,function ()
        if inst.caster then
            inst:ListenForEvent("death",function()inst:Remove()end,inst.caster)
        end
        if inst.exist_time then
            inst:DoTaskInTime(inst.exist_time,function()
                inst:Remove()
                --inst.SoundEmitter:PlaySound("")      
            end)
        end
    end)   
    inst:DoPeriodicTask(.33,function ()
        local dist = inst:GetDistanceSqToInst(GetPlayer())  --距离的平方
        local animspeed = math.max(1,50/dist/2)
        inst.SetSpeed(animspeed)
        if dist < 1 then
            inst.caster.components.qw_stemspawner:SpawnStemAt(inst:GetPosition())
            --inst.SoundEmitter:PlaySound("")
            inst:Remove()
        end
    end)
--]]
    return inst
end

local function CreateSingleNeedle()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    PUELLA_MOD_FN.SetAnim(inst,"witch_qw_icon","witch_qw_needle","anim",true,true)
    local s = .9
    trans:SetScale(s,s,s)
    anim:SetMultColour(.2,.2,1,.75)
    inst:AddTag("FX")
    inst:AddTag("NOCLICK")
    return inst
end

local function CreateIndicator()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    inst.num = math.random(2,4)
    inst.length = (10 - inst.num)*GetRandomMinMax(.8,1.2) --每条的长度
    for i = 1,inst.num do
        local needle = CreateSingleNeedle()
        inst:AddChild(needle)
        needle.Transform:SetRotation(360/inst.num*i)
    end
    inst:AddTag("FX")
    inst:AddTag("NOCLICK")

    return inst
end

local function icon_2()
    local inst = SpawnIcon({0,0,0},1.5)
    inst.indi = CreateIndicator()
    inst.indi.entity:SetParent(inst.entity)
    inst.countdown_task = inst:DoPeriodicTask(0.1,function()
        local angle = inst.indi.Transform:GetRotation()
        inst.indi.Transform:SetRotation(angle+2)
        if inst.exist_time then
            inst.exist_time = inst.exist_time - 0.1
            inst.SetSpeed(math.max(0.5,3-inst.exist_time)*1.2+0.5)
            if inst.exist_time < 0 then
                for needle,_ in pairs(inst.indi.children)do
                    local angle = needle.Transform:GetRotation()*DEGREES
                    local length = inst.indi.length
                    local interval = 0.8
                    local dist = interval/2
                    while dist < length do
                        dist = dist + interval
                        local pos = inst:GetPosition()+Vector3(dist*math.cos(angle),0,-dist*math.sin(angle))
                        inst:DoTaskInTime(dist/length/2.5,function ()
                            inst.caster.components.qw_stemspawner:SpawnStemAt(pos)
                        end)
                    end
                end
                inst:DoTaskInTime(.5,inst.Remove)
                inst.countdown_task:Cancel()
            end
            
        end
    end)

    return inst
end

local function icon_3() --排列类似传送基座
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()

    local side = math.random(3,6) --多边形边数
    local faced = math.random()*6.283
    local r = side == 3 and 10 or 8  -- 半径（定义见math）
    inst:DoTaskInTime(0,function ()
        inst.math = PUELLA_MOD_MATH.POLYGON(inst:GetPosition(),r,side,faced)
        inst.child_pos_table = inst.math:GetPointPosition()
        for i = 1,side do
            local pos = inst.child_pos_table[i]
            inst["icon"..i] = SpawnIcon({0,0,0},1.5)
            inst["icon"..i].SoundEmitter:PlaySound('lw_witch/qw/magic2')
            inst["icon"..i].AnimState:SetAddColour(0,0,1,1)
            inst["icon"..i].Transform:SetPosition(pos:Get())
            inst["icon"..i]:ForceFacePoint(inst:GetPosition())
        end
        if inst.exist_time then
            inst:DoTaskInTime(inst.exist_time,inst.Remove)
        end
    end)
    inst:DoPeriodicTask(.1,function ()
        local _out = inst.math:PointIs(GetPlayer(),r+1)
        local _in  = inst.math:PointIs(GetPlayer(),r-1)
        --if GetDebugEntity() == inst then print('1: '.._in..'    2:' .._out) end
        if _in == "out" and _out == "in" then  --夹在两个圆之间
            --do return end
            for _,pos in pairs(inst.math:GetTracePosition(1))do
                inst.caster.components.qw_stemspawner:SpawnStemAt(pos,0.3*math.random())
            end
            inst:Remove()
        end
    end)
    inst.OnRemoveEntity = function(inst)
        for i = 1,side do
            inst["icon"..i]:Remove()
        end
    end
    return inst
end


return 
Prefab("common/fx/witch_qw_icon_mi", icon_1, assets_qw),
Prefab("common/fx/witch_qw_icon_cr", icon_2, assets_qw),
Prefab("common/fx/witch_qw_icon_sr", icon_3, assets_qw)