
local assets=
{
    Asset("ANIM", "anim/lw_rotation_anim.zip"),
    Asset("ANIM", "anim/sd_charge_fx_build.zip"),
    Asset("ANIM", "anim/sd_ball.zip"),
    Asset("ANIM", 'anim/lavaarena_item_pickup_fx_pmmm.zip'),
    Asset("ANIM", 'anim/witch_sd_blastfx.zip'),

}
local prefabs = {}

local function CreateTail(target) --拖尾
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    PUELLA_MOD_FN.SetAnim(inst,'sd_ball','sd_ball','anim',true)
    anim:SetTime(math.random(5)*FRAMES)
    anim:SetMultColour(0,0,0,0.8)
    local s = 1
    inst:DoPeriodicTask(0,function()trans:SetScale(s,s,s);s=s-1/20;if s<=0 then inst:Remove()end;end)

    return inst
end

local function UpdateTails(inst,target,white)
    if not target or not target:IsValid() then
        return
    end
    local tail = CreateTail(target,white)
    local pos = inst:GetPosition()
    local targpos = pos+Vector3(0.5*math.random(),0.5*math.random(),0.5*math.random())
    tail.Transform:SetPosition(targpos:Get())

    tail:AddComponent('fallingprojectile')
    tail.components.fallingprojectile:Set(GetRandomMinMax(1,3),false,true)
    tail.components.fallingprojectile:Launch(nil,target)
end

local function Ball() -- 飞行小球 prefab: sd_ball
    local OnLaunch = function(inst,attacker,target)
        inst:DoPeriodicTask(0,UpdateTails,nil,inst)
        inst.Follower:FollowSymbol(inst.GUID,'',0,0,0) --解绑
        inst.SoundEmitter:PlaySound('lw_witch/sd/tower_atk')
    end
    local OnHit = function(inst,attacker,target)
        local pos = inst:GetPosition()
        local ents = TheSim:FindEntities(pos.x,pos.y,pos.z,2.5,{"combat"},{"death","falling", "DECOR", "INLIMBO","witch"})
        for _,v in pairs(ents)do
            if v.components.health then
                v.components.combat:GetAttacked(inst.caster and inst.caster.witch and 
                    inst.caster.witch.components.sd_shadowspawner:GetRedirectTarget(), 20)
                v.components.witchsd_darkness_debuff:AddDebuff(15)
            end
        end

        local explode = SpawnPrefab("explode_small")
        explode.Transform:SetPosition(pos:Get())
        explode.AnimState:SetMultColour(0,0,0,0.8)
        inst:Remove()
    end

    local s = .2
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    inst.entity:AddFollower()
    PUELLA_MOD_FN.SetAnim(inst,'sd_ball','sd_ball','anim',true)
    anim:SetMultColour(0,0,0,0.8)
    trans:SetScale(s,s,s)

    inst:AddComponent('fallingprojectile')
    inst.components.fallingprojectile:Set(3,1.2)
    inst.components.fallingprojectile.onlaunchfn = OnLaunch
    inst.components.fallingprojectile.onhitground = OnHit

    inst.becomebigtask = inst:DoPeriodicTask(0,function()
        trans:SetScale(s,s,s);s = s + 0.8/15
        if s >= 1 then
            inst.canshoot = true
            if inst.instantshoot then
                if inst.caster and inst.caster:IsValid() then
                    local witch = inst.caster.witch
                    local target = witch and witch.components.combat.target or GetPlayer()
                    inst.components.fallingprojectile:Launch(witch,target)
                end
            end
            inst.becomebigtask:Cancel()
        end
    end)

    return inst
end

local function MakeSingleChargeFx(scale,data) --单个蓄力粒子
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    PUELLA_MOD_FN.SetAnim(inst,'lw_rotation_anim','lw_rotation_anim','anim'..(math.random(360)-1))
    
    anim:SetMultColour(0,0,0,0.4)
    local s = GetRandomMinMax(scale[1],scale[2])
    trans:SetScale(s,s,s)
    for i = 2,5 do
        anim:Hide('symbol'..i)
    end
    local tick = 0
    anim:OverrideSymbol('symbol1','sd_charge_fx_build','symbol1-'..tick)

    inst.animtask = inst:DoPeriodicTask(0,function()
        tick = tick+1
        anim:OverrideSymbol('symbol1','sd_charge_fx_build','symbol1-'..tick)
        anim:SetMultColour(0,0,0,0.4+tick*0.04)

        if tick > 15 then
            inst.animtask:Cancel()
            inst.components.colourtweener:StartTween({0,0,0,0},5*FRAMES,inst.Remove)
        end
    end)

    inst:AddComponent('colourtweener')

    local follower = inst.entity:AddFollower()
    if data then    
        follower:FollowSymbol(unpack(data))
    end

    inst:AddTag('FX')

    return inst
end

local function MakeChargeFx() ---粒子向中间汇集  prefab: sd_charge_fx
    local inst = PUELLA_MOD_FN.CreateEntity()
    inst.entity:AddFollower()

    inst:DoPeriodicTask(0,function()
        local pos = inst:GetPosition()
        local fx = MakeSingleChargeFx({1.5,2},inst.followerdata)
        fx.Transform:SetPosition(pos:Get())
    end)
    return inst
end
---------
local function MakeArc()
    local inst,trans,anim = PUELLA_MOD_FN.CreateEntity()
    trans:SetScale(.75,.75,.75)
    anim:SetBank('puellaUI_homurafocus')
    anim:SetBuild('puellaUI_homurafocus')
    anim:PlayAnimation('arc_slow',true)
    anim:SetLightOverride(0.5)
    anim:SetBloomEffectHandle("shaders/anim.ksh")

    inst.SetSpeed = function(inst,speed)
        anim:SetDeltaTimeMultiplier(speed)
    end

    inst.SetMultColour = function(inst,...)
        anim:SetMultColour(...)
    end

    inst.SetAlpha = function(inst,alpha)
        local r,g,b,a = anim:GetMultColour()
        anim:SetMultColour(r,g,b,alpha)
    end

    inst.SetTime = function(inst,time)
        anim:SetTime(time)
    end

    return inst
end

local function MakeTimeMagicChargeFx()
    local inst = PUELLA_MOD_FN.CreateEntity()
    inst.entity:AddFollower()
    for i = 1,3 do 
        local arc = SpawnPrefab('sd_timemagic_arc')
        arc:SetTime(i)
        arc:SetMultColour(1,.5,.5,0.5)
        inst['arc'..i] = inst:AddChild(arc)
    end
    inst.basicspeed = 1
    inst.speed = 1
    inst.SetSpeed = function(inst,speed)
        inst.speed = speed
        speed = speed * inst.basicspeed
        for k,v in pairs(inst.children)do
            k:SetSpeed(speed)
        end
    end
    inst.SetAlpha = function(inst,alpha)
        for k,v in pairs(inst.children)do
            k:SetAlpha(alpha)
        end
    end
    inst.SpeedTo = function(inst,to,time,callback)
        inst.oldspeed = inst.speed
        inst.targetspeed = to
        local tick = 0
        local totaltick = time*30

        if inst.speedup_task then
            inst.speedup_task:Cancel()
        end
        inst.speedup_task = inst:DoPeriodicTask(0,function()
            tick = tick + 1
            if tick > totaltick then
                inst.speedup_task:Cancel()
                inst.speedup_task = nil
                if callback then
                    callback(inst)
                end
            end
            local speed = Lerp(inst.oldspeed, inst.targetspeed, tick/totaltick)
            --print(speed)
            inst:SetSpeed(speed)
        end)
    end

    return inst
end

local function BlastFx()
    local inst,trans,anim = PUELLA_MOD_FN.CreateEntity()
    anim:SetBank('witch_sd_blastfx')
    anim:SetBuild('witch_sd_blastfx')
    anim:PlayAnimation('anim')
    anim:SetLayer(LAYER_WORLD_CEILING)
    anim:SetMultColour(1,0,0,1)

    trans:SetScale(4,4,2)

    inst:ListenForEvent('animover',inst.Remove)

    --inst.SoundEmitter:PlaySound('lw_griefseed/sfx/blast')
    GetPlayer().SoundEmitter:PlaySound('lw_griefseed/sfx/blast')

    inst.entity:AddFollower()
    inst.Play = function(inst, parent)
        inst.Follower:FollowSymbol(parent.GUID, 'firemarker',0,0,0)
    end
    --
    return inst
end

local function LavaItemFx()
    local inst = PUELLA_MOD_FN.CreateEntity()
    inst.AnimState:SetBank("lavaarena_item_pickup_fx")
    inst.AnimState:SetBuild("lavaarena_item_pickup_fx_pmmm")
    inst.AnimState:PlayAnimation('pre')
    inst.AnimState:PushAnimation('loop')
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
    inst.AnimState:SetFinalOffset(1)
    inst.AnimState:SetLayer(LAYER_WORLD_CEILING)

    inst:AddTag("DECOR")
    inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.AnimState:SetMultColour(1,1,1,1)
    inst.Transform:SetScale(2,2,1)

    inst.SetSpeed = function(inst, num)inst.AnimState:SetDeltaTimeMultiplier(num)end

    inst.persists = false

    inst.Fade = function(inst)
        inst.AnimState:PlayAnimation('pst')
        inst:ListenForEvent('animover', inst.Remove)
    end

    return inst
end

local function ShadowFx()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.persists = false
    inst.spawnprefabname = nil

    inst:StartThread(function()
        Sleep(0)
        if not inst.spawnprefabname then
            inst:Remove()
            return true
        end
        for i = 1,math.random(2,3)do
            local fx = SpawnPrefab(inst.spawnprefabname)
            local pos = inst:GetPosition() + Vector3(GetRandomMinMax(-1,1),0,GetRandomMinMax(-1,1))
            fx.Transform:SetPosition(pos:Get())
            Sleep(0.2)
        end
        inst:Remove()
        return true
    end)
    return inst
end

return Prefab( "sd_charge_fx", MakeChargeFx, assets, prefabs),Prefab('sd_ball',Ball,assets),
Prefab("sd_timemagic_arc",MakeArc, assets, prefabs),Prefab('sd_timemagic_fx',MakeTimeMagicChargeFx, assets, prefabs),
Prefab("sd_lavaitem", LavaItemFx),Prefab("sd_blastfx",BlastFx),Prefab('sd_shadowfx',ShadowFx)
