local function updateSG(inst) 

    local oldfn1 = inst.sg.sg.states.attack.onenter
    inst.sg.sg.states.attack.onenter = function(inst)
    --print("mod by SGsayaka.lua")
        if inst.prefab == "kyouko" and inst.components.magicalcharge.state == 3 and inst.components.skill_kyouko_sweep:CanSweep()then
            local item = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if item and item.prefab == "kyouko_spear" then --检查武器
                if not (inst.components.driver and inst.components.driver.vehicle)then --船上不允许
                    inst.sg:GoToState("kyouko_sweep_pre")
                    return
                end
            end
        end
        oldfn1(inst)
    end

    inst.sg.sg.states.kyouko_sweep_pre = 
    State{ 
        name = "kyouko_sweep_pre",
        tags = {"attack", "notalking", "abouttoattack", "busy","ignorehitstate"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("side0")  
            
                inst.SoundEmitter:PlaySound("lw_kyouko/sfx/lance")
                inst.components.skill_kyouko_sweep.cansweep = false
            
            if inst.components.combat.target then
                inst.components.combat:BattleCry()
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.components.locomotor:Stop()
            inst.components.skill_kyouko_sweep:OnSweep()
            
        end,
        
        timeline={},
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("kyouko_sweep_loop2")
            end ),
        },
    }  

    inst.sg.sg.states.kyouko_sweep_loop1 = 
    State{ 
        name = "kyouko_sweep_loop1",
        tags = {"attack", "notalking", "abouttoattack", "busy","ignorehitstate"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("side1")  
        end,
        
        timeline={},
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("kyouko_sweep_loop2")
            end ),
        },
    }  

    inst.sg.sg.states.kyouko_sweep_loop2 = 
    State{ 
        name = "kyouko_sweep_loop2",
        tags = {"attack", "notalking", "abouttoattack", "busy","ignorehitstate"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("side2") 
        end,
        
        timeline=
        {       
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("kyouko_sweep_loop3")
            end ),
        },
        onexit = function(inst)inst.AnimState:SetDeltaTimeMultiplier(1)end,
    }  

    inst.sg.sg.states.kyouko_sweep_loop3 = 
    State{ 
        name = "kyouko_sweep_loop3",
        tags = {"attack", "notalking", "abouttoattack", "busy","ignorehitstate"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("side3")  
        end,
        
        timeline=
        {
            TimeEvent(3*FRAMES, function(inst)
                local AddHurtBuff = function (targ)
                    if not targ or not targ.components.combat then
                        return
                    end
                    if not targ.components.kyouko_hurt_debuff then
                        targ:AddComponent('kyouko_hurt_debuff')
                    end
                    targ.components.kyouko_hurt_debuff:OnHeavilyAttacked()
                end
                local pos = inst:GetPosition()
                local ents = TheSim:FindEntities(pos.x,pos.y,pos.z,3,{"combat"},{"INLIMBO","death","player"})
                    for _,v in pairs(ents) do
                        local angle1 = inst.Transform:GetRotation()
                        local angle2 = inst:GetAngleToPoint(v:GetPosition())
                        local dangle = PUELLA_MOD_FN.DeltaAngle(angle1,angle2,"abs")
                        if dangle <= 75 then
                            if v == inst.components.combat.target then
                                v.components.combat:GetAttacked(inst,25,nil,"kyouko_sweep")
                            else
                                v.components.combat:GetAttacked(inst,60,nil,"kyouko_sweep")
                            end
                        end
                    end
                inst.components.combat:DoAttack()
                
                
                inst.sg:RemoveStateTag("abouttoattack") 
                inst.sg:RemoveStateTag("busy")
                inst.sg:RemoveStateTag("attack")
                inst.sg:RemoveStateTag("ignorehitstate")
            end),         
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
            EventHandler("onhitother",function(inst,data)
                local targ = data and data.target 
                if not targ or not targ.components.combat then
                    return
                end
                if data.stimuli == 'kyouko_hurt' then
                    return
                end
                if not targ.components.kyouko_hurt_debuff then
                    targ:AddComponent('kyouko_hurt_debuff')
                end
                targ.components.kyouko_hurt_debuff:OnHeavilyAttacked()
            end),
        },
        --onexit = function(inst)inst.components.skill_kyouko_sweep:OnSweep() end,
    }  
end

local function SetKyoukoSG(inst)
    updateSG(inst)
    inst:ListenForEvent('pmmm: force update sg',updateSG)
    inst:ListenForEvent("dismountboat",updateSG)
    inst:ListenForEvent("mountboat",updateSG)
end

return SetKyoukoSG
     