local function updateSG(inst) 
    local oldfn1 = inst.sg.sg.states.attack.onenter
    inst.sg.sg.states.attack.onenter = function(inst)
        if inst.prefab == "sayaka" and inst.components.magicalcharge.state == 3 then
            local item = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if item and item.prefab == "sayaka_sword" then
                inst.sg:GoToState("sayaka_quickattack")
                return
            end
        end
        oldfn1(inst)
    end

    inst.sg.sg.states.sayaka_quickattack = 
    State{ 
        name = "sayaka_quickattack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("atk")  
            if inst:HasTag("sayaka_dark")then             
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
            else
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")
            end
            
            if inst.components.combat.target then
                inst.components.combat:BattleCry()
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.components.locomotor:Stop()
            
        end,

        onupdate = function(inst)
            if not inst.components.combat:InCooldown() and inst.sg.timeinstate and inst.sg.timeinstate > 10/30 then
                inst.sg:RemoveStateTag('busy')
                inst.sg:RemoveStateTag('attack')
            end
        end,
        
        timeline=
        {
            TimeEvent(9*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),
            --TimeEvent(11*FRAMES, function(inst) 
            --    inst.sg:RemoveStateTag("busy")
            --end),               
            --TimeEvent(11*FRAMES, function(inst)
            --    inst.sg:RemoveStateTag("attack")
            --end),                
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    } 

    ACTIONS.SAYAKA_LUNGE = {
        id = 'SAYAKA_LUNGE',
        str = PUELLA_MOD_SETTINGS.LANGUAGE and 'Lunge' or '瞬闪',
        mount_enabled = false,
        priority = 0,--@--
        instant = true,
        distance = 100,
        crosseswaterboundary = false,
        
        fn = function(act)
            act.pos = act.pos or (act.target and act.target:GetPosition())
            act.doer:PushEvent('sayaka_lunge',{pos = act.pos})
        end,
    }
    STRINGS.ACTIONS['SAYAKA_LUNGE'] = ACTIONS.SAYAKA_LUNGE.str

    inst.sg.sg.events.sayaka_lunge = EventHandler('sayaka_lunge', function(inst,data)
        if not inst.sg:HasStateTag('sayaka_lunge') and not inst.components.health:IsDead() and not inst.sg:HasStateTag('hit')
            and not (inst.components.driver and inst.components.driver.vehicle) then
            inst.sg:GoToState('sayaka_lunge',data.pos)
        end
    end)

    inst.sg.sg.states.sayaka_lunge = 
    State{
        name = 'sayaka_lunge',
        tags = {'sayaka_lunge', 'busy', 'attack', 'notalking', 'canrotate', 'ignorehitstate'},

        onenter = function(inst, pos)
            inst.SoundEmitter:PlaySound('lw_sayaka/sfx/lunge', 0.6)
            inst.components.combat:SetTarget(nil)
            inst.components.playercontroller:Enable(false)
            inst.AnimState:PlayAnimation('lunge_pst')
            inst.AnimState:SetTime(5/30)
            inst:ForceFacePoint(pos)
            inst.components.skill_sayaka:OnLunge()
            inst.components.locomotor:Stop()
            inst.components.locomotor:EnableGroundSpeedMultiplier(false)
            inst.components.locomotor:SetBufferedAction(nil)
            inst.components.locomotor:Clear()
            local phy = inst.Physics
            phy:SetMotorVelOverride(25,0,0)
            phy:ClearCollisionMask()
            phy:SetCollisionGroup(COLLISION.CHARACTERS)

            if IsDLCEnabled(PORKLAND_DLC)then
                phy:CollidesWith(GetWorldCollision())
                phy:CollidesWith(GetWaterCollision())
                phy:CollidesWith(COLLISION.GROUND)
                phy:CollidesWith(COLLISION.OBSTACLES)
                --phy:CollidesWith(COLLISION.CHARACTERS)
                phy:CollidesWith(COLLISION.WAVES)
            else
                phy:CollidesWith(COLLISION.WORLD)
                phy:CollidesWith(COLLISION.OBSTACLES)
                --phy:CollidesWith(COLLISION.CHARACTERS)
                phy:CollidesWith(COLLISION.WAVES)
            end

            inst.components.motionshadowspawner:Start()
            inst:AddTag('sayaka_lunge')
            inst.sg:SetTimeout(8/30)
            inst.sg.statemem.hittarget = {}
        end,

        events = {EventHandler("animover", function(inst) inst.sg:GoToState('idle')end)},

        onupdate = function(inst)
            --print('lunge!'..GetTime())
            inst.Physics:SetMotorVelOverride(25,0,0) --我也不想啊...

            local x,y,z = inst:GetPosition():Get()
            local ents = TheSim:FindEntities(x,y,z,1.5,{'combat'},{'INLIMBO'})
            for _,v in pairs(ents)do
                if v ~= inst and v.components.health and not inst.sg.statemem.hittarget[v] then
                    inst.sg.statemem.hittarget[v] = true
                    v.components.combat:GetAttacked(inst,10)
                    if v:HasTag('bird') then --拿着个技能抓鸟有点op了
                        v:DoTaskInTime(0,function()
                            v.sg:RemoveStateTag('busy')
                            v:PushEvent("flyaway")
                        end)
                    end
                end
            end
        end,

        ontimeout = function(inst)
            inst.sg:GoToState('idle')
        end,

        onexit = function(inst)
            inst.components.playercontroller:Enable(true)
            inst.Physics:ClearMotorVelOverride()
            inst.components.locomotor:Stop()
            --inst.components.locomotor:SetBufferedAction(nil)
            inst.components.motionshadowspawner:End()
            inst:RemoveTag('sayaka_lunge')
            ChangeToCharacterPhysics(inst)
            --print('exit')
            --inst.sg:GoToState('idle')
        end,

    }
end

local function SetSayakaSG(inst)
    updateSG(inst)
    inst:ListenForEvent('pmmm: force update sg',updateSG)
    inst:ListenForEvent("dismountboat",updateSG)
    inst:ListenForEvent("mountboat",updateSG)
end

return SetSayakaSG
     