local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"

local Flash = Class(Widget, function(self, owner)
    self.owner = owner
    Widget._ctor(self, "Flash")
	self:SetClickable(true) --好像没啥实际作用

	self.white = self:AddChild(UIAnim())
    self.white:GetAnimState():SetBuild("puellaUI_flash")
    self.white:GetAnimState():SetBank("vig_shine")
    self.white:GetAnimState():PlayAnimation("anim", true)
    self.white:GetAnimState():SetMultColour(1,1,1,0)
    self.white:SetHAnchor(ANCHOR_MIDDLE)
    self.white:SetVAnchor(ANCHOR_MIDDLE)
    self.white:SetScaleMode(SCALEMODE_FIXEDSCREEN_NONDYNAMIC) --同vig
    self.white:SetClickable(true)
    self.white:Hide()

    self.blindtime = 0
    --self:StartUpdating()
    self.inst.entity:AddSoundEmitter()
end)
local uptime = 1/10
local downtime = 2

function Flash:SetBlind(time)
    if time then
        self.inst.SoundEmitter:PlaySound('lw_homura/flashbang/hit')
    end
    self.inst.SoundEmitter:PlaySound('lw_homura/flashbang/loop', "LOOP")
    self.inst.SoundEmitter:SetParameter('LOOP', 'intensity', 1)

	self.blindtime = math.max((time or uptime),self.blindtime) 
	self.white:SetClickable(true)
    self.white:Show()
	self:StartUpdating()
end

function Flash:OnUpdate(dt)
    if not IsPaused() then
	   self.blindtime = self.blindtime - dt
    end
	local alphadelta
	if self.blindtime < 0 then
		self.white:SetClickable(false)
		alphadelta = - FRAMES/downtime
	else
		alphadelta = FRAMES/uptime
	end
	local r,g,b,a = self.white:GetAnimState():GetMultColour()
	local targalpha = math.clamp(a + alphadelta,0,1)
	self.white:GetAnimState():SetMultColour(1,1,1,targalpha)
    self.inst.SoundEmitter:SetParameter('LOOP', 'intensity', self.blindtime < 0 and targalpha or 1)
    if targalpha == 0 then
        self:StopUpdating()
        self.white:Hide()
        self.inst.SoundEmitter:KillSound('LOOP')
    end
end

return Flash