local L = PUELLA_MOD_SETTINGS.LANGUAGE 
local CLICKABLE = PUELLA_MOD_SETTINGS.CLICKABLE
local ALPHABET = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",}

local KEY = PUELLA_MOD_SETTINGS.CHARGEKEY
	  KEY = ALPHABET[KEY - 96]
local chargehint1 = L and [[Transform (]]..KEY..[[)]] or "按 "..KEY.." 变身" --2~5
local chargehint2 = L and [[Stop transforming (]]..KEY..[[)]] or "按 "..KEY.." 解除" --2~5
							
--------------------------------------------------
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Text = require "widgets/text"
local Badge = require "widgets/badge"
local ImageButton = require "widgets/imagebutton"

local sg = Class(Widget, function(self, owner)


	Widget._ctor(self, "sg")

	self.owner = owner

	local ischarged = owner.components.magicalcharge.state > 1 

    self:SetPosition(0,60,0)

    self.mod = 1

	self.pulse = self:AddChild(UIAnim())--sg变化时发白或发黑
    self.pulse:GetAnimState():SetBank("pulse")
    self.pulse:GetAnimState():SetBuild("hunger_health_pulse")
    self.pulse:SetScale(1.1)
    self.pulse:SetPosition(0, 0, 0)

    self.warning = self:AddChild(UIAnim())--连续的发黑警告
    self.warning:GetAnimState():SetBank("pulse")
    self.warning:GetAnimState():SetBuild("hunger_health_pulse")
    self.warning:SetScale(1)
    self.warning:SetPosition(0, 0, 0)
    self.warning:Hide()

    local bank_build = self.owner.prefab:sub(1,1)== 'h' and "homura" or self.owner.prefab

    self.sg_uncharge = self:AddChild(UIAnim())--灵核1
	self.sg_uncharge:GetAnimState():SetBank(bank_build.."_sg_1")
	self.sg_uncharge:GetAnimState():SetBuild(bank_build.."_sg_1")
	self.sg_uncharge:SetPosition(0, 2, 0)

	self.sg_charge = self:AddChild(UIAnim())--灵核2
	self.sg_charge:GetAnimState():SetBank(bank_build.."_sg_2")
	self.sg_charge:GetAnimState():SetBuild(bank_build.."_sg_2")
	self.sg_charge:SetPosition(0, 2, 0)
	self.sg_charge:Hide()
	 if self.owner.components.magicalcharge.state > 1 then 
	 	self.sg_charge:Show() 
	 end

	self.pulse_charge = self:AddChild(UIAnim())--五毛变身特效
    self.pulse_charge:GetAnimState():SetBank("pulse")
    self.pulse_charge:GetAnimState():SetBuild("hunger_health_pulse")
    self.pulse_charge:SetScale(1.1)
    local tc = owner.themecolour
    self.pulse_charge:GetAnimState():SetMultColour(tc[1],tc[2],tc[3],.8)
    self.pulse_charge:SetPosition(0, 2, 0)

    self.glow = self:AddChild(UIAnim())
    self.glow:GetAnimState():SetBank("puellaUI_soulgem_glow")
    self.glow:GetAnimState():SetBuild("puellaUI_soulgem_glow")
    self.glow:GetAnimState():PlayAnimation("anim",true) --glow_pst
    self.glow:GetAnimState():SetMultColour(tc[1],tc[2],tc[3],.9)
    self.glow:SetPosition(0,2,0)
    self.glow:SetScale(.8)
    self.glow.SetDist = function (dist)
    	self.glow:GetAnimState():SetDeltaTimeMultiplier(50/dist)
    	local a = math.max(Remap(dist,20,90,.9,.3))
    	self.glow:GetAnimState():SetMultColour(tc[1],tc[2],tc[3],a)
    end

    self.cdfan = self:AddChild(UIAnim())--外圆环（没用）
    --self.cdfan:GetAnimState():SetBank("cd_indicator")
    --self.cdfan:GetAnimState():SetBuild("cd_indicator")
    self.cdfan:SetScale(.7)
    self.cdfan:SetPosition(-1, 0, 0)
    self.cdfan:Hide()
    if ischarged then 
    	self.cdfan:Show() 
    end
	---------------------------------------------------------------------------------
    self.num = self:AddChild(Text(BODYTEXTFONT, 33))--soulgem数值
    self.num:Hide()
	self.num:SetPosition(4, 0, 0)

    self.hint = self:AddChild(Text(BODYTEXTFONT,25,ischarged and chargehint2 or chargehint1))--变身提示
    self.hint:Hide()
    self.hint:SetPosition(0,-50,0)

    self.help = self:AddChild(Text(BODYTEXTFONT,25,""))--游戏提示
    self.help:SetPosition(0,-130,0)
    self.help:SetRegionSize(200, 200)
    --self.help:SetHAlign(ANCHOR_LEFT)
    self.help:SetVAlign(ANCHOR_TOP)
    self.help:EnableWordWrap( true )

    self.get_help = self:AddChild(Text(BODYTEXTFONT,25,""))--打开游戏提示的提示
    self.get_help:SetPosition(0,-130,0)

	self:StartUpdating()
	self.inst:ListenForEvent("soulgemdelta", function(inst, data)  self:SoulgemDelta(data)  end, self.owner)
	self.inst:ListenForEvent("charge", function (inst) self:OnCharge() end,self.owner)
	self.inst:ListenForEvent("uncharge",function (inst) self:OnUncharge() end,self.owner)

	self.help.count = 0
	self.get_help.count = 0
end)

function sg:BrowseHelp()
	if self.focus then
		self.help:Show()
		self.help.count = self.help.count + 1
		self.help:SetString(PUELLA_MOD_HELP:Get("HELP",self.help.count))
		self.hint:Hide()
		if self.hint.task1 then self.hint.task1:Cancel()  self.hint.task1 = nil end
    	if self.hint.task2 then self.hint.task2:Cancel()  self.hint.task2 = nil end
    	if self.get_help.task then self.get_help.task:Cancel() self.get_help.task = nil end
    	self.get_help:Hide()
    else
    	self.help.count = 0
	end
end

local function ShowNPC(self)
	self.get_help.task = self.inst:DoPeriodicTask(5,function()
		self.get_help.count = self.get_help.count+1
		--print("help!")
		self.get_help:SetString(PUELLA_MOD_HELP:Get("HELP_FOR_HELP",self.get_help.count))
	end)
end

function sg:OnGainFocus()
    Badge._base.OnGainFocus(self)
    if self.max then
    	self.max:Show()
    end
    self.num:Show()																--显示数值
    self.hint.task1 = self.inst:DoTaskInTime(2,function()self.hint:Show() end)	--显示变身键位提示
    self.hint.task2 = self.inst:DoTaskInTime(7,function()self.hint:Hide() end)	--隐藏变身键位提示 
    ShowNPC(self)	
end

function sg:OnLoseFocus()
    Badge._base.OnLoseFocus(self)
    if self.hint.task1 then self.hint.task1:Cancel()  self.hint.task1 = nil end
    if self.hint.task2 then self.hint.task2:Cancel()  self.hint.task2 = nil end
    if self.get_help.task then self.get_help.task:Cancel() self.get_help.task = nil end
    self:ScaleTo(self.mod*1,self.mod*1,0)
    if not self.always_on_status then
    	self.num:Hide()
    else
    	if self.max then
    		self.max:Hide()
    	end
    end
	self.hint:Hide()

    self.help:Hide()
    self.help.count = 0
    self.get_help:Hide()
    self.get_help.count = 0
end

function sg:OnControl(control, down)
	
	if not self:IsEnabled() or not self.focus then return end
	
	if control == CONTROL_ACCEPT then
		if down then
			TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/click_move")
			self:ScaleTo(self.mod*1,self.mod*.9,.1)
			self.down = true
		else
			if self.down then
				self.down = false
				self:ScaleTo(self.mod*.9,self.mod*1,.1)
				
				if CLICKABLE and self.help.count < 5 then
					self.owner.components.magicalcharge:OnTrigger()
				elseif self.help.count >= 5 then
					self:BrowseHelp()
				end
			end
		end
		return true
	end
end

function sg:PulseWhite()
    self.pulse:GetAnimState():SetMultColour(1,1,1,1)
	self.pulse:GetAnimState():PlayAnimation("pulse")
end

function sg:PulseBlack()
    self.pulse:GetAnimState():SetMultColour(0,0,0,1)
	self.pulse:GetAnimState():PlayAnimation("pulse")
end

function sg:StopWarning()
	if self.warning.shown then
		self.warning:Hide()
	end
end

function sg:StartWarning()
	if not self.warning.shown then
		self.warning:Show()
		self.warning:GetAnimState():SetMultColour(0,0,0,1)
		self.warning:GetAnimState():PlayAnimation("pulse", true)
	end
end

function sg:OnCharge() 
	self.hint:SetString(chargehint2)
	self.pulse_charge:GetAnimState():PlayAnimation("pulse")
	self.sg_charge:Show()
	self.cdfan:Show()
end

function sg:OnUncharge( )
	self.hint:SetString(chargehint1)
	self.sg_charge:Hide()
	self.pulse_charge:GetAnimState():PlayAnimation("pulse")
	self.cdfan:Hide()

end

function sg:SoulgemDelta(data)

	if  data.newpercent > .9 then
		self:StartWarning()
	else
		self:StopWarning()
	end
	
	if not data.overtime then
		if data.newpercent > data.oldpercent then
			self:PulseBlack()
			--TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
		elseif data.newpercent < data.oldpercent then
			--TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
			self:PulseWhite()
		end
	end
end

function sg:OnUpdate(dt)
	if self.owner.components.soulgem then
		local newnum =  self.owner.components.soulgem.current
		local newp = self.owner.components.soulgem:GetPercent()
		self.sg_uncharge:GetAnimState():SetPercent("anim", 1-newp)
		self.sg_charge:GetAnimState():SetPercent("anim", 1-newp)
		self.num:SetString(tostring(math.ceil(newnum) ).."\0" )
		local dist = self.owner.components.witchspawner:GetDist()
		if dist then
			self.glow:Show()
			self.glow.SetDist(dist)
		else
			self.glow:Hide()
		end
	else
		self:StopUpdating()
	end
end

return sg