local easing = require("easing")
local UIAnim = require("widgets/uianim")

----这玩意儿半年前写的, 我已经不记得都写了些啥了
local Behavior = {}

local TimeLine = Class(function(self,time,fn,param)
	self.time = time
	self.fn = fn
	self.param = param
end)

local function BesselRemap(time,t1,t2,p1,p2)
	local duration = t2-t1
	local t = time-t1
	local b = p1
	local c = p2-p1
	return easing.inOutQuad(t,b,c,duration)
end

local remap_method = 
{
	linear = function(time,t1,t2,p1,p2,overide)
		local Remap = Remap
		if overide then
			Remap = overide
		end
		-------------------------
		local param
		if type(p1)=='number' then
			param = Remap(time,t1,t2,p1,p2)
		elseif type(p1)=='table' then 
			if p1.Get then 						--Vector3
				param = Vector3(Remap(time,t1,t2,p1.x,p2.x),Remap(time,t1,t2,p1.y,p2.y),Remap(time,t1,t2,p1.z,p2.z))
			else								--只有数字元素的单层表
				for k,v in ipairs(p1)do 
					param[k] = Remap(time,t1,t2,p1[k],p2[k])
				end
			end
		end
		return param
	end,
}
remap_method.bessel = function(time,t1,t2,p1,p2)
	local override = BesselRemap
	return remap_method.linear(time,t1,t2,p1,p2,override)
end
--关键帧插值函数
local function AddBetweenKeyFrame(tl1,tl2,choose) --T1在T2之前
	local _table = {}
	local p1,t1 = tl1.param,tl1.time
	local p2,t2 = tl2.param,tl2.time
	local fn = tl1.fn
	local _remap = remap_method[choose]
	for time = t1+FRAMES,t2-FRAMES,FRAMES do
		if p1 and p2 then
			local param = _remap(time,t1,t2,p1,p2)
			table.insert(_table,TimeLine(time,fn,param))
		end
	end
	return _table
end

local BehaviorLine = Class(function(self,timeline,addkey)
	self.timeline = timeline

	if addkey then
		for i = 1,#self.timeline - 1 do
			local _table = AddBetweenKeyFrame(self.timeline[i],self.timeline[i+1],addkey)
			for _,v in ipairs(_table)do
				table.insert(self.timeline,v)
			end
		end
	end

	self.SetUp = function(self,inst,delay)
		delay = delay or 0
		for _,v in pairs(self.timeline or {})do
			local fn = function(inst)
				v.fn(inst,v.param)
			end
			inst:DoTaskInTime(delay+v.time,fn)
		end
	end
end)
-----self.timeline  _,v TimeLine类  /  Setup函数,传入inst,即可快速赋值

local Shine_Slow1 = function(a) 
	return BehaviorLine({
	TimeLine(0,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	TimeLine(1,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,0),
	TimeLine(2,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	TimeLine(3,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,0),
	TimeLine(4,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	},
	'bessel')
end
local Shine_Fast1 = function(a)
	return BehaviorLine({
	TimeLine(0,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	TimeLine(0.2,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,0),
	TimeLine(0.4,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	TimeLine(0.6,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,0),
	TimeLine(0.8,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	},
	'bessel')
end

-----淡入淡出
local FadeOut = function(t,a)
	return BehaviorLine({
	TimeLine(0,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	TimeLine(t,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,0),
	},
	'linear')
end

local FadeIn = function(t,a)
	return BehaviorLine({
	TimeLine(0,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,0),
	TimeLine(t,function(inst,p)inst.AnimState:SetMultColour(0,0,0,inst.alpha*p)end,a),
	},
	'linear')
end
function debugs()
	--print(GetTableSize(FadeOut.timeline))
end

local SetScale = function(s)
	return BehaviorLine({TimeLine(0,function(inst,p)inst.UITransform:SetScale(s,s,s)end,0)})
end

local RotateAtSpeed = function(s)
	local function uirotate(inst,angle)
		local ag = inst.UITransform:GetRotation()
		inst.UITransform:SetRotation(ag+angle)
	end
	return BehaviorLine({
	TimeLine(0,function(inst,p) uirotate(inst,s) end, 0),
	TimeLine(30,function(inst,p) uirotate(inst,s) end, 0),
	},
	'linear')
end

--local FadeIn 
--local Distort

------旋转，持续时间 > ui最大持续时间



----单图，旋转/缩放/失真/闪烁
local shadowsdata_normal = 
{
	griefseed1 = 
	{
		{ {SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),5}, },
		--{ {SetScale(0.3),0},{FadeIn(2,0.4),0},{Rotate_Fast_Clockwise,0},{EroseOut,10}},
	},
	soulgem = 
	{
		{ {SetScale(0.4)},{FadeIn(1,0.6)},{Shine_Slow1(0.6),0.6},{FadeOut(5,0.6),6},},
	},
	snake = 
	{
		{{SetScale(0.4)},{FadeIn(2,0.6)},{FadeOut(5,0.6),5},},
	},
	qb = 
	{
		{{SetScale(0.2)},{FadeIn(2,0.6)},{FadeOut(5,0.6),5},},
	},
	mouth = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),7},},
	},
	ink1 = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),5},},
	},
	ink2 = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),6},},
	},
	ink3 = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),7},},
	},
	ink4 = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),8},},
	},
	ink5 = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),9},},
	},
	ink6 = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),10},},
	},
	bottleman = 
	{
		{{SetScale(0.5)},{FadeIn(2,0.6)},{FadeOut(5,0.6),5},},
		{{SetScale(0.5)},{FadeIn(2,0.6)},{Shine_Fast1(0.6),4},{FadeOut(5,0.6),8},},
	},
}


local shadowsdata_special =
{
	kyouko = 
	{
		chain = 
		{
			{ { FadeIn(2,0.4),0 },{FadeOut,5},},
		},
	},
}

local function PickUpShadow(player)
	local shadowsdata
	do
		local num1 = GetTableSize(shadowsdata_normal)
		local num2 = GetTableSize(shadowsdata_special[player])
		local rate = num1/(num1+num2)
		if math.random() < rate then
			shadowsdata = shadowsdata_normal
		else
			shadowsdata = shadowsdata_special[player]
		end
	end

	local i = math.random()*GetTableSize(shadowsdata)
	for k,v in pairs(shadowsdata)do
		i = i - 1
		if i <= 0 then
			local ui = UIAnim()
			local anim = ui:GetAnimState()
			anim:SetBuild('puellaUI_sgdark');anim:SetBank('puellaUI_sgdark');
			anim:OverrideSymbol('item','puellaUI_sgdark_build',k)
			--anim:PlayAnimation('anim'..math.random(3),true)
			anim:PlayAnimation('anim1',true)

			local data = v[math.random(#v)]
			for _,vv in pairs(data)do
				local behav,delay = vv[1],vv[2]
				behav:SetUp(ui.inst,delay or 0)
			end
			return ui
		end
	end
end

local function Clear(ui)
	ui.inst:CancelAllPendingTasks()
	local fadeouttime = GetRandomMinMax(2,4)
	ui.inst:DoTaskInTime(fadeouttime+0.1,ui.inst.Remove)
	local r,g,b,a = ui.inst.AnimState:GetMultColour()
	FadeOut(fadeouttime,a).SetUp(ui.inst,0)
end

return 
{
	PickUpRandomShadow = PickUpShadow,
	Clear = Clear,
}
