local L = PUELLA_MOD_SETTINGS.LANGUAGE 
local CLICKABLE = PUELLA_MOD_SETTINGS.CLICKABLE
local ALPHABET = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",}

local KEY = ALPHABET[PUELLA_MOD_SETTINGS.SKILLKEY - 96]

local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Text = require "widgets/text"
local Badge = require "widgets/badge"
local Image = require "widgets/image"
local ImageButton = require "widgets/imagebutton"

local SKILL_kyouko = Class(Widget, function(self, owner)

	Widget._ctor(self, "SKILL_kyouko")
	self.owner = owner
	self.inst.entity:AddSoundEmitter()
	self.MOD = 1
    local ischarge = self.owner.components.magicalcharge.state == 3

	self.badge = self:AddChild(UIAnim())--技能图标
    self.badge:GetAnimState():SetBank("kyouko_icon")
    self.badge:GetAnimState():SetBuild("kyouko_icon")
    self.badge:GetAnimState():PlayAnimation("build")	
    self.badge.SetAlphaFn = function (a)
    	self.badge:GetAnimState():SetMultColour(1,1,1,a)
    end
    self.badge:SetScale(1)
    self.badge:SetPosition(0, 2, 0)
    if not ischarge then self.badge.SetAlphaFn(.3)end

    self.name = self:AddChild(Text(BODYTEXTFONT,25,L and "<Magical chain>" or "<心锁>"))--技能名字
    self.name:SetPosition(0,-50,0)
    self.name:Hide()

    self.text = self:AddChild(Text(BODYTEXTFONT,20,"")) ---cd数字/锁定/就绪
    self.text:SetPosition(0,-80,0)
    self.text:Hide()

    --self.cdfan = self:AddChild(UIAnim())  --cd图形
    --self.cdfan:SetPosition(0,2,0)
    --self.cdfan:GetAnimState():SetBank("cd_fan")
    --self.cdfan:GetAnimState():SetBuild("cd_fan")
    --self.cdfan.SetAlphaFn = function(a)
    --	self.cdfan:GetAnimState():SetMultColour(0,0,0,a)
    --end
    --self.cdfan:SetScale(.8)

    self.front = self:AddChild(UIAnim()) --增加判定面积（我也不知道出了什么情况，反正去掉这部分的话按钮手感很差）
    self.front:GetAnimState():SetBank("cd_fan")
    self.front:GetAnimState():SetBuild("cd_fan")
    self.front:GetAnimState():SetPercent("anim",.01)
    self.front:GetAnimState():SetMultColour(1,1,1,0)

    --self.locktext = self:AddChild(Text(BODYTEXTFONT,20,L and ES1 or CS1))
    --self.locktext:SetPosition(0,-100,0)
    --self.locktext:Hide()

    self.description = self:AddChild(Text(BODYTEXTFONT,20,L and "{Passive} Absorb deadly damage by magic." or "【被动】用魔法锁链吸收致命伤害。"))
    self.description:SetPosition(0,-110,0)

    self.timer = 5

	self:StartUpdating()
	self.inst:ListenForEvent("cooldown", function() self:OnCoolDown() end, owner)
	self.inst:ListenForEvent("skill_incd",function () self:ShowCD() end, owner) --还在冷却中
	self.inst:ListenForEvent("skill_locked",function () self:ShowCD() end, owner)
	self.inst:ListenForEvent("charge",function() self:OnCharge()end,owner)
	self.inst:ListenForEvent("uncharge",function() self:OnUncharge()end,owner)
end)

function SKILL_kyouko:OnGainFocus()  --显示技能名称，/ 未变身：显示变身提示 / 冷却完成：显示介绍  / 冷却中：显示CD
    SKILL_kyouko._base.OnGainFocus(self)
    self.name:Show()
    self.text:Show()
    self.description_task = self.inst:DoTaskInTime(2.5,function ()
    self.description:Show()
    end)
    self.timer = 2
end

function SKILL_kyouko:OnLoseFocus() -- 
	SKILL_kyouko._base.OnLoseFocus(self)
	self.name:Hide()
	self.text:Hide()
	if self.description_task then 
		self.description_task:Cancel()
	end
	self.description:Hide()
	--self.locktext:Hide()
	self:ScaleTo(self.MOD,self.MOD,0)
end

function SKILL_kyouko:OnControl(control, down)  -- 
	
	if not self:IsEnabled() or not self.focus then return end
	
	if control == CONTROL_ACCEPT then
		if down then
			self:ScaleTo(self.MOD,self.MOD*0.9,.1)
			self.down = true
			TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/click_move")
		elseif self.down then
			self:ScaleTo(self.MOD*0.9,self.MOD,.1)
			self.down = false
			self.owner.components.puella_keytrigger:OnStrike2()
		end
		return true
	end
end

function SKILL_kyouko:ShowCD()
	self.name:Show()
	self.text:Show()
	self.description:Show()
	self.timer = 5
end

function SKILL_kyouko:ShowChargeHint()
	if self.description_task then 
		self.description_task:Cancel()
	end
	self.name:Show()
	self.text:Show()
	self.description:Hide()
	--self.locktext:Show()
	self.timer = 5
end

function SKILL_kyouko:OnUncharge()
	self.badge.SetAlphaFn(.3)
	--self.cdfan.SetAlphaFn(.3)
end

function SKILL_kyouko:OnCharge()
	--self.locktext:Hide()
	self.badge.SetAlphaFn(1)
	--self.cdfan.SetAlphaFn(.5)
end

function SKILL_kyouko:OnCoolDown()
	--self.badge:GetAnimState():PlayAnimation("")--------
end

function SKILL_kyouko:OnUpdate(dt)
	if self.timer > 0 then
		self.timer = self.timer - dt 
	end

	if self.timer <= 0 then
		if not self.focus then
			self.name:Hide()
			self.text:Hide()
			self.description:Hide()
			--self.locktext:Hide()
		end
	end

	local function RemapColour(c1,c2,percent)
		local colour = {}
		for i = 1,4 do
			colour[i] = Lerp(c1[i],c2[i],percent)
		end
		return colour
	end

	local power,power_p = self.owner.components.skill_kyouko:GetLeftPower()
	local isactivated = self.owner.components.skill_kyouko:IsActivated()
	local isavailable = self.owner.components.skill_kyouko:IsAvailable()
	local islocked = self.owner.components.magicalcharge.state < 3
	power = power - math.mod(power,0.1)+0.1
	
	--self.cdfan:GetAnimState():SetPercent("anim",1- leftcd_p )
	if islocked then
		self.text:SetString(L and "Locked\n".."shield: "..power or "锁定\n".."护盾值："..power)
		self.text:SetColour(1,0,0,1)
		if self.timer  <= 0 and not self.focus then
			self.badge.SetAlphaFn(.1)
			--self.cdfan.SetAlphaFn(.2)
		else
			self.badge.SetAlphaFn(.3)
			--self.cdfan.SetAlphaFn(.3)
		end
	elseif not isavailable then
		self.text:SetString(L and "Locked\nNo magical power!"or "锁定\n魔力不足！")
		self.text:SetColour(1,0,0,1)
	elseif isactivated then
		self.text:SetString(L and "Activated\n".."shield: "..power or "已激活\n".."护盾值："..power)
		self.text:SetColour(RemapColour({1,0,0,1},{0,1,0,1},power_p))
	else 
		self.text:SetString(L and "Ready\n".."shield: "..power or "就绪\n".."护盾值："..power)
		self.text:SetColour(RemapColour({1,0,0,1},{0,1,0,1},power_p))
	end
end

return SKILL_kyouko