local L = PUELLA_MOD_SETTINGS.LANGUAGE 
local CLICKABLE = PUELLA_MOD_SETTINGS.CLICKABLE
local ALPHABET = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",}

local KEY = ALPHABET[PUELLA_MOD_SETTINGS.SKILLKEY - 96]

--------------------------------------
--   < 治愈之歌 >    
--       锁定       冷却中（12）  就绪
--    必须在变身       描述       描述
--    状态下，才            
--    能使用技能
--------------------------------------
local ES1 = "Transform to use\npowerful skill." --锁定提示
local CS1 = "必须在变身\n状态下，才\n能使用技能"


local string = L and 
{
	heal = {name="<Healing Song>",description="To heal yourself and\nyour reinforcements.\n"..[[(]]..KEY..[[)]],cd=30,},
	dark = {name="<Dark Song>",description="Release dark power",cd=500,},
}
or
{
	heal = {name="<治愈之歌>",description="释放治愈光环, \n为你和你的队友\n恢复元气! ("..KEY..") ",cd=30,},
	dark = {name="<致郁之歌>",description="被动: 激发暗影能量, \n不顾一切, 疯狂战斗.\n(进攻和受伤时几率触发)",cd=500,},
}

local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Text = require "widgets/text"
local Badge = require "widgets/badge"

local SKILL_sayaka = Class(Widget, function(self, owner)

	Widget._ctor(self, "SKILL_sayaka")

	self.owner = owner

	local skillname = self.owner.components.skill_sayaka.skillname
    local ischarge = self.owner.components.magicalcharge.state == 3


	self.badge = self:AddChild(UIAnim())--技能图标
    self.badge:GetAnimState():SetBank("sayaka_icon")
    self.badge:GetAnimState():SetBuild("sayaka_icon")
    self.badge:GetAnimState():PlayAnimation( (skillname == 2) and "idle2" or "idle1")	
    self.badge.SetAlphaFn = function (a)
    	self.badge:GetAnimState():SetMultColour(1,1,1,a)
    end
    self.badge:SetScale(.98)
    self.badge:SetPosition(0, 2, 0)
    if not ischarge then self.badge.SetAlphaFn(.3)end
    
    self.name = self:AddChild(Text(BODYTEXTFONT,25,string[(skillname == 2)and"dark"or"heal"].name))--技能名字
    self.name:SetPosition(0,-50,0)
    self.name:Hide()

    self.text = self:AddChild(Text(BODYTEXTFONT,20,"")) ---cd数字/锁定/就绪
    self.text:SetPosition(0,-70,0)
    self.text:Hide()

    self.cdfan = self:AddChild(UIAnim())  --cd图形
    self.cdfan:GetAnimState():SetBank("cd_fan")
    self.cdfan:GetAnimState():SetBuild("cd_fan")
    self.cdfan.SetColourFn = function(c,a)
    	if c then
    		self.cdfan:GetAnimState():SetMultColour(1,1,1,a)
    	else
    		self.cdfan:GetAnimState():SetMultColour(0,0,0,a)
    	end
    end
    self.cdfan:SetScale(.8)

    self.cdflash = self.cdfan:AddChild(UIAnim())
    self.cdflash:SetPosition(0,0)
    self.cdflash:SetScale(0.4)
    self.cdflash:GetAnimState():SetBank("cdflash")
    self.cdflash:GetAnimState():SetBuild("cdflash")
    self.cdflash:GetAnimState():SetDeltaTimeMultiplier(3)
    self.cdflash.inst:ListenForEvent('animover',function()self.cdflash:Hide()end)

    self.locktext = self:AddChild(Text(BODYTEXTFONT,20,L and ES1 or CS1))
    self.locktext:SetPosition(0,-100,0)
    self.locktext:Hide()

    self.description = self:AddChild(Text(BODYTEXTFONT,20,string.heal.description))
    if skillname == 2 then self.description:SetString(string.dark.description)end
    self.description:SetPosition(0,-100,0)

    self.timer = 5

	self:StartUpdating()
	self.inst:ListenForEvent("cooldown", function() self:OnCoolDown() end,self.owner)

	self.inst:ListenForEvent("sayaka: undateskill",function (i,data) self:OnChangeSkill(data) end,self.owner)  --刷新技能图标
	self.inst:ListenForEvent("charge",function() self:OnCharge()end,owner)
	self.inst:ListenForEvent("uncharge",function() self:OnUncharge()end,owner)

	owner.components.puella_keytrigger.afterstrike2 = function(result)
		if result == 'LOCK' then
			self:ShowChargeHint()
		elseif result == 'CD' then
			self:ShowCD()
		elseif result == 'ACTIVATE' then
			self:ShowCD()
		elseif result == 'PASSIVE' then
			self:ShowPassiveSkillHint()
		end
	end

	owner.components.skill_sayaka.onstartdark = function()
		self:OnStartDark()
	end
	owner.components.skill_sayaka.onenddark = function()
		self:OnEndDark()
	end
end)


function SKILL_sayaka:OnGainFocus()  --显示技能名称，/ 未变身：显示变身提示 / 冷却完成：显示介绍  / 冷却中：显示CD
    SKILL_sayaka._base.OnGainFocus(self)
    self.name:Show()
    self.text:Show()
    self.description_task = self.inst:DoTaskInTime(2.5,function ()
    self.description:Show()
    end)
    self.timer = 2
end

function SKILL_sayaka:OnLoseFocus() -- 
	SKILL_sayaka._base.OnLoseFocus(self)
	self:ScaleTo(1,1,0)
	self.name:Hide()
	self.text:Hide()
	if self.description_task then 
		self.description_task:Cancel()
	end
	self.description:Hide()
	self.locktext:Hide()
end

function SKILL_sayaka:OnControl(control, down)  -- 
	
	if not self:IsEnabled() or not self.focus then return end
	
	if control == CONTROL_ACCEPT then
		if down then
			TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/click_move")
			self:ScaleTo(1, 0.9, 1/15)
			self.down = true
		elseif self.down then
			self.down = false
			self:ScaleTo(0.9, 1, 1/15)
			self.owner.components.puella_keytrigger:OnStrike2()	
		end
		return true
	end
end

function SKILL_sayaka:ShowCD( )
	self.name:Show()
	self.text:Show()
	self.timer = 5
end

function SKILL_sayaka:ShowChargeHint()
	if self.description_task then 
		self.description_task:Cancel()
	end
	self.name:Show()
	self.text:Show()
	self.description:Hide()
	self.locktext:Show()
	self.timer = 5
end

function SKILL_sayaka:ShowPassiveSkillHint()
	self.name:Show()
	self.text:Show()
	self.description:Show()
	self.timer = 5
end

function SKILL_sayaka:OnUncharge()
	self.badge.SetAlphaFn(.3)
	local skillname = self.owner.components.skill_sayaka.skillname
	if skillname and skillname == 1 then
		self.cdfan.SetColourFn(false,.3)
	else
		self.cdfan.SetColourFn(true,.3)
	end
end

function SKILL_sayaka:OnCharge()
	self.locktext:Hide()
	self.badge.SetAlphaFn(1)
	local skillname = self.owner.components.skill_sayaka.skillname
	if skillname and skillname == 1 then
		self.cdfan.SetColourFn(false,.5)
	else
		self.cdfan.SetColourFn(true,.5)
	end
end

function SKILL_sayaka:OnChangeSkill(num)
	if num == 1 then
		self.name:SetString(string.heal.name)
		self.description:SetString(string.heal.description)
		self.cdfan:Hide()
		self.cdfan.SetColourFn(false,.5)
		self.badge:GetAnimState():PlayAnimation("to1")
		self.badge:GetAnimState():PushAnimation("idle1",false)

		self.inst:DoTaskInTime(.3,function()self.cdfan:Show()end)		
	else
		self.name:SetString(string.dark.name)
		self.description:SetString(string.dark.description)
		self.cdfan:Hide()
		self.cdfan.SetColourFn(true,.5)
		self.badge:GetAnimState():PlayAnimation("to2")
		self.badge:GetAnimState():PushAnimation("idle2",false)
		
		self.inst:DoTaskInTime(.3,function()self.cdfan:Show()end)
	end
end

function SKILL_sayaka:OnCoolDown()
	self.cdflash:Show()
	self.cdflash:GetAnimState():PlayAnimation("anim")
end

function SKILL_sayaka:OnStartDark()
	if self.badge.pop then return end
	self.badge.pop = self.inst:DoPeriodicTask(1,function()
		self.badge:GetAnimState():PlayAnimation('idle2_pop')
		self.badge:GetAnimState():PushAnimation('idle2',false)
	end, 0.4)
end

function SKILL_sayaka:OnEndDark()
	if self.badge.pop then
		self.badge.pop:Cancel()
		self.badge.pop = nil
	end
end

function SKILL_sayaka:OnUpdate(dt)
	if self.timer > 0 then
		self.timer = self.timer - dt 
	end

	if self.timer <= 0 then
		if not self.focus then
			self.name:Hide()
			self.text:Hide()
			self.description:Hide()
			self.locktext:Hide()
		end
	end

	local leftcd,p,leftdarkduration,p2 = self.owner.components.skill_sayaka:GetLeftTime()
	local iscd = (leftcd > 0)
	local islocked = self.owner.components.magicalcharge.state < 3
	local isdarkmode = leftdarkduration ~= nil
	local isactivated = leftdarkduration and leftdarkduration > 0
	
	self.cdfan:GetAnimState():SetPercent("anim",1-p)

	if islocked then
		self.text:SetString(L and "Locked" or "锁定")
		self.text:SetColour(1,0,0,1)
		if self.timer <= 0 and not self.focus then
			self.badge.SetAlphaFn(.1)
		else
			self.badge.SetAlphaFn(.3)
		end
	elseif iscd then
		self.text:SetString( (L and "Cooling down (" or "冷却中 (") .. math.ceil(leftcd) ..")")
		if isdarkmode then
			self.text:SetColour(1,1,1,1)
		else
			self.text:SetColour(.5,.5,1,1)
		end
	elseif isactivated then
		self.text:SetString( (L and 'Activated (' or '使用中 (') .. math.ceil(leftdarkduration) .. ')')
		self.text:SetColour(1,1,1,1)
	else --就绪
		self.text:SetString(L and "Ready" or "就绪")
		self.text:SetColour(0,1,0,1)
	end
end

return SKILL_sayaka