local L = PUELLA_MOD_SETTINGS.LANGUAGE 
local CLICKABLE = PUELLA_MOD_SETTINGS.CLICKABLE
local ALPHABET = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",}

local KEY = ALPHABET[PUELLA_MOD_SETTINGS.SKILLKEY - 96]

local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Text = require "widgets/text"
local Badge = require "widgets/badge"

local ES1 = "Transform to use\npowerful skill." --锁定提示
local CS1 = "必须在变身\n状态下，才\n能使用技能"

local SKILL_homura = Class(Widget, function(self, owner)

	Widget._ctor(self, "SKILL_homura")
	self.owner = owner
	self.inst.entity:AddSoundEmitter()
	self.MOD = 1
    local ischarge = self.owner.components.magicalcharge.state == 3

	self.badge = self:AddChild(UIAnim())--技能图标
    self.badge:GetAnimState():SetBank("homura_icon")
    self.badge:GetAnimState():SetBuild("homura_icon")
    self.badge:GetAnimState():PlayAnimation("idle")	
    self.badge.SetAlphaFn = function (a)
    	self.badge:GetAnimState():SetMultColour(1,1,1,a)
    end
    self.badge:SetScale(.25)
    self.badge:SetPosition(-1, 3, 0)
    if not ischarge then self.badge.SetAlphaFn(.3)end

    self.name = self:AddChild(Text(BODYTEXTFONT,25,L and "<Time magic>" or "<时间暂停>"))--技能名字
    self.name:SetPosition(0,-50,0)
    self.name:Hide()

    self.text = self:AddChild(Text(BODYTEXTFONT,20,"")) ---cd数字/锁定/就绪
    self.text:SetPosition(0,-70,0)
    self.text:Hide()

    self.cdfan = self:AddChild(UIAnim())  --cd图形
    self.cdfan:SetPosition(0,2,0)
    self.cdfan:GetAnimState():SetBank("cd_fan")
    self.cdfan:GetAnimState():SetBuild("cd_fan")
    self.cdfan.SetAlphaFn = function(a)
    	self.cdfan:GetAnimState():SetMultColour(0,0,0,a)
    end
    self.cdfan:SetScale(.8)

    self.cdflash = self.cdfan:AddChild(UIAnim())
    self.cdflash:SetPosition(0,1)
    self.cdflash:SetScale(0.48)
    self.cdflash:GetAnimState():SetBank("cdflash")
    self.cdflash:GetAnimState():SetBuild("cdflash")
    self.cdflash:GetAnimState():SetDeltaTimeMultiplier(3)
    self.cdflash.inst:ListenForEvent('animover',function()self.cdflash:Hide()end)

    self.front = self:AddChild(UIAnim()) --增加判定面积（我也不知道出了什么情况，反正去掉这部分的话按钮手感很差）
    self.front:GetAnimState():SetBank("cd_fan")
    self.front:GetAnimState():SetBuild("cd_fan")
    self.front:GetAnimState():SetPercent("anim",.01)
    self.front:GetAnimState():SetMultColour(1,1,1,0)

    self.locktext = self:AddChild(Text(BODYTEXTFONT,20,L and ES1 or CS1))
    self.locktext:SetPosition(0,-100,0)
    self.locktext:Hide()

    self.description = self:AddChild(Text(BODYTEXTFONT,20,L and "Temporarily freeze time. ("..KEY..")" or "暂时冻结时间流逝。（"..KEY.."）"))
    self.description:SetPosition(0,-100,0)

    self.timer = 5

	self:StartUpdating()
	self.inst:ListenForEvent("cooldown", function() self:OnCoolDown() end, owner)

	self.inst:ListenForEvent("charge",function() self:OnCharge()end,owner)
	self.inst:ListenForEvent("uncharge",function() self:OnUncharge()end,owner)

	self.inst:ListenForEvent('pause',function(i,vel)
		self.inst.SoundEmitter:SetParameter('TICK','intensity',vel and 0 or 0.8)
	end, GetWorld())

	owner.components.puella_keytrigger.afterstrike2 = function(result)
		if result == 'LOCK' then
			self:ShowChargeHint()
		elseif result == 'CD' then
			self:ShowCD()
		elseif result == 'ACTIVATE' then
			self:ShowCD()
		end
	end

	--组件接口
	local skill = owner.components.skill_homura
	skill.ongetready = function() self:OnTry() end --进入前摇
	skill.oninterrupt = function() self:OnAttacked() end --打断前摇
	skill.onstarttp = function() self:OnStart() end --技能开始
	skill.onendtp = function() self:OnEnd() end --技能结束
end)

function SKILL_homura:OnGainFocus()  --显示技能名称，/ 未变身：显示变身提示 / 冷却完成：显示介绍  / 冷却中：显示CD
    SKILL_homura._base.OnGainFocus(self)
    self.name:Show()
    self.text:Show()
    self.description_task = self.inst:DoTaskInTime(2.5,function ()
    self.description:Show()
    end)
    self.timer = 2
end

function SKILL_homura:OnLoseFocus() 
	SKILL_homura._base.OnLoseFocus(self)
	self.name:Hide()
	self.text:Hide()
	if self.description_task then 
		self.description_task:Cancel()
	end
	self.description:Hide()
	self.locktext:Hide()
	self:ScaleTo(1, 1, 0)
end

function SKILL_homura:OnControl(control, down) 
	
	if not self:IsEnabled() or not self.focus then return end
	
	if control == CONTROL_ACCEPT then
		if down then
			self:ScaleTo(1,0.9,1/15)
			self.down = true
			TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/click_move")
		elseif self.down then
			self:ScaleTo(0.9,1,1/15)
			self.down = false
			self.owner.components.puella_keytrigger:OnStrike2()	
		end
		return true
	end
end

function SKILL_homura:ShowCD()
	self.name:Show()
	self.text:Show()
	self.timer = 5
end

function SKILL_homura:ShowChargeHint()
	if self.description_task then 
		self.description_task:Cancel()
	end
	self.name:Show()
	self.text:Show()
	self.description:Hide()
	self.locktext:Show()
	self.timer = 5
end

function SKILL_homura:OnUncharge()
	self.badge.SetAlphaFn(.3)
	self.cdfan.SetAlphaFn(.3)
end

function SKILL_homura:OnCharge()
	self.locktext:Hide()
	self.badge.SetAlphaFn(1)
	self.cdfan.SetAlphaFn(.5)
end

function SKILL_homura:OnTry( )
	self.badge:GetAnimState():PlayAnimation("enter")
end

function SKILL_homura:OnStart()
	self.badge:GetAnimState():PushAnimation("run",true)
	self.inst.SoundEmitter:PlaySound("lw_homura/tp/start","tp1",.2)
	self.inst.SoundEmitter:PlaySound("lw_homura/tp/tick","TICK",.4)
	self.inst.SoundEmitter:SetParameter('TICK','intensity',.8)
end

function SKILL_homura:OnAttacked( )
	self.badge:GetAnimState():PlayAnimation("idle")
end

function SKILL_homura:OnEnd()
	self.badge:GetAnimState():PlayAnimation("end")
	self.badge:GetAnimState():PushAnimation("idle",false)
	self.inst.SoundEmitter:KillSound("TICK")
	self.inst.SoundEmitter:PlaySound("lw_homura/tp/end","tp2",.2)
end

function SKILL_homura:OnCoolDown()
	self.cdflash:Show()
	self.cdflash:GetAnimState():PlayAnimation("anim")
end

function SKILL_homura:OnUpdate(dt)
	if self.timer > 0 then
		self.timer = self.timer - dt 
	end

	if self.timer <= 0 then
		if not self.focus then
			self.name:Hide()
			self.text:Hide()
			self.description:Hide()
			self.locktext:Hide()
		end
	end

	local leftcd,leftcd_p,lefttime,left_ready_time = self.owner.components.skill_homura:GetLeft()
	local iscd = (leftcd > 0)
	local isactivated = (lefttime >0 )
	local islocked = self.owner.components.magicalcharge.state < 3
	self.cdfan:GetAnimState():SetPercent("anim",1- leftcd_p )
	if islocked then
		self.text:SetString(L and "Locked" or "锁定")
		self.text:SetColour(1,0,0,1)
		if self.timer  <= 0 and not self.focus then
			self.badge.SetAlphaFn(.1)
			self.cdfan.SetAlphaFn(.2)
		else
			self.badge.SetAlphaFn(.3)
			self.cdfan.SetAlphaFn(.3)
		end
	elseif isactivated then
		self.text:SetString( (L and "Activated ("or "使用中 (") ..math.ceil(lefttime) ..")")
		self.text:SetColour(0,1,0,1)
	elseif iscd then
		self.text:SetString( (L and "Cooling down (" or "冷却中 (") .. math.ceil(leftcd) ..")")
		self.text:SetColour(147/255,120/255,193/255,1)
	else 
		self.text:SetString(L and "Ready" or "就绪")
		self.text:SetColour(0,1,0,1)
	end
end

return SKILL_homura